// $ANTLR 3.4 /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g 2012-04-10 16:33:46

/*
 * Copyright 2010 Spolecne s.r.o. (www.spoledge.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.spoledge.audao.parser.gql.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import com.google.appengine.api.datastore.GeoPt;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.Query;

import com.google.appengine.api.users.User;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import static com.spoledge.audao.parser.gql.impl.ParserUtils.*;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked"})
public class GqlDynamicParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "A", "ANCESTOR", "AND", "ASC", "B", "BY", "C", "D", "DATE", "DATETIME", "DESC", "E", "EQ", "EXPONENT", "F", "FALSE", "FLOAT", "FROM", "G", "GEOPT", "H", "HEX_DIGIT", "I", "ID", "IN", "INT", "IS", "J", "K", "KEY", "KEYPROP", "L", "LIMIT", "M", "MINUS", "N", "NULL", "O", "OFFSET", "OPER", "ORDER", "P", "PLUS", "Q", "R", "S", "SELECT", "STRING", "T", "TIME", "TRUE", "U", "USER", "V", "VARID", "VARNAME", "W", "WHERE", "WS", "X", "Y", "Z", "'('", "')'", "'*'", "','", "'.'"
    };

    public static final int EOF=-1;
    public static final int T__66=66;
    public static final int T__67=67;
    public static final int T__68=68;
    public static final int T__69=69;
    public static final int T__70=70;
    public static final int A=4;
    public static final int ANCESTOR=5;
    public static final int AND=6;
    public static final int ASC=7;
    public static final int B=8;
    public static final int BY=9;
    public static final int C=10;
    public static final int D=11;
    public static final int DATE=12;
    public static final int DATETIME=13;
    public static final int DESC=14;
    public static final int E=15;
    public static final int EQ=16;
    public static final int EXPONENT=17;
    public static final int F=18;
    public static final int FALSE=19;
    public static final int FLOAT=20;
    public static final int FROM=21;
    public static final int G=22;
    public static final int GEOPT=23;
    public static final int H=24;
    public static final int HEX_DIGIT=25;
    public static final int I=26;
    public static final int ID=27;
    public static final int IN=28;
    public static final int INT=29;
    public static final int IS=30;
    public static final int J=31;
    public static final int K=32;
    public static final int KEY=33;
    public static final int KEYPROP=34;
    public static final int L=35;
    public static final int LIMIT=36;
    public static final int M=37;
    public static final int MINUS=38;
    public static final int N=39;
    public static final int NULL=40;
    public static final int O=41;
    public static final int OFFSET=42;
    public static final int OPER=43;
    public static final int ORDER=44;
    public static final int P=45;
    public static final int PLUS=46;
    public static final int Q=47;
    public static final int R=48;
    public static final int S=49;
    public static final int SELECT=50;
    public static final int STRING=51;
    public static final int T=52;
    public static final int TIME=53;
    public static final int TRUE=54;
    public static final int U=55;
    public static final int USER=56;
    public static final int V=57;
    public static final int VARID=58;
    public static final int VARNAME=59;
    public static final int W=60;
    public static final int WHERE=61;
    public static final int WS=62;
    public static final int X=63;
    public static final int Y=64;
    public static final int Z=65;

    // delegates
    public Parser[] getDelegates() {
        return new Parser[] {};
    }

    // delegators


    public GqlDynamicParser(TokenStream input) {
        this(input, new RecognizerSharedState());
    }
    public GqlDynamicParser(TokenStream input, RecognizerSharedState state) {
        super(input, state);
    }

    public String[] getTokenNames() { return GqlDynamicParser.tokenNames; }
    public String getGrammarFileName() { return "/Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g"; }


        private static final HashMap<String, Query.FilterOperator> OPERANDS = new HashMap<String, Query.FilterOperator>();

        static {
            OPERANDS.put( "=", Query.FilterOperator.EQUAL );
            OPERANDS.put( ">", Query.FilterOperator.GREATER_THAN );
            OPERANDS.put( ">=", Query.FilterOperator.GREATER_THAN_OR_EQUAL );
            OPERANDS.put( "<", Query.FilterOperator.LESS_THAN );
            OPERANDS.put( "<=", Query.FilterOperator.LESS_THAN_OR_EQUAL );
            OPERANDS.put( "!=", Query.FilterOperator.NOT_EQUAL );
            OPERANDS.put( "IN", Query.FilterOperator.IN );
        }

        /**
         * The logger.
         */
        private Log log = LogFactory.getLog( getClass());

        private Query query;
        private Object[] args;
        private RecognitionException firstError;
        private Integer offset;
        private Integer limit;
        private boolean multipleQueries;
        private boolean keysOnly;


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods
        ////////////////////////////////////////////////////////////////////////////

        @Override
        public void reportError(RecognitionException e) {
            if (firstError == null) firstError = e;
            super.reportError( e );
        }


        /**
         * Returns the offset of the GQL query.
         */
        public Integer getOffset() {
            return offset;
        }


        /**
         * Returns the limit of the GQL query.
         */
        public Integer getLimit() {
            return limit;
        }


        /**
         * Returns true iff the last query was a multiple query ("!=" or "IN" operators).
         */
        public boolean wasMultipleQueries() {
            return multipleQueries;
        }


        /**
         * Returns true iff the last query returns keys only.
         */
        public boolean wasKeysOnly() {
            return keysOnly;
        }


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods - private
        ////////////////////////////////////////////////////////////////////////////

        private Object arg(int pos) {
            if (args == null) {
                // when passing 'null' - it is treated as (Object[])
                if (pos == 1) return null;
            }
            else if (pos <= args.length) return args[ pos - 1 ];

            log.error("arg(): no such parameter ':" + pos + "'");

            throw new RuntimeException("No such parameter ':" + pos + "'");
        }


        ////////////////////////////////////////////////////////////////////////////
        // Dynamically generated methods
        ////////////////////////////////////////////////////////////////////////////



    // $ANTLR start "gql"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:170:1: gql[Object[] args] returns [Query value] : SELECT ( '*' |iskey= KEYPROP ) FROM kind ( where )? ( orderby )? ( limit )? ( offset )? ;
    public final Query gql(Object[] args) throws RecognitionException {
        Query value = null;


        Token iskey=null;
        String kind1 =null;



            this.args = args;
            firstError = null;
            offset = limit = null;
            multipleQueries = false;
            keysOnly = false;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:178:5: ( SELECT ( '*' |iskey= KEYPROP ) FROM kind ( where )? ( orderby )? ( limit )? ( offset )? )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:179:5: SELECT ( '*' |iskey= KEYPROP ) FROM kind ( where )? ( orderby )? ( limit )? ( offset )?
            {
            match(input,SELECT,FOLLOW_SELECT_in_gql56); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:179:12: ( '*' |iskey= KEYPROP )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==68) ) {
                alt1=1;
            }
            else if ( (LA1_0==KEYPROP) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;

            }
            switch (alt1) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:179:13: '*'
                    {
                    match(input,68,FOLLOW_68_in_gql59); 

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:179:17: iskey= KEYPROP
                    {
                    iskey=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_gql63); 

                    }
                    break;

            }


            match(input,FROM,FOLLOW_FROM_in_gql66); 

            pushFollow(FOLLOW_kind_in_gql68);
            kind1=kind();

            state._fsp--;



                    query = new Query( kind1 );
                    if (iskey != null) keysOnly = true;
                

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:5: ( where )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==WHERE) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:5: where
                    {
                    pushFollow(FOLLOW_where_in_gql76);
                    where();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:12: ( orderby )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==ORDER) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:12: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql79);
                    orderby();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:21: ( limit )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==LIMIT) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:21: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql82);
                    limit();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:28: ( offset )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==OFFSET) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:183:28: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql85);
                    offset();

                    state._fsp--;


                    }
                    break;

            }



                    value = query;
                    if (keysOnly && !multipleQueries) query.setKeysOnly();
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving

                    if (getNumberOfSyntaxErrors() != 0) throw firstError;
                
        }
        return value;
    }
    // $ANTLR end "gql"



    // $ANTLR start "gqlcond"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:193:1: gqlcond[Query query, Object[] args] returns [Query value] : conditions ( orderby )? ;
    public final Query gqlcond(Query query, Object[] args) throws RecognitionException {
        Query value = null;



            this.query = query != null ? query : new Query();
            this.args = args;
            firstError = null;
            offset = limit = null;
            multipleQueries = false;
            keysOnly = false;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:202:5: ( conditions ( orderby )? )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:203:5: conditions ( orderby )?
            {
            pushFollow(FOLLOW_conditions_in_gqlcond126);
            conditions();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:203:16: ( orderby )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==ORDER) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:203:16: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gqlcond128);
                    orderby();

                    state._fsp--;


                    }
                    break;

            }



                    value = query;
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving

                    if (getNumberOfSyntaxErrors() != 0) throw firstError;
                
        }
        return value;
    }
    // $ANTLR end "gqlcond"



    // $ANTLR start "where"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:212:1: where : WHERE conditions ;
    public final void where() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:212:6: ( WHERE conditions )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:212:8: WHERE conditions
            {
            match(input,WHERE,FOLLOW_WHERE_in_where152); 

            pushFollow(FOLLOW_conditions_in_where154);
            conditions();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "where"



    // $ANTLR start "conditions"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:214:1: conditions : condition ( AND condition )* ;
    public final void conditions() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:214:11: ( condition ( AND condition )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:214:13: condition ( AND condition )*
            {
            pushFollow(FOLLOW_condition_in_conditions161);
            condition();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:214:23: ( AND condition )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==AND) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:214:24: AND condition
            	    {
            	    match(input,AND,FOLLOW_AND_in_conditions164); 

            	    pushFollow(FOLLOW_condition_in_conditions166);
            	    condition();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "conditions"



    // $ANTLR start "condition"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:1: condition : ( cond | condkey | condancestor | condin | condkeyin );
    public final void condition() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:10: ( cond | condkey | condancestor | condin | condkeyin )
            int alt8=5;
            switch ( input.LA(1) ) {
            case ID:
                {
                int LA8_1 = input.LA(2);

                if ( (LA8_1==EQ||LA8_1==OPER) ) {
                    alt8=1;
                }
                else if ( (LA8_1==IN) ) {
                    alt8=4;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 1, input);

                    throw nvae;

                }
                }
                break;
            case STRING:
                {
                int LA8_2 = input.LA(2);

                if ( (LA8_2==EQ||LA8_2==OPER) ) {
                    alt8=1;
                }
                else if ( (LA8_2==IN) ) {
                    alt8=4;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 2, input);

                    throw nvae;

                }
                }
                break;
            case KEYPROP:
                {
                int LA8_3 = input.LA(2);

                if ( (LA8_3==IN) ) {
                    alt8=5;
                }
                else if ( (LA8_3==EQ||LA8_3==OPER) ) {
                    alt8=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 3, input);

                    throw nvae;

                }
                }
                break;
            case ANCESTOR:
                {
                alt8=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;

            }

            switch (alt8) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:12: cond
                    {
                    pushFollow(FOLLOW_cond_in_condition176);
                    cond();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:19: condkey
                    {
                    pushFollow(FOLLOW_condkey_in_condition180);
                    condkey();

                    state._fsp--;


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:29: condancestor
                    {
                    pushFollow(FOLLOW_condancestor_in_condition184);
                    condancestor();

                    state._fsp--;


                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:44: condin
                    {
                    pushFollow(FOLLOW_condin_in_condition188);
                    condin();

                    state._fsp--;


                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:217:53: condkeyin
                    {
                    pushFollow(FOLLOW_condkeyin_in_condition192);
                    condkeyin();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condition"



    // $ANTLR start "cond"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:220:1: cond : property oper vov= valorvarobj ;
    public final void cond() throws RecognitionException {
        Object vov =null;

        String oper2 =null;

        GqlDynamicParser.property_return property3 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:220:5: ( property oper vov= valorvarobj )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:221:5: property oper vov= valorvarobj
            {
            pushFollow(FOLLOW_property_in_cond204);
            property3=property();

            state._fsp--;


            pushFollow(FOLLOW_oper_in_cond206);
            oper2=oper();

            state._fsp--;


            pushFollow(FOLLOW_valorvarobj_in_cond210);
            vov=valorvarobj();

            state._fsp--;



                    Query.FilterOperator oper = OPERANDS.get( oper2 );

                    if (log.isDebugEnabled()) {
                        if (vov != null && (vov instanceof Collection)) {
                            Collection col = (Collection)vov;

                            if (col.size() == 0) {
                                log.debug("query.addFilter( \"" + (property3!=null?property3.value:null)
                                    + "\", Query.FilterOperator." + oper.name() + ", null)");
                            }
                            else {
                                for (Object o : ((Collection)vov)) {
                                    log.debug("query.addFilter( \"" + (property3!=null?property3.value:null)
                                        + "\", Query.FilterOperator." + oper.name() + ", "
                                        + (o != null ?
                                            o.getClass().getName() + '(' + o + ')'
                                            : "null") + ')');
                                }

                            }
                        }
                        else {
                            log.debug("query.addFilter( \"" + (property3!=null?property3.value:null)
                                + "\", Query.FilterOperator." + oper.name() + ", "
                                + (vov != null ?
                                    vov.getClass().getName() + '(' + vov + ')'
                                    : "null") + ')');
                        }
                    }

                    if (vov != null && (vov instanceof Collection)) {
                        Collection col = (Collection)vov;

                        if (col.size() == 0) {
                            query.addFilter( (property3!=null?property3.value:null), oper, null );
                        }
                        else {
                            for (Object o : col) {
                                query.addFilter( (property3!=null?property3.value:null), oper, o );
                            }
                        }
                    }
                    else query.addFilter( (property3!=null?property3.value:null), oper, vov );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "cond"



    // $ANTLR start "condkey"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:269:1: condkey : KEYPROP oper key ;
    public final void condkey() throws RecognitionException {
        Token KEYPROP4=null;
        String oper5 =null;

        Key key6 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:269:8: ( KEYPROP oper key )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:270:5: KEYPROP oper key
            {
            KEYPROP4=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkey229); 

            pushFollow(FOLLOW_oper_in_condkey231);
            oper5=oper();

            state._fsp--;


            pushFollow(FOLLOW_key_in_condkey233);
            key6=key();

            state._fsp--;



                    query.addFilter( (KEYPROP4!=null?KEYPROP4.getText():null), OPERANDS.get( oper5 ), key6 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condkey"



    // $ANTLR start "condancestor"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:276:1: condancestor : ANCESTOR IS key ;
    public final void condancestor() throws RecognitionException {
        Key key7 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:276:13: ( ANCESTOR IS key )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:277:5: ANCESTOR IS key
            {
            match(input,ANCESTOR,FOLLOW_ANCESTOR_in_condancestor252); 

            match(input,IS,FOLLOW_IS_in_condancestor254); 

            pushFollow(FOLLOW_key_in_condancestor256);
            key7=key();

            state._fsp--;



                    query.setAncestor( key7 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condancestor"



    // $ANTLR start "condin"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:283:1: condin : property IN ( ( '(' listitem[list] ( ',' listitem[list] )* ')' ) | var ) ;
    public final void condin() throws RecognitionException {
        GqlDynamicParser.property_return property8 =null;

        Object var9 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:283:7: ( property IN ( ( '(' listitem[list] ( ',' listitem[list] )* ')' ) | var ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:284:5: property IN ( ( '(' listitem[list] ( ',' listitem[list] )* ')' ) | var )
            {
            pushFollow(FOLLOW_property_in_condin275);
            property8=property();

            state._fsp--;


            match(input,IN,FOLLOW_IN_in_condin277); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:285:5: ( ( '(' listitem[list] ( ',' listitem[list] )* ')' ) | var )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==66) ) {
                alt10=1;
            }
            else if ( (LA10_0==VARID) ) {
                alt10=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;

            }
            switch (alt10) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:286:9: ( '(' listitem[list] ( ',' listitem[list] )* ')' )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:286:9: ( '(' listitem[list] ( ',' listitem[list] )* ')' )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:287:13: '(' listitem[list] ( ',' listitem[list] )* ')'
                    {
                    match(input,66,FOLLOW_66_in_condin307); 


                                    ArrayList list = new ArrayList();
                                

                    pushFollow(FOLLOW_listitem_in_condin323);
                    listitem(list);

                    state._fsp--;


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:290:28: ( ',' listitem[list] )*
                    loop9:
                    do {
                        int alt9=2;
                        int LA9_0 = input.LA(1);

                        if ( (LA9_0==69) ) {
                            alt9=1;
                        }


                        switch (alt9) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:290:29: ',' listitem[list]
                    	    {
                    	    match(input,69,FOLLOW_69_in_condin327); 

                    	    pushFollow(FOLLOW_listitem_in_condin329);
                    	    listitem(list);

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    break loop9;
                        }
                    } while (true);


                    match(input,67,FOLLOW_67_in_condin334); 


                                    query.addFilter( (property8!=null?input.toString(property8.start,property8.stop):null), Query.FilterOperator.IN, list );
                                

                    }


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:294:11: var
                    {
                    pushFollow(FOLLOW_var_in_condin358);
                    var9=var();

                    state._fsp--;



                                query.addFilter( (property8!=null?input.toString(property8.start,property8.stop):null), Query.FilterOperator.IN, var9 );
                            

                    }
                    break;

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condin"



    // $ANTLR start "condkeyin"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:301:1: condkeyin : KEYPROP IN ( ( '(' listitemkey[list] ( ',' listitemkey[list] )* ')' ) | var ) ;
    public final void condkeyin() throws RecognitionException {
        Token KEYPROP10=null;
        Object var11 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:301:10: ( KEYPROP IN ( ( '(' listitemkey[list] ( ',' listitemkey[list] )* ')' ) | var ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:302:5: KEYPROP IN ( ( '(' listitemkey[list] ( ',' listitemkey[list] )* ')' ) | var )
            {
            KEYPROP10=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkeyin383); 

            match(input,IN,FOLLOW_IN_in_condkeyin385); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:303:5: ( ( '(' listitemkey[list] ( ',' listitemkey[list] )* ')' ) | var )
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==66) ) {
                alt12=1;
            }
            else if ( (LA12_0==VARID) ) {
                alt12=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;

            }
            switch (alt12) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:304:9: ( '(' listitemkey[list] ( ',' listitemkey[list] )* ')' )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:304:9: ( '(' listitemkey[list] ( ',' listitemkey[list] )* ')' )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:305:13: '(' listitemkey[list] ( ',' listitemkey[list] )* ')'
                    {
                    match(input,66,FOLLOW_66_in_condkeyin415); 


                                    ArrayList<Key> list = new ArrayList<Key>();
                                

                    pushFollow(FOLLOW_listitemkey_in_condkeyin431);
                    listitemkey(list);

                    state._fsp--;


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:308:31: ( ',' listitemkey[list] )*
                    loop11:
                    do {
                        int alt11=2;
                        int LA11_0 = input.LA(1);

                        if ( (LA11_0==69) ) {
                            alt11=1;
                        }


                        switch (alt11) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:308:32: ',' listitemkey[list]
                    	    {
                    	    match(input,69,FOLLOW_69_in_condkeyin435); 

                    	    pushFollow(FOLLOW_listitemkey_in_condkeyin437);
                    	    listitemkey(list);

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    break loop11;
                        }
                    } while (true);


                    match(input,67,FOLLOW_67_in_condkeyin442); 


                                    query.addFilter( (KEYPROP10!=null?KEYPROP10.getText():null), Query.FilterOperator.IN, list );
                                

                    }


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:312:11: var
                    {
                    pushFollow(FOLLOW_var_in_condkeyin466);
                    var11=var();

                    state._fsp--;



                                query.addFilter( (KEYPROP10!=null?KEYPROP10.getText():null), Query.FilterOperator.IN, var11 );
                            

                    }
                    break;

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condkeyin"



    // $ANTLR start "oper"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:319:1: oper returns [String value] : ( EQ | OPER );
    public final String oper() throws RecognitionException {
        String value = null;


        Token EQ12=null;
        Token OPER13=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:319:27: ( EQ | OPER )
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==EQ) ) {
                alt13=1;
            }
            else if ( (LA13_0==OPER) ) {
                alt13=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;

            }
            switch (alt13) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:320:5: EQ
                    {
                    EQ12=(Token)match(input,EQ,FOLLOW_EQ_in_oper494); 


                            value = (EQ12!=null?EQ12.getText():null);
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:323:7: OPER
                    {
                    OPER13=(Token)match(input,OPER,FOLLOW_OPER_in_oper504); 


                            value = (OPER13!=null?OPER13.getText():null);
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "oper"



    // $ANTLR start "listitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:329:1: listitem[List list] : vov= valorvarobj ;
    public final void listitem(List list) throws RecognitionException {
        Object vov =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:329:20: (vov= valorvarobj )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:330:5: vov= valorvarobj
            {
            pushFollow(FOLLOW_valorvarobj_in_listitem526);
            vov=valorvarobj();

            state._fsp--;



                    list.add( vov );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "listitem"



    // $ANTLR start "listitemkey"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:336:1: listitemkey[List<Key> list] : key ;
    public final void listitemkey(List<Key> list) throws RecognitionException {
        Key key14 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:336:28: ( key )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:337:5: key
            {
            pushFollow(FOLLOW_key_in_listitemkey546);
            key14=key();

            state._fsp--;



                    list.add( key14 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "listitemkey"



    // $ANTLR start "key"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:343:1: key returns [Key value] : ( STRING | var | keyfunc );
    public final Key key() throws RecognitionException {
        Key value = null;


        Token STRING15=null;
        Object var16 =null;

        Key keyfunc17 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:343:23: ( STRING | var | keyfunc )
            int alt14=3;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt14=1;
                }
                break;
            case VARID:
                {
                alt14=2;
                }
                break;
            case KEY:
                {
                alt14=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;

            }

            switch (alt14) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:344:5: STRING
                    {
                    STRING15=(Token)match(input,STRING,FOLLOW_STRING_in_key568); 


                            value = KeyFactory.stringToKey( string( (STRING15!=null?STRING15.getText():null) ));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:347:7: var
                    {
                    pushFollow(FOLLOW_var_in_key578);
                    var16=var();

                    state._fsp--;



                            if (var16 instanceof Key) {
                                value = (Key) var16;
                            }
                            else {
                                value = KeyFactory.stringToKey( argString( var16 ));
                            }
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:355:7: keyfunc
                    {
                    pushFollow(FOLLOW_keyfunc_in_key588);
                    keyfunc17=keyfunc();

                    state._fsp--;



                            value = keyfunc17;
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "key"



    // $ANTLR start "keyfunc"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:361:1: keyfunc returns [Key value] : KEY '(' (vov= stringorvar | keypath ) ')' ;
    public final Key keyfunc() throws RecognitionException {
        Key value = null;


        String vov =null;

        KeyFactory.Builder keypath18 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:361:27: ( KEY '(' (vov= stringorvar | keypath ) ')' )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:362:5: KEY '(' (vov= stringorvar | keypath ) ')'
            {
            match(input,KEY,FOLLOW_KEY_in_keyfunc610); 

            match(input,66,FOLLOW_66_in_keyfunc612); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:363:5: (vov= stringorvar | keypath )
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==STRING) ) {
                int LA15_1 = input.LA(2);

                if ( (LA15_1==69) ) {
                    alt15=2;
                }
                else if ( (LA15_1==67) ) {
                    alt15=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 15, 1, input);

                    throw nvae;

                }
            }
            else if ( (LA15_0==VARID) ) {
                alt15=1;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 15, 0, input);

                throw nvae;

            }
            switch (alt15) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:364:9: vov= stringorvar
                    {
                    pushFollow(FOLLOW_stringorvar_in_keyfunc630);
                    vov=stringorvar();

                    state._fsp--;



                                value = KeyFactory.stringToKey( vov );
                            

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:367:11: keypath
                    {
                    pushFollow(FOLLOW_keypath_in_keyfunc644);
                    keypath18=keypath();

                    state._fsp--;



                                value = keypath18.getKey();
                            

                    }
                    break;

            }


            match(input,67,FOLLOW_67_in_keyfunc658); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "keyfunc"



    // $ANTLR start "keypath"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:375:1: keypath returns [KeyFactory.Builder value] : kin= STRING ',' (name= STRING |id= INT | var ) ( keypathchild[$value] )? ;
    public final KeyFactory.Builder keypath() throws RecognitionException {
        KeyFactory.Builder value = null;


        Token kin=null;
        Token name=null;
        Token id=null;
        Object var19 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:375:42: (kin= STRING ',' (name= STRING |id= INT | var ) ( keypathchild[$value] )? )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:376:5: kin= STRING ',' (name= STRING |id= INT | var ) ( keypathchild[$value] )?
            {
            kin=(Token)match(input,STRING,FOLLOW_STRING_in_keypath680); 

            match(input,69,FOLLOW_69_in_keypath682); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:377:5: (name= STRING |id= INT | var )
            int alt16=3;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt16=1;
                }
                break;
            case INT:
                {
                alt16=2;
                }
                break;
            case VARID:
                {
                alt16=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 16, 0, input);

                throw nvae;

            }

            switch (alt16) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:378:9: name= STRING
                    {
                    name=(Token)match(input,STRING,FOLLOW_STRING_in_keypath700); 


                                value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), string( (name!=null?name.getText():null) ));
                            

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:381:11: id= INT
                    {
                    id=(Token)match(input,INT,FOLLOW_INT_in_keypath716); 


                                value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), new Long( (id!=null?id.getText():null) ));
                            

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:384:11: var
                    {
                    pushFollow(FOLLOW_var_in_keypath730);
                    var19=var();

                    state._fsp--;



                                if (var19 instanceof Number) {
                                    value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), argLong( var19 ));
                                }
                                else {
                                    value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), argString( var19 ));
                                }
                            

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:393:5: ( keypathchild[$value] )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==69) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:393:5: keypathchild[$value]
                    {
                    pushFollow(FOLLOW_keypathchild_in_keypath744);
                    keypathchild(value);

                    state._fsp--;


                    }
                    break;

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "keypath"



    // $ANTLR start "keypathchild"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:397:1: keypathchild[KeyFactory.Builder builder] : ',' kin= STRING ',' (name= STRING |id= INT | var ) ( keypathchild[builder] )? ;
    public final void keypathchild(KeyFactory.Builder builder) throws RecognitionException {
        Token kin=null;
        Token name=null;
        Token id=null;
        Object var20 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:397:41: ( ',' kin= STRING ',' (name= STRING |id= INT | var ) ( keypathchild[builder] )? )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:398:5: ',' kin= STRING ',' (name= STRING |id= INT | var ) ( keypathchild[builder] )?
            {
            match(input,69,FOLLOW_69_in_keypathchild765); 

            kin=(Token)match(input,STRING,FOLLOW_STRING_in_keypathchild769); 

            match(input,69,FOLLOW_69_in_keypathchild771); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:399:5: (name= STRING |id= INT | var )
            int alt18=3;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt18=1;
                }
                break;
            case INT:
                {
                alt18=2;
                }
                break;
            case VARID:
                {
                alt18=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;

            }

            switch (alt18) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:400:9: name= STRING
                    {
                    name=(Token)match(input,STRING,FOLLOW_STRING_in_keypathchild789); 

                     builder.addChild( string( (kin!=null?kin.getText():null) ), string( (name!=null?name.getText():null) )); 

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:401:11: id= INT
                    {
                    id=(Token)match(input,INT,FOLLOW_INT_in_keypathchild805); 

                     builder.addChild( string( (kin!=null?kin.getText():null) ), new Long( (id!=null?id.getText():null) )); 

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:402:11: var
                    {
                    pushFollow(FOLLOW_var_in_keypathchild819);
                    var20=var();

                    state._fsp--;


                     builder.addChild( string( (kin!=null?kin.getText():null) ), argLong( var20 )); 

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:404:5: ( keypathchild[builder] )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==69) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:404:5: keypathchild[builder]
                    {
                    pushFollow(FOLLOW_keypathchild_in_keypathchild833);
                    keypathchild(builder);

                    state._fsp--;


                    }
                    break;

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "keypathchild"



    // $ANTLR start "orderby"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:408:1: orderby : ORDER BY orderbyitem ( ',' orderbyitem )* ;
    public final void orderby() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:408:8: ( ORDER BY orderbyitem ( ',' orderbyitem )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:408:10: ORDER BY orderbyitem ( ',' orderbyitem )*
            {
            match(input,ORDER,FOLLOW_ORDER_in_orderby849); 

            match(input,BY,FOLLOW_BY_in_orderby851); 

            pushFollow(FOLLOW_orderbyitem_in_orderby853);
            orderbyitem();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:408:31: ( ',' orderbyitem )*
            loop20:
            do {
                int alt20=2;
                int LA20_0 = input.LA(1);

                if ( (LA20_0==69) ) {
                    alt20=1;
                }


                switch (alt20) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:408:32: ',' orderbyitem
            	    {
            	    match(input,69,FOLLOW_69_in_orderby856); 

            	    pushFollow(FOLLOW_orderbyitem_in_orderby858);
            	    orderbyitem();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "orderby"



    // $ANTLR start "orderbyitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:411:1: orderbyitem : ( property | KEYPROP ) ( ( ASC )? |isdesc= DESC ) ;
    public final void orderbyitem() throws RecognitionException {
        Token isdesc=null;
        Token KEYPROP22=null;
        GqlDynamicParser.property_return property21 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:411:12: ( ( property | KEYPROP ) ( ( ASC )? |isdesc= DESC ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:412:5: ( property | KEYPROP ) ( ( ASC )? |isdesc= DESC )
            {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:412:5: ( property | KEYPROP )
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==ID||LA21_0==STRING) ) {
                alt21=1;
            }
            else if ( (LA21_0==KEYPROP) ) {
                alt21=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;

            }
            switch (alt21) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:413:9: property
                    {
                    pushFollow(FOLLOW_property_in_orderbyitem882);
                    property21=property();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:414:11: KEYPROP
                    {
                    KEYPROP22=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_orderbyitem894); 

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:416:5: ( ( ASC )? |isdesc= DESC )
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==EOF||LA23_0==ASC||LA23_0==LIMIT||LA23_0==OFFSET||LA23_0==69) ) {
                alt23=1;
            }
            else if ( (LA23_0==DESC) ) {
                alt23=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;

            }
            switch (alt23) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:417:9: ( ASC )?
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:417:9: ( ASC )?
                    int alt22=2;
                    int LA22_0 = input.LA(1);

                    if ( (LA22_0==ASC) ) {
                        alt22=1;
                    }
                    switch (alt22) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:417:9: ASC
                            {
                            match(input,ASC,FOLLOW_ASC_in_orderbyitem916); 

                            }
                            break;

                    }



                                query.addSort( (property21!=null?property21.value:null) != null ? (property21!=null?property21.value:null) : (KEYPROP22!=null?KEYPROP22.getText():null),
                                    Query.SortDirection.ASCENDING );
                            

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:421:11: isdesc= DESC
                    {
                    isdesc=(Token)match(input,DESC,FOLLOW_DESC_in_orderbyitem934); 


                                query.addSort( (property21!=null?property21.value:null) != null ? (property21!=null?property21.value:null) : (KEYPROP22!=null?KEYPROP22.getText():null),
                                    Query.SortDirection.DESCENDING );
                            

                    }
                    break;

            }



                    if (log.isDebugEnabled()) {
                        log.debug("query.addSort( \"" +  ((property21!=null?property21.value:null) != null ? (property21!=null?property21.value:null) : (KEYPROP22!=null?KEYPROP22.getText():null))
                            + "\", Query.SortDirection." + (isdesc != null ? "DESCENDING" : "ASCENDING") + " )");
                    }
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "orderbyitem"



    // $ANTLR start "limit"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:435:1: limit : LIMIT (off= INT ',' )? lim= INT ;
    public final void limit() throws RecognitionException {
        Token off=null;
        Token lim=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:435:6: ( LIMIT (off= INT ',' )? lim= INT )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:436:5: LIMIT (off= INT ',' )? lim= INT
            {
            match(input,LIMIT,FOLLOW_LIMIT_in_limit965); 

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:437:5: (off= INT ',' )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==INT) ) {
                int LA24_1 = input.LA(2);

                if ( (LA24_1==69) ) {
                    alt24=1;
                }
            }
            switch (alt24) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:438:9: off= INT ','
                    {
                    off=(Token)match(input,INT,FOLLOW_INT_in_limit983); 

                    match(input,69,FOLLOW_69_in_limit985); 


                                offset = new Integer( (off!=null?off.getText():null) );
                            

                    }
                    break;

            }


            lim=(Token)match(input,INT,FOLLOW_INT_in_limit1002); 


                     limit = new Integer( (lim!=null?lim.getText():null) );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "limit"



    // $ANTLR start "offset"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:448:1: offset : OFFSET INT ;
    public final void offset() throws RecognitionException {
        Token INT23=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:448:7: ( OFFSET INT )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:449:5: OFFSET INT
            {
            match(input,OFFSET,FOLLOW_OFFSET_in_offset1021); 

            INT23=(Token)match(input,INT,FOLLOW_INT_in_offset1023); 


                     offset = new Integer( (INT23!=null?INT23.getText():null) );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "offset"



    // $ANTLR start "valorvarobj"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:455:1: valorvarobj returns [Object value] : ( STRING | t_long | t_double | TRUE | FALSE | NULL | var | datetime | keyfunc | geopt | user );
    public final Object valorvarobj() throws RecognitionException {
        Object value = null;


        Token STRING24=null;
        Long t_long25 =null;

        Double t_double26 =null;

        Object var27 =null;

        Date datetime28 =null;

        Key keyfunc29 =null;

        GeoPt geopt30 =null;

        User user31 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:455:34: ( STRING | t_long | t_double | TRUE | FALSE | NULL | var | datetime | keyfunc | geopt | user )
            int alt25=11;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt25=1;
                }
                break;
            case PLUS:
                {
                int LA25_2 = input.LA(2);

                if ( (LA25_2==INT) ) {
                    alt25=2;
                }
                else if ( (LA25_2==FLOAT) ) {
                    alt25=3;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 2, input);

                    throw nvae;

                }
                }
                break;
            case INT:
                {
                alt25=2;
                }
                break;
            case MINUS:
                {
                int LA25_4 = input.LA(2);

                if ( (LA25_4==INT) ) {
                    alt25=2;
                }
                else if ( (LA25_4==FLOAT) ) {
                    alt25=3;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 4, input);

                    throw nvae;

                }
                }
                break;
            case FLOAT:
                {
                alt25=3;
                }
                break;
            case TRUE:
                {
                alt25=4;
                }
                break;
            case FALSE:
                {
                alt25=5;
                }
                break;
            case NULL:
                {
                alt25=6;
                }
                break;
            case VARID:
                {
                alt25=7;
                }
                break;
            case DATE:
            case DATETIME:
            case TIME:
                {
                alt25=8;
                }
                break;
            case KEY:
                {
                alt25=9;
                }
                break;
            case GEOPT:
                {
                alt25=10;
                }
                break;
            case USER:
                {
                alt25=11;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;

            }

            switch (alt25) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:456:5: STRING
                    {
                    STRING24=(Token)match(input,STRING,FOLLOW_STRING_in_valorvarobj1045); 

                     value = string( (STRING24!=null?STRING24.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:457:7: t_long
                    {
                    pushFollow(FOLLOW_t_long_in_valorvarobj1055);
                    t_long25=t_long();

                    state._fsp--;


                     value = t_long25;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:458:7: t_double
                    {
                    pushFollow(FOLLOW_t_double_in_valorvarobj1065);
                    t_double26=t_double();

                    state._fsp--;


                     value = t_double26;

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:459:7: TRUE
                    {
                    match(input,TRUE,FOLLOW_TRUE_in_valorvarobj1075); 

                     value = Boolean.TRUE;

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:460:7: FALSE
                    {
                    match(input,FALSE,FOLLOW_FALSE_in_valorvarobj1085); 

                     value = Boolean.FALSE;

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:461:7: NULL
                    {
                    match(input,NULL,FOLLOW_NULL_in_valorvarobj1095); 

                     value = null; 

                    }
                    break;
                case 7 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:462:7: var
                    {
                    pushFollow(FOLLOW_var_in_valorvarobj1105);
                    var27=var();

                    state._fsp--;


                     value = var27;

                    }
                    break;
                case 8 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:463:7: datetime
                    {
                    pushFollow(FOLLOW_datetime_in_valorvarobj1115);
                    datetime28=datetime();

                    state._fsp--;


                     value = datetime28;

                    }
                    break;
                case 9 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:464:7: keyfunc
                    {
                    pushFollow(FOLLOW_keyfunc_in_valorvarobj1125);
                    keyfunc29=keyfunc();

                    state._fsp--;


                     value = keyfunc29;

                    }
                    break;
                case 10 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:465:7: geopt
                    {
                    pushFollow(FOLLOW_geopt_in_valorvarobj1135);
                    geopt30=geopt();

                    state._fsp--;


                     value = geopt30;

                    }
                    break;
                case 11 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:466:7: user
                    {
                    pushFollow(FOLLOW_user_in_valorvarobj1145);
                    user31=user();

                    state._fsp--;


                     value = user31;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "valorvarobj"



    // $ANTLR start "datetime"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:470:1: datetime returns [Date value] : ( DATE '(' sval= STRING ')' | DATETIME '(' sval= STRING ')' | TIME '(' sval= STRING ')' | DATE '(' year= intorvar ',' month= intorvar ',' day= intorvar ')' | DATETIME '(' year= intorvar ',' month= intorvar ',' day= intorvar ',' hour= intorvar ',' minute= intorvar ',' second= intorvar ')' | TIME '(' hour= intorvar ',' minute= intorvar ',' second= intorvar ')' );
    public final Date datetime() throws RecognitionException {
        Date value = null;


        Token sval=null;
        Integer year =null;

        Integer month =null;

        Integer day =null;

        Integer hour =null;

        Integer minute =null;

        Integer second =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:470:29: ( DATE '(' sval= STRING ')' | DATETIME '(' sval= STRING ')' | TIME '(' sval= STRING ')' | DATE '(' year= intorvar ',' month= intorvar ',' day= intorvar ')' | DATETIME '(' year= intorvar ',' month= intorvar ',' day= intorvar ',' hour= intorvar ',' minute= intorvar ',' second= intorvar ')' | TIME '(' hour= intorvar ',' minute= intorvar ',' second= intorvar ')' )
            int alt26=6;
            switch ( input.LA(1) ) {
            case DATE:
                {
                int LA26_1 = input.LA(2);

                if ( (LA26_1==66) ) {
                    int LA26_4 = input.LA(3);

                    if ( (LA26_4==STRING) ) {
                        alt26=1;
                    }
                    else if ( (LA26_4==INT||LA26_4==VARID) ) {
                        alt26=4;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 26, 4, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 26, 1, input);

                    throw nvae;

                }
                }
                break;
            case DATETIME:
                {
                int LA26_2 = input.LA(2);

                if ( (LA26_2==66) ) {
                    int LA26_5 = input.LA(3);

                    if ( (LA26_5==STRING) ) {
                        alt26=2;
                    }
                    else if ( (LA26_5==INT||LA26_5==VARID) ) {
                        alt26=5;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 26, 5, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 26, 2, input);

                    throw nvae;

                }
                }
                break;
            case TIME:
                {
                int LA26_3 = input.LA(2);

                if ( (LA26_3==66) ) {
                    int LA26_6 = input.LA(3);

                    if ( (LA26_6==STRING) ) {
                        alt26=3;
                    }
                    else if ( (LA26_6==INT||LA26_6==VARID) ) {
                        alt26=6;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 26, 6, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 26, 3, input);

                    throw nvae;

                }
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;

            }

            switch (alt26) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:471:5: DATE '(' sval= STRING ')'
                    {
                    match(input,DATE,FOLLOW_DATE_in_datetime1167); 

                    match(input,66,FOLLOW_66_in_datetime1169); 

                    sval=(Token)match(input,STRING,FOLLOW_STRING_in_datetime1173); 

                    match(input,67,FOLLOW_67_in_datetime1175); 

                     value = date( string((sval!=null?sval.getText():null))); 

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:472:7: DATETIME '(' sval= STRING ')'
                    {
                    match(input,DATETIME,FOLLOW_DATETIME_in_datetime1185); 

                    match(input,66,FOLLOW_66_in_datetime1187); 

                    sval=(Token)match(input,STRING,FOLLOW_STRING_in_datetime1191); 

                    match(input,67,FOLLOW_67_in_datetime1193); 

                     value = ParserUtils.datetime( string((sval!=null?sval.getText():null) )); 

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:473:7: TIME '(' sval= STRING ')'
                    {
                    match(input,TIME,FOLLOW_TIME_in_datetime1203); 

                    match(input,66,FOLLOW_66_in_datetime1205); 

                    sval=(Token)match(input,STRING,FOLLOW_STRING_in_datetime1209); 

                    match(input,67,FOLLOW_67_in_datetime1211); 

                     value = time( string((sval!=null?sval.getText():null) )); 

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:474:7: DATE '(' year= intorvar ',' month= intorvar ',' day= intorvar ')'
                    {
                    match(input,DATE,FOLLOW_DATE_in_datetime1221); 

                    match(input,66,FOLLOW_66_in_datetime1223); 

                    pushFollow(FOLLOW_intorvar_in_datetime1227);
                    year=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1229); 

                    pushFollow(FOLLOW_intorvar_in_datetime1233);
                    month=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1235); 

                    pushFollow(FOLLOW_intorvar_in_datetime1239);
                    day=intorvar();

                    state._fsp--;


                    match(input,67,FOLLOW_67_in_datetime1241); 

                     value = date( year, month, day ); 

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:476:7: DATETIME '(' year= intorvar ',' month= intorvar ',' day= intorvar ',' hour= intorvar ',' minute= intorvar ',' second= intorvar ')'
                    {
                    match(input,DATETIME,FOLLOW_DATETIME_in_datetime1259); 

                    match(input,66,FOLLOW_66_in_datetime1261); 

                    pushFollow(FOLLOW_intorvar_in_datetime1265);
                    year=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1267); 

                    pushFollow(FOLLOW_intorvar_in_datetime1271);
                    month=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1273); 

                    pushFollow(FOLLOW_intorvar_in_datetime1277);
                    day=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1279); 

                    pushFollow(FOLLOW_intorvar_in_datetime1283);
                    hour=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1285); 

                    pushFollow(FOLLOW_intorvar_in_datetime1289);
                    minute=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1291); 

                    pushFollow(FOLLOW_intorvar_in_datetime1295);
                    second=intorvar();

                    state._fsp--;


                    match(input,67,FOLLOW_67_in_datetime1297); 

                     value = ParserUtils.datetime( year, month, day, hour, minute, second ); 

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:478:7: TIME '(' hour= intorvar ',' minute= intorvar ',' second= intorvar ')'
                    {
                    match(input,TIME,FOLLOW_TIME_in_datetime1315); 

                    match(input,66,FOLLOW_66_in_datetime1317); 

                    pushFollow(FOLLOW_intorvar_in_datetime1321);
                    hour=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1323); 

                    pushFollow(FOLLOW_intorvar_in_datetime1327);
                    minute=intorvar();

                    state._fsp--;


                    match(input,69,FOLLOW_69_in_datetime1329); 

                    pushFollow(FOLLOW_intorvar_in_datetime1333);
                    second=intorvar();

                    state._fsp--;


                    match(input,67,FOLLOW_67_in_datetime1335); 

                     value = time( hour, minute, second ); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "datetime"



    // $ANTLR start "geopt"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:483:1: geopt returns [GeoPt value] : GEOPT '(' lat= floatorvar ',' lon= floatorvar ')' ;
    public final GeoPt geopt() throws RecognitionException {
        GeoPt value = null;


        Float lat =null;

        Float lon =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:483:27: ( GEOPT '(' lat= floatorvar ',' lon= floatorvar ')' )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:484:5: GEOPT '(' lat= floatorvar ',' lon= floatorvar ')'
            {
            match(input,GEOPT,FOLLOW_GEOPT_in_geopt1365); 

            match(input,66,FOLLOW_66_in_geopt1367); 

            pushFollow(FOLLOW_floatorvar_in_geopt1371);
            lat=floatorvar();

            state._fsp--;


            match(input,69,FOLLOW_69_in_geopt1373); 

            pushFollow(FOLLOW_floatorvar_in_geopt1377);
            lon=floatorvar();

            state._fsp--;


            match(input,67,FOLLOW_67_in_geopt1379); 


                    value = new GeoPt( lat, lon );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "geopt"



    // $ANTLR start "user"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:489:1: user returns [User value] : USER '(' email= stringorvar ')' ;
    public final User user() throws RecognitionException {
        User value = null;


        String email =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:489:25: ( USER '(' email= stringorvar ')' )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:490:5: USER '(' email= stringorvar ')'
            {
            match(input,USER,FOLLOW_USER_in_user1400); 

            match(input,66,FOLLOW_66_in_user1402); 

            pushFollow(FOLLOW_stringorvar_in_user1406);
            email=stringorvar();

            state._fsp--;


            match(input,67,FOLLOW_67_in_user1408); 


                    value = new User( email, "gmail.com" );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "user"



    // $ANTLR start "intorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:496:1: intorvar returns [Integer value] : ( INT | var );
    public final Integer intorvar() throws RecognitionException {
        Integer value = null;


        Token INT32=null;
        Object var33 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:496:32: ( INT | var )
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==INT) ) {
                alt27=1;
            }
            else if ( (LA27_0==VARID) ) {
                alt27=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;

            }
            switch (alt27) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:497:5: INT
                    {
                    INT32=(Token)match(input,INT,FOLLOW_INT_in_intorvar1430); 

                     value = new Integer( (INT32!=null?INT32.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:498:7: var
                    {
                    pushFollow(FOLLOW_var_in_intorvar1440);
                    var33=var();

                    state._fsp--;


                     value = argInt( var33 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "intorvar"



    // $ANTLR start "floatorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:502:1: floatorvar returns [Float value] : ( t_long | t_double | var );
    public final Float floatorvar() throws RecognitionException {
        Float value = null;


        Long t_long34 =null;

        Double t_double35 =null;

        Object var36 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:502:32: ( t_long | t_double | var )
            int alt28=3;
            switch ( input.LA(1) ) {
            case PLUS:
                {
                int LA28_1 = input.LA(2);

                if ( (LA28_1==INT) ) {
                    alt28=1;
                }
                else if ( (LA28_1==FLOAT) ) {
                    alt28=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 28, 1, input);

                    throw nvae;

                }
                }
                break;
            case INT:
                {
                alt28=1;
                }
                break;
            case MINUS:
                {
                int LA28_3 = input.LA(2);

                if ( (LA28_3==INT) ) {
                    alt28=1;
                }
                else if ( (LA28_3==FLOAT) ) {
                    alt28=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 28, 3, input);

                    throw nvae;

                }
                }
                break;
            case FLOAT:
                {
                alt28=2;
                }
                break;
            case VARID:
                {
                alt28=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 28, 0, input);

                throw nvae;

            }

            switch (alt28) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:503:5: t_long
                    {
                    pushFollow(FOLLOW_t_long_in_floatorvar1462);
                    t_long34=t_long();

                    state._fsp--;


                     value = new Float(t_long34.floatValue());

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:504:7: t_double
                    {
                    pushFollow(FOLLOW_t_double_in_floatorvar1472);
                    t_double35=t_double();

                    state._fsp--;


                     value = new Float( t_double35.floatValue());

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:505:7: var
                    {
                    pushFollow(FOLLOW_var_in_floatorvar1482);
                    var36=var();

                    state._fsp--;


                     value = argFloat( var36 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "floatorvar"



    // $ANTLR start "stringorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:510:1: stringorvar returns [String value] : ( STRING | var );
    public final String stringorvar() throws RecognitionException {
        String value = null;


        Token STRING37=null;
        Object var38 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:510:34: ( STRING | var )
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==STRING) ) {
                alt29=1;
            }
            else if ( (LA29_0==VARID) ) {
                alt29=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;

            }
            switch (alt29) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:511:5: STRING
                    {
                    STRING37=(Token)match(input,STRING,FOLLOW_STRING_in_stringorvar1505); 

                     value = string( (STRING37!=null?STRING37.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:512:7: var
                    {
                    pushFollow(FOLLOW_var_in_stringorvar1515);
                    var38=var();

                    state._fsp--;


                     value = argString( var38 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "stringorvar"



    // $ANTLR start "t_long"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:516:1: t_long returns [Long value] : ( ( PLUS )? INT | MINUS INT );
    public final Long t_long() throws RecognitionException {
        Long value = null;


        Token INT39=null;
        Token INT40=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:516:27: ( ( PLUS )? INT | MINUS INT )
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==INT||LA31_0==PLUS) ) {
                alt31=1;
            }
            else if ( (LA31_0==MINUS) ) {
                alt31=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 31, 0, input);

                throw nvae;

            }
            switch (alt31) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:517:5: ( PLUS )? INT
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:517:5: ( PLUS )?
                    int alt30=2;
                    int LA30_0 = input.LA(1);

                    if ( (LA30_0==PLUS) ) {
                        alt30=1;
                    }
                    switch (alt30) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:517:5: PLUS
                            {
                            match(input,PLUS,FOLLOW_PLUS_in_t_long1537); 

                            }
                            break;

                    }


                    INT39=(Token)match(input,INT,FOLLOW_INT_in_t_long1540); 


                            value = new Long( (INT39!=null?INT39.getText():null) );
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:520:7: MINUS INT
                    {
                    match(input,MINUS,FOLLOW_MINUS_in_t_long1550); 

                    INT40=(Token)match(input,INT,FOLLOW_INT_in_t_long1552); 


                            value = new Long( "-" + (INT40!=null?INT40.getText():null) );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "t_long"



    // $ANTLR start "t_double"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:525:1: t_double returns [Double value] : ( ( PLUS )? FLOAT | MINUS FLOAT );
    public final Double t_double() throws RecognitionException {
        Double value = null;


        Token FLOAT41=null;
        Token FLOAT42=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:525:31: ( ( PLUS )? FLOAT | MINUS FLOAT )
            int alt33=2;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==FLOAT||LA33_0==PLUS) ) {
                alt33=1;
            }
            else if ( (LA33_0==MINUS) ) {
                alt33=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 33, 0, input);

                throw nvae;

            }
            switch (alt33) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:526:5: ( PLUS )? FLOAT
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:526:5: ( PLUS )?
                    int alt32=2;
                    int LA32_0 = input.LA(1);

                    if ( (LA32_0==PLUS) ) {
                        alt32=1;
                    }
                    switch (alt32) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:526:5: PLUS
                            {
                            match(input,PLUS,FOLLOW_PLUS_in_t_double1569); 

                            }
                            break;

                    }


                    FLOAT41=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_t_double1572); 


                            value = new Double( (FLOAT41!=null?FLOAT41.getText():null) );
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:529:7: MINUS FLOAT
                    {
                    match(input,MINUS,FOLLOW_MINUS_in_t_double1582); 

                    FLOAT42=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_t_double1584); 


                            value = new Double( "-" + (FLOAT42!=null?FLOAT42.getText():null) );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "t_double"



    // $ANTLR start "var"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:534:1: var returns [Object value] : VARID ;
    public final Object var() throws RecognitionException {
        Object value = null;


        Token VARID43=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:534:26: ( VARID )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:535:5: VARID
            {
            VARID43=(Token)match(input,VARID,FOLLOW_VARID_in_var1601); 

             value = arg( Integer.parseInt( (VARID43!=null?VARID43.getText():null).substring( 1 ))); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "var"


    public static class property_return extends ParserRuleReturnScope {
        public String value;
    };


    // $ANTLR start "property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:539:1: property returns [String value] : ( ID | STRING );
    public final GqlDynamicParser.property_return property() throws RecognitionException {
        GqlDynamicParser.property_return retval = new GqlDynamicParser.property_return();
        retval.start = input.LT(1);


        Token ID44=null;
        Token STRING45=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:539:31: ( ID | STRING )
            int alt34=2;
            int LA34_0 = input.LA(1);

            if ( (LA34_0==ID) ) {
                alt34=1;
            }
            else if ( (LA34_0==STRING) ) {
                alt34=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 34, 0, input);

                throw nvae;

            }
            switch (alt34) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:540:5: ID
                    {
                    ID44=(Token)match(input,ID,FOLLOW_ID_in_property1623); 


                            retval.value = (ID44!=null?ID44.getText():null);
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:543:7: STRING
                    {
                    STRING45=(Token)match(input,STRING,FOLLOW_STRING_in_property1633); 


                            retval.value = string( (STRING45!=null?STRING45.getText():null) );
                        

                    }
                    break;

            }
            retval.stop = input.LT(-1);


        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "property"



    // $ANTLR start "kind"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:549:1: kind returns [String value] : ( (id= ID ( '.' id2= ID )* ) | STRING );
    public final String kind() throws RecognitionException {
        String value = null;


        Token id=null;
        Token id2=null;
        Token STRING46=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:549:27: ( (id= ID ( '.' id2= ID )* ) | STRING )
            int alt36=2;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==ID) ) {
                alt36=1;
            }
            else if ( (LA36_0==STRING) ) {
                alt36=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;

            }
            switch (alt36) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:550:5: (id= ID ( '.' id2= ID )* )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:550:5: (id= ID ( '.' id2= ID )* )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:551:9: id= ID ( '.' id2= ID )*
                    {
                    id=(Token)match(input,ID,FOLLOW_ID_in_kind1667); 


                                value = (id!=null?id.getText():null);
                            

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:554:9: ( '.' id2= ID )*
                    loop35:
                    do {
                        int alt35=2;
                        int LA35_0 = input.LA(1);

                        if ( (LA35_0==70) ) {
                            alt35=1;
                        }


                        switch (alt35) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:555:13: '.' id2= ID
                    	    {
                    	    match(input,70,FOLLOW_70_in_kind1693); 

                    	    id2=(Token)match(input,ID,FOLLOW_ID_in_kind1697); 


                    	                    value += '.' + (id2!=null?id2.getText():null);
                    	                

                    	    }
                    	    break;

                    	default :
                    	    break loop35;
                        }
                    } while (true);


                    }


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlDynamic.g:560:7: STRING
                    {
                    STRING46=(Token)match(input,STRING,FOLLOW_STRING_in_kind1724); 


                            value = string( (STRING46!=null?STRING46.getText():null) );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "kind"

    // Delegated rules


 

    public static final BitSet FOLLOW_SELECT_in_gql56 = new BitSet(new long[]{0x0000000400000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_68_in_gql59 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_KEYPROP_in_gql63 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_FROM_in_gql66 = new BitSet(new long[]{0x0008000008000000L});
    public static final BitSet FOLLOW_kind_in_gql68 = new BitSet(new long[]{0x2000141000000002L});
    public static final BitSet FOLLOW_where_in_gql76 = new BitSet(new long[]{0x0000141000000002L});
    public static final BitSet FOLLOW_orderby_in_gql79 = new BitSet(new long[]{0x0000041000000002L});
    public static final BitSet FOLLOW_limit_in_gql82 = new BitSet(new long[]{0x0000040000000002L});
    public static final BitSet FOLLOW_offset_in_gql85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditions_in_gqlcond126 = new BitSet(new long[]{0x0000100000000002L});
    public static final BitSet FOLLOW_orderby_in_gqlcond128 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHERE_in_where152 = new BitSet(new long[]{0x0008000408000020L});
    public static final BitSet FOLLOW_conditions_in_where154 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condition_in_conditions161 = new BitSet(new long[]{0x0000000000000042L});
    public static final BitSet FOLLOW_AND_in_conditions164 = new BitSet(new long[]{0x0008000408000020L});
    public static final BitSet FOLLOW_condition_in_conditions166 = new BitSet(new long[]{0x0000000000000042L});
    public static final BitSet FOLLOW_cond_in_condition176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condkey_in_condition180 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condancestor_in_condition184 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condin_in_condition188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condkeyin_in_condition192 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_cond204 = new BitSet(new long[]{0x0000080000010000L});
    public static final BitSet FOLLOW_oper_in_cond206 = new BitSet(new long[]{0x0568414220983000L});
    public static final BitSet FOLLOW_valorvarobj_in_cond210 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_condkey229 = new BitSet(new long[]{0x0000080000010000L});
    public static final BitSet FOLLOW_oper_in_condkey231 = new BitSet(new long[]{0x0408000200000000L});
    public static final BitSet FOLLOW_key_in_condkey233 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTOR_in_condancestor252 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_IS_in_condancestor254 = new BitSet(new long[]{0x0408000200000000L});
    public static final BitSet FOLLOW_key_in_condancestor256 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_condin275 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_IN_in_condin277 = new BitSet(new long[]{0x0400000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_condin307 = new BitSet(new long[]{0x0568414220983000L});
    public static final BitSet FOLLOW_listitem_in_condin323 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000028L});
    public static final BitSet FOLLOW_69_in_condin327 = new BitSet(new long[]{0x0568414220983000L});
    public static final BitSet FOLLOW_listitem_in_condin329 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000028L});
    public static final BitSet FOLLOW_67_in_condin334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_condin358 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_condkeyin383 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_IN_in_condkeyin385 = new BitSet(new long[]{0x0400000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_condkeyin415 = new BitSet(new long[]{0x0408000200000000L});
    public static final BitSet FOLLOW_listitemkey_in_condkeyin431 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000028L});
    public static final BitSet FOLLOW_69_in_condkeyin435 = new BitSet(new long[]{0x0408000200000000L});
    public static final BitSet FOLLOW_listitemkey_in_condkeyin437 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000028L});
    public static final BitSet FOLLOW_67_in_condkeyin442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_condkeyin466 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EQ_in_oper494 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPER_in_oper504 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_valorvarobj_in_listitem526 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_key_in_listitemkey546 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_key568 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_key578 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_keyfunc_in_key588 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEY_in_keyfunc610 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_keyfunc612 = new BitSet(new long[]{0x0408000000000000L});
    public static final BitSet FOLLOW_stringorvar_in_keyfunc630 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_keypath_in_keyfunc644 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_keyfunc658 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_keypath680 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_keypath682 = new BitSet(new long[]{0x0408000020000000L});
    public static final BitSet FOLLOW_STRING_in_keypath700 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_INT_in_keypath716 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_var_in_keypath730 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_keypathchild_in_keypath744 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_69_in_keypathchild765 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_STRING_in_keypathchild769 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_keypathchild771 = new BitSet(new long[]{0x0408000020000000L});
    public static final BitSet FOLLOW_STRING_in_keypathchild789 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_INT_in_keypathchild805 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_var_in_keypathchild819 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_keypathchild_in_keypathchild833 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDER_in_orderby849 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_BY_in_orderby851 = new BitSet(new long[]{0x0008000408000000L});
    public static final BitSet FOLLOW_orderbyitem_in_orderby853 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_orderby856 = new BitSet(new long[]{0x0008000408000000L});
    public static final BitSet FOLLOW_orderbyitem_in_orderby858 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000020L});
    public static final BitSet FOLLOW_property_in_orderbyitem882 = new BitSet(new long[]{0x0000000000004082L});
    public static final BitSet FOLLOW_KEYPROP_in_orderbyitem894 = new BitSet(new long[]{0x0000000000004082L});
    public static final BitSet FOLLOW_ASC_in_orderbyitem916 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DESC_in_orderbyitem934 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LIMIT_in_limit965 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_INT_in_limit983 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_limit985 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_INT_in_limit1002 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OFFSET_in_offset1021 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_INT_in_offset1023 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_valorvarobj1045 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_t_long_in_valorvarobj1055 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_t_double_in_valorvarobj1065 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_valorvarobj1075 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_valorvarobj1085 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NULL_in_valorvarobj1095 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_valorvarobj1105 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_datetime_in_valorvarobj1115 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_keyfunc_in_valorvarobj1125 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_geopt_in_valorvarobj1135 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_user_in_valorvarobj1145 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATE_in_datetime1167 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_datetime1169 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_STRING_in_datetime1173 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_datetime1175 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATETIME_in_datetime1185 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_datetime1187 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_STRING_in_datetime1191 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_datetime1193 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TIME_in_datetime1203 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_datetime1205 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_STRING_in_datetime1209 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_datetime1211 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATE_in_datetime1221 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_datetime1223 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1227 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1229 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1233 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1235 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1239 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_datetime1241 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATETIME_in_datetime1259 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_datetime1261 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1265 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1267 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1271 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1273 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1277 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1279 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1283 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1285 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1289 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1291 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1295 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_datetime1297 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TIME_in_datetime1315 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_datetime1317 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1321 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1323 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1327 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_datetime1329 = new BitSet(new long[]{0x0400000020000000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1333 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_datetime1335 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_GEOPT_in_geopt1365 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_geopt1367 = new BitSet(new long[]{0x0400404020100000L});
    public static final BitSet FOLLOW_floatorvar_in_geopt1371 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_69_in_geopt1373 = new BitSet(new long[]{0x0400404020100000L});
    public static final BitSet FOLLOW_floatorvar_in_geopt1377 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_geopt1379 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_USER_in_user1400 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_66_in_user1402 = new BitSet(new long[]{0x0408000000000000L});
    public static final BitSet FOLLOW_stringorvar_in_user1406 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_67_in_user1408 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_intorvar1430 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_intorvar1440 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_t_long_in_floatorvar1462 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_t_double_in_floatorvar1472 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_floatorvar1482 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_stringorvar1505 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_stringorvar1515 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_t_long1537 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_INT_in_t_long1540 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_t_long1550 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_INT_in_t_long1552 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_t_double1569 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_FLOAT_in_t_double1572 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_t_double1582 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_FLOAT_in_t_double1584 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VARID_in_var1601 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_property1623 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_property1633 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_kind1667 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000040L});
    public static final BitSet FOLLOW_70_in_kind1693 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_ID_in_kind1697 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000040L});
    public static final BitSet FOLLOW_STRING_in_kind1724 = new BitSet(new long[]{0x0000000000000002L});

}