// $ANTLR 3.4 /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g 2012-04-10 16:34:00

/*
 * Copyright 2010 Spolecne s.r.o. (www.spoledge.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.spoledge.audao.parser.gql.impl;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.GeoPt;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;

import com.google.appengine.api.users.User;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.spoledge.audao.parser.gql.impl.soft.SoftFunction;
import com.spoledge.audao.parser.gql.impl.soft.SoftFunctionFactory;
import static com.spoledge.audao.parser.gql.impl.ParserUtils.*;



import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked"})
public class GqlExtExprTree extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "A", "ANCESTOR", "AND", "AS", "ASC", "ASTERISK", "B", "BY", "C", "COMMA", "D", "DATE", "DATETIME", "DELETE", "DESC", "DOT", "DUAL", "E", "EMPTY", "EQ", "EXPONENT", "F", "FALSE", "FLOAT", "FROM", "G", "GEOPT", "H", "HEX_DIGIT", "I", "ID", "IN", "INSERT", "INT", "INTO", "IS", "J", "K", "KEY", "KEYPROP", "KIND", "L", "LEFT_PAR", "LIMIT", "M", "MINUS", "N", "NOT", "NULL", "O", "OFFSET", "OPER", "OR", "ORDER", "P", "PLUS", "PROP", "Q", "R", "RIGHT_PAR", "S", "SELECT", "SET", "SLASH", "SOFT", "STRING", "T", "TIME", "TRUE", "Tokens", "U", "UNINDEXED", "UPDATE", "USER", "V", "VALUES", "VARID", "VARNAME", "W", "WHERE", "WS", "X", "Y", "Z", "COLAS", "DIV", "FUNC", "LIST", "MUL", "PATH", "UMINUS"
    };

    public static final int EOF=-1;
    public static final int A=4;
    public static final int ANCESTOR=5;
    public static final int AND=6;
    public static final int AS=7;
    public static final int ASC=8;
    public static final int ASTERISK=9;
    public static final int B=10;
    public static final int BY=11;
    public static final int C=12;
    public static final int COMMA=13;
    public static final int D=14;
    public static final int DATE=15;
    public static final int DATETIME=16;
    public static final int DELETE=17;
    public static final int DESC=18;
    public static final int DOT=19;
    public static final int DUAL=20;
    public static final int E=21;
    public static final int EMPTY=22;
    public static final int EQ=23;
    public static final int EXPONENT=24;
    public static final int F=25;
    public static final int FALSE=26;
    public static final int FLOAT=27;
    public static final int FROM=28;
    public static final int G=29;
    public static final int GEOPT=30;
    public static final int H=31;
    public static final int HEX_DIGIT=32;
    public static final int I=33;
    public static final int ID=34;
    public static final int IN=35;
    public static final int INSERT=36;
    public static final int INT=37;
    public static final int INTO=38;
    public static final int IS=39;
    public static final int J=40;
    public static final int K=41;
    public static final int KEY=42;
    public static final int KEYPROP=43;
    public static final int KIND=44;
    public static final int L=45;
    public static final int LEFT_PAR=46;
    public static final int LIMIT=47;
    public static final int M=48;
    public static final int MINUS=49;
    public static final int N=50;
    public static final int NOT=51;
    public static final int NULL=52;
    public static final int O=53;
    public static final int OFFSET=54;
    public static final int OPER=55;
    public static final int OR=56;
    public static final int ORDER=57;
    public static final int P=58;
    public static final int PLUS=59;
    public static final int PROP=60;
    public static final int Q=61;
    public static final int R=62;
    public static final int RIGHT_PAR=63;
    public static final int S=64;
    public static final int SELECT=65;
    public static final int SET=66;
    public static final int SLASH=67;
    public static final int SOFT=68;
    public static final int STRING=69;
    public static final int T=70;
    public static final int TIME=71;
    public static final int TRUE=72;
    public static final int Tokens=73;
    public static final int U=74;
    public static final int UNINDEXED=75;
    public static final int UPDATE=76;
    public static final int USER=77;
    public static final int V=78;
    public static final int VALUES=79;
    public static final int VARID=80;
    public static final int VARNAME=81;
    public static final int W=82;
    public static final int WHERE=83;
    public static final int WS=84;
    public static final int X=85;
    public static final int Y=86;
    public static final int Z=87;
    public static final int COLAS=88;
    public static final int DIV=89;
    public static final int FUNC=90;
    public static final int LIST=91;
    public static final int MUL=92;
    public static final int PATH=93;
    public static final int UMINUS=94;

    // delegates
    public TreeParser[] getDelegates() {
        return new TreeParser[] {};
    }

    // delegators


    public GqlExtExprTree(TreeNodeStream input) {
        this(input, new RecognizerSharedState());
    }
    public GqlExtExprTree(TreeNodeStream input, RecognizerSharedState state) {
        super(input, state);
    }

    public String[] getTokenNames() { return GqlExtExprTree.tokenNames; }
    public String getGrammarFileName() { return "/Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g"; }



        /**
         * The logger.
         */
        private Log log = LogFactory.getLog( getClass());

        private Object[] args;
        private Entity ent;
        private RecognitionException firstError;
        private SoftFunctionFactory softFunctionFactory;


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods - public
        ////////////////////////////////////////////////////////////////////////////

        @Override
        public void reportError(RecognitionException e) {
            if (firstError == null) firstError = e;
            super.reportError( e );
        }


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods - private
        ////////////////////////////////////////////////////////////////////////////

        private Object arg(int pos) {
            if (args == null) {
                // when passing 'null' - it is treated as (Object[])
                if (pos == 1) return null;
            }
            else if (pos <= args.length) return args[ pos - 1 ];

            log.error("arg(): no such parameter ':" + pos + "'");

            throw new RuntimeException("No such parameter ':" + pos + "'");
        }


        private Object plus( Object o1, Object o2 ) {
            return func( "PLUS", Arrays.asList( o1, o2 ));
        }

        private Object minus( Object o1, Object o2 ) {
            return func( "MINUS", Arrays.asList( o1, o2 ));
        }

        private Object mul( Object o1, Object o2 ) {
            return func( "MUL", Arrays.asList( o1, o2 ));
        }

        private Object div( Object o1, Object o2 ) {
            return func( "DIV", Arrays.asList( o1, o2 ));
        }

        private Object func( String fname, List<Object> params ) {
            if (softFunctionFactory == null) {
                softFunctionFactory = SoftFunctionFactory.getDefaultFactory();
            }

            fname = fname.toUpperCase();

            return softFunctionFactory.getSoftFunction( fname ).getFunctionValue( params );
        }


        ////////////////////////////////////////////////////////////////////////////
        // Dynamically generated methods
        ////////////////////////////////////////////////////////////////////////////



    // $ANTLR start "expr"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:142:1: expr[Object[] args, Entity ent] returns [Object value] : exprimpl ;
    public final Object expr(Object[] args, Entity ent) throws RecognitionException {
        Object value = null;


        Object exprimpl1 =null;



                this.args = args;
                this.ent = ent;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:147:5: ( exprimpl )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:147:7: exprimpl
            {
            pushFollow(FOLLOW_exprimpl_in_expr71);
            exprimpl1=exprimpl();

            state._fsp--;



                    value = exprimpl1;
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving

                    if (getNumberOfSyntaxErrors() != 0) throw firstError;
                
        }
        return value;
    }
    // $ANTLR end "expr"



    // $ANTLR start "key"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:155:1: key returns [Key value] : ( ^( KEY STRING ) | ^( KEY var ) | ^( KEY keypath ) );
    public final Key key() throws RecognitionException {
        Key value = null;


        CommonTree STRING2=null;
        Object var3 =null;

        KeyFactory.Builder keypath4 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:155:23: ( ^( KEY STRING ) | ^( KEY var ) | ^( KEY keypath ) )
            int alt1=3;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==KEY) ) {
                int LA1_1 = input.LA(2);

                if ( (LA1_1==DOWN) ) {
                    switch ( input.LA(3) ) {
                    case STRING:
                        {
                        alt1=1;
                        }
                        break;
                    case VARID:
                        {
                        alt1=2;
                        }
                        break;
                    case PATH:
                        {
                        alt1=3;
                        }
                        break;
                    default:
                        NoViableAltException nvae =
                            new NoViableAltException("", 1, 2, input);

                        throw nvae;

                    }

                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 1, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;

            }
            switch (alt1) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:156:5: ^( KEY STRING )
                    {
                    match(input,KEY,FOLLOW_KEY_in_key97); 

                    match(input, Token.DOWN, null); 
                    STRING2=(CommonTree)match(input,STRING,FOLLOW_STRING_in_key99); 

                    match(input, Token.UP, null); 



                            value = KeyFactory.stringToKey( string( (STRING2!=null?STRING2.getText():null) ));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:159:7: ^( KEY var )
                    {
                    match(input,KEY,FOLLOW_KEY_in_key111); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_var_in_key113);
                    var3=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            if (var3 instanceof Key) {
                                value = (Key) var3;
                            }
                            else {
                                value = KeyFactory.stringToKey( argString( var3 ));
                            }
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:167:7: ^( KEY keypath )
                    {
                    match(input,KEY,FOLLOW_KEY_in_key125); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_keypath_in_key127);
                    keypath4=keypath();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = keypath4.getKey();
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "key"



    // $ANTLR start "keypath"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:173:1: keypath returns [KeyFactory.Builder value] : ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) ) ( keypathchild[$value] )* ;
    public final KeyFactory.Builder keypath() throws RecognitionException {
        KeyFactory.Builder value = null;


        CommonTree kin=null;
        CommonTree name=null;
        CommonTree id=null;
        Object var5 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:173:42: ( ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) ) ( keypathchild[$value] )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:174:5: ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) ) ( keypathchild[$value] )*
            {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:174:5: ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) )
            int alt2=3;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==PATH) ) {
                int LA2_1 = input.LA(2);

                if ( (LA2_1==DOWN) ) {
                    int LA2_2 = input.LA(3);

                    if ( (LA2_2==STRING) ) {
                        switch ( input.LA(4) ) {
                        case STRING:
                            {
                            alt2=1;
                            }
                            break;
                        case INT:
                            {
                            alt2=2;
                            }
                            break;
                        case VARID:
                            {
                            alt2=3;
                            }
                            break;
                        default:
                            NoViableAltException nvae =
                                new NoViableAltException("", 2, 3, input);

                            throw nvae;

                        }

                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 2, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 2, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;

            }
            switch (alt2) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:175:9: ^( PATH kin= STRING name= STRING )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypath161); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath165); 

                    name=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath169); 

                    match(input, Token.UP, null); 



                                value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), string( (name!=null?name.getText():null) ));
                            

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:178:11: ^( PATH kin= STRING id= INT )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypath185); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath189); 

                    id=(CommonTree)match(input,INT,FOLLOW_INT_in_keypath193); 

                    match(input, Token.UP, null); 



                                value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), new Long( (id!=null?id.getText():null) ));
                            

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:181:11: ^( PATH kin= STRING var )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypath209); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath213); 

                    pushFollow(FOLLOW_var_in_keypath215);
                    var5=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                                if (var5 instanceof Number) {
                                    value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), argLong( var5 ));
                                }
                                else {
                                    value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), argString( var5 ));
                                }
                            

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:190:5: ( keypathchild[$value] )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==PATH) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:190:5: keypathchild[$value]
            	    {
            	    pushFollow(FOLLOW_keypathchild_in_keypath230);
            	    keypathchild(value);

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "keypath"



    // $ANTLR start "keypathchild"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:193:1: keypathchild[KeyFactory.Builder builder] : ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) );
    public final void keypathchild(KeyFactory.Builder builder) throws RecognitionException {
        CommonTree kin=null;
        CommonTree name=null;
        CommonTree id=null;
        Object var6 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:193:41: ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) )
            int alt4=3;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==PATH) ) {
                int LA4_1 = input.LA(2);

                if ( (LA4_1==DOWN) ) {
                    int LA4_2 = input.LA(3);

                    if ( (LA4_2==STRING) ) {
                        switch ( input.LA(4) ) {
                        case STRING:
                            {
                            alt4=1;
                            }
                            break;
                        case INT:
                            {
                            alt4=2;
                            }
                            break;
                        case VARID:
                            {
                            alt4=3;
                            }
                            break;
                        default:
                            NoViableAltException nvae =
                                new NoViableAltException("", 4, 3, input);

                            throw nvae;

                        }

                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 4, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 4, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;

            }
            switch (alt4) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:194:5: ^( PATH kin= STRING name= STRING )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypathchild246); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild250); 

                    name=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild254); 

                    match(input, Token.UP, null); 



                            builder.addChild( string( (kin!=null?kin.getText():null) ), string( (name!=null?name.getText():null) ));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:197:7: ^( PATH kin= STRING id= INT )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypathchild266); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild270); 

                    id=(CommonTree)match(input,INT,FOLLOW_INT_in_keypathchild274); 

                    match(input, Token.UP, null); 



                            builder.addChild( string( (kin!=null?kin.getText():null) ), new Long( (id!=null?id.getText():null) ));
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:200:7: ^( PATH kin= STRING var )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypathchild286); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild290); 

                    pushFollow(FOLLOW_var_in_keypathchild292);
                    var6=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            if (var6 instanceof Number) {
                                builder.addChild( string( (kin!=null?kin.getText():null) ), argLong( var6 ));
                            }
                            else {
                                builder.addChild( string( (kin!=null?kin.getText():null) ), argString( var6 ));
                            }
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "keypathchild"



    // $ANTLR start "valorvarobj"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:210:1: valorvarobj returns [Object value] : ( STRING | INT | FLOAT | TRUE | FALSE | NULL | var | datetime | key | geopt | user );
    public final Object valorvarobj() throws RecognitionException {
        Object value = null;


        CommonTree STRING7=null;
        CommonTree INT8=null;
        CommonTree FLOAT9=null;
        Object var10 =null;

        Date datetime11 =null;

        Key key12 =null;

        GeoPt geopt13 =null;

        User user14 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:210:34: ( STRING | INT | FLOAT | TRUE | FALSE | NULL | var | datetime | key | geopt | user )
            int alt5=11;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt5=1;
                }
                break;
            case INT:
                {
                alt5=2;
                }
                break;
            case FLOAT:
                {
                alt5=3;
                }
                break;
            case TRUE:
                {
                alt5=4;
                }
                break;
            case FALSE:
                {
                alt5=5;
                }
                break;
            case NULL:
                {
                alt5=6;
                }
                break;
            case VARID:
                {
                alt5=7;
                }
                break;
            case DATE:
            case DATETIME:
            case TIME:
                {
                alt5=8;
                }
                break;
            case KEY:
                {
                alt5=9;
                }
                break;
            case GEOPT:
                {
                alt5=10;
                }
                break;
            case USER:
                {
                alt5=11;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;

            }

            switch (alt5) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:211:5: STRING
                    {
                    STRING7=(CommonTree)match(input,STRING,FOLLOW_STRING_in_valorvarobj310); 

                     value = string( (STRING7!=null?STRING7.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:212:7: INT
                    {
                    INT8=(CommonTree)match(input,INT,FOLLOW_INT_in_valorvarobj320); 

                     value = new Long( (INT8!=null?INT8.getText():null) );

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:213:7: FLOAT
                    {
                    FLOAT9=(CommonTree)match(input,FLOAT,FOLLOW_FLOAT_in_valorvarobj330); 

                     value = new Double( (FLOAT9!=null?FLOAT9.getText():null) );

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:214:7: TRUE
                    {
                    match(input,TRUE,FOLLOW_TRUE_in_valorvarobj340); 

                     value = Boolean.TRUE;

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:215:7: FALSE
                    {
                    match(input,FALSE,FOLLOW_FALSE_in_valorvarobj350); 

                     value = Boolean.FALSE;

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:216:7: NULL
                    {
                    match(input,NULL,FOLLOW_NULL_in_valorvarobj360); 

                     value = null; 

                    }
                    break;
                case 7 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:217:7: var
                    {
                    pushFollow(FOLLOW_var_in_valorvarobj370);
                    var10=var();

                    state._fsp--;


                     value = var10;

                    }
                    break;
                case 8 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:218:7: datetime
                    {
                    pushFollow(FOLLOW_datetime_in_valorvarobj380);
                    datetime11=datetime();

                    state._fsp--;


                     value = datetime11;

                    }
                    break;
                case 9 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:219:7: key
                    {
                    pushFollow(FOLLOW_key_in_valorvarobj390);
                    key12=key();

                    state._fsp--;


                     value = key12;

                    }
                    break;
                case 10 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:220:7: geopt
                    {
                    pushFollow(FOLLOW_geopt_in_valorvarobj400);
                    geopt13=geopt();

                    state._fsp--;


                     value = geopt13;

                    }
                    break;
                case 11 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:221:7: user
                    {
                    pushFollow(FOLLOW_user_in_valorvarobj410);
                    user14=user();

                    state._fsp--;


                     value = user14;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "valorvarobj"



    // $ANTLR start "datetime"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:225:1: datetime returns [Date value] : ( ^( DATE sval= STRING ) | ^( DATETIME sval= STRING ) | ^( TIME sval= STRING ) | ^( DATE year= intorvar month= intorvar day= intorvar ) | ^( DATETIME year= intorvar month= intorvar day= intorvar hour= intorvar minute= intorvar second= intorvar ) | ^( TIME hour= intorvar minute= intorvar second= intorvar ) );
    public final Date datetime() throws RecognitionException {
        Date value = null;


        CommonTree sval=null;
        Integer year =null;

        Integer month =null;

        Integer day =null;

        Integer hour =null;

        Integer minute =null;

        Integer second =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:225:29: ( ^( DATE sval= STRING ) | ^( DATETIME sval= STRING ) | ^( TIME sval= STRING ) | ^( DATE year= intorvar month= intorvar day= intorvar ) | ^( DATETIME year= intorvar month= intorvar day= intorvar hour= intorvar minute= intorvar second= intorvar ) | ^( TIME hour= intorvar minute= intorvar second= intorvar ) )
            int alt6=6;
            switch ( input.LA(1) ) {
            case DATE:
                {
                int LA6_1 = input.LA(2);

                if ( (LA6_1==DOWN) ) {
                    int LA6_4 = input.LA(3);

                    if ( (LA6_4==STRING) ) {
                        alt6=1;
                    }
                    else if ( (LA6_4==INT||LA6_4==VARID) ) {
                        alt6=4;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 6, 4, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 1, input);

                    throw nvae;

                }
                }
                break;
            case DATETIME:
                {
                int LA6_2 = input.LA(2);

                if ( (LA6_2==DOWN) ) {
                    int LA6_5 = input.LA(3);

                    if ( (LA6_5==STRING) ) {
                        alt6=2;
                    }
                    else if ( (LA6_5==INT||LA6_5==VARID) ) {
                        alt6=5;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 6, 5, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 2, input);

                    throw nvae;

                }
                }
                break;
            case TIME:
                {
                int LA6_3 = input.LA(2);

                if ( (LA6_3==DOWN) ) {
                    int LA6_6 = input.LA(3);

                    if ( (LA6_6==STRING) ) {
                        alt6=3;
                    }
                    else if ( (LA6_6==INT||LA6_6==VARID) ) {
                        alt6=6;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 6, 6, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 3, input);

                    throw nvae;

                }
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;

            }

            switch (alt6) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:226:5: ^( DATE sval= STRING )
                    {
                    match(input,DATE,FOLLOW_DATE_in_datetime433); 

                    match(input, Token.DOWN, null); 
                    sval=(CommonTree)match(input,STRING,FOLLOW_STRING_in_datetime437); 

                    match(input, Token.UP, null); 



                            value = date( string((sval!=null?sval.getText():null)));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:229:7: ^( DATETIME sval= STRING )
                    {
                    match(input,DATETIME,FOLLOW_DATETIME_in_datetime449); 

                    match(input, Token.DOWN, null); 
                    sval=(CommonTree)match(input,STRING,FOLLOW_STRING_in_datetime453); 

                    match(input, Token.UP, null); 



                            value = ParserUtils.datetime( string((sval!=null?sval.getText():null) ));
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:232:7: ^( TIME sval= STRING )
                    {
                    match(input,TIME,FOLLOW_TIME_in_datetime465); 

                    match(input, Token.DOWN, null); 
                    sval=(CommonTree)match(input,STRING,FOLLOW_STRING_in_datetime469); 

                    match(input, Token.UP, null); 



                            value = time( string((sval!=null?sval.getText():null) ));
                        

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:235:7: ^( DATE year= intorvar month= intorvar day= intorvar )
                    {
                    match(input,DATE,FOLLOW_DATE_in_datetime481); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_intorvar_in_datetime485);
                    year=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime489);
                    month=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime493);
                    day=intorvar();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = date( year, month, day );
                        

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:238:7: ^( DATETIME year= intorvar month= intorvar day= intorvar hour= intorvar minute= intorvar second= intorvar )
                    {
                    match(input,DATETIME,FOLLOW_DATETIME_in_datetime505); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_intorvar_in_datetime509);
                    year=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime513);
                    month=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime517);
                    day=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime521);
                    hour=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime525);
                    minute=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime529);
                    second=intorvar();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = ParserUtils.datetime( year, month, day, hour, minute, second );
                        

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:241:7: ^( TIME hour= intorvar minute= intorvar second= intorvar )
                    {
                    match(input,TIME,FOLLOW_TIME_in_datetime541); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_intorvar_in_datetime545);
                    hour=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime549);
                    minute=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime553);
                    second=intorvar();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = time( hour, minute, second );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "datetime"



    // $ANTLR start "geopt"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:247:1: geopt returns [GeoPt value] : ^( GEOPT lat= floatorvar lon= floatorvar ) ;
    public final GeoPt geopt() throws RecognitionException {
        GeoPt value = null;


        Float lat =null;

        Float lon =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:247:27: ( ^( GEOPT lat= floatorvar lon= floatorvar ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:248:5: ^( GEOPT lat= floatorvar lon= floatorvar )
            {
            match(input,GEOPT,FOLLOW_GEOPT_in_geopt577); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_floatorvar_in_geopt581);
            lat=floatorvar();

            state._fsp--;


            pushFollow(FOLLOW_floatorvar_in_geopt585);
            lon=floatorvar();

            state._fsp--;


            match(input, Token.UP, null); 



                    value = new GeoPt( lat, lon );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "geopt"



    // $ANTLR start "user"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:254:1: user returns [User value] : ^( USER email= stringorvar ) ;
    public final User user() throws RecognitionException {
        User value = null;


        String email =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:254:25: ( ^( USER email= stringorvar ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:255:5: ^( USER email= stringorvar )
            {
            match(input,USER,FOLLOW_USER_in_user609); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_stringorvar_in_user613);
            email=stringorvar();

            state._fsp--;


            match(input, Token.UP, null); 



                    value = new User( email, "gmail.com" );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "user"



    // $ANTLR start "intorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:261:1: intorvar returns [Integer value] : ( INT | var );
    public final Integer intorvar() throws RecognitionException {
        Integer value = null;


        CommonTree INT15=null;
        Object var16 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:261:32: ( INT | var )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==INT) ) {
                alt7=1;
            }
            else if ( (LA7_0==VARID) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;

            }
            switch (alt7) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:262:5: INT
                    {
                    INT15=(CommonTree)match(input,INT,FOLLOW_INT_in_intorvar636); 

                     value = new Integer( (INT15!=null?INT15.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:263:7: var
                    {
                    pushFollow(FOLLOW_var_in_intorvar646);
                    var16=var();

                    state._fsp--;


                     value = argInt( var16 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "intorvar"



    // $ANTLR start "floatorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:267:1: floatorvar returns [Float value] : ( INT | FLOAT | var );
    public final Float floatorvar() throws RecognitionException {
        Float value = null;


        CommonTree INT17=null;
        CommonTree FLOAT18=null;
        Object var19 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:267:32: ( INT | FLOAT | var )
            int alt8=3;
            switch ( input.LA(1) ) {
            case INT:
                {
                alt8=1;
                }
                break;
            case FLOAT:
                {
                alt8=2;
                }
                break;
            case VARID:
                {
                alt8=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;

            }

            switch (alt8) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:268:5: INT
                    {
                    INT17=(CommonTree)match(input,INT,FOLLOW_INT_in_floatorvar668); 

                     value = new Float( (INT17!=null?INT17.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:269:7: FLOAT
                    {
                    FLOAT18=(CommonTree)match(input,FLOAT,FOLLOW_FLOAT_in_floatorvar678); 

                     value = new Float( (FLOAT18!=null?FLOAT18.getText():null) );

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:270:7: var
                    {
                    pushFollow(FOLLOW_var_in_floatorvar688);
                    var19=var();

                    state._fsp--;


                     value = argFloat( var19 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "floatorvar"



    // $ANTLR start "stringorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:275:1: stringorvar returns [String value] : ( STRING | var );
    public final String stringorvar() throws RecognitionException {
        String value = null;


        CommonTree STRING20=null;
        Object var21 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:275:34: ( STRING | var )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==STRING) ) {
                alt9=1;
            }
            else if ( (LA9_0==VARID) ) {
                alt9=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;

            }
            switch (alt9) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:276:5: STRING
                    {
                    STRING20=(CommonTree)match(input,STRING,FOLLOW_STRING_in_stringorvar711); 

                     value = string( (STRING20!=null?STRING20.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:277:7: var
                    {
                    pushFollow(FOLLOW_var_in_stringorvar721);
                    var21=var();

                    state._fsp--;


                     value = argString( var21 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "stringorvar"



    // $ANTLR start "var"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:281:1: var returns [Object value] : VARID ;
    public final Object var() throws RecognitionException {
        Object value = null;


        CommonTree VARID22=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:281:26: ( VARID )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:282:5: VARID
            {
            VARID22=(CommonTree)match(input,VARID,FOLLOW_VARID_in_var743); 

             value = arg( Integer.parseInt( (VARID22!=null?VARID22.getText():null).substring( 1 ))); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "var"



    // $ANTLR start "prop"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:286:1: prop returns [String value] : ( property | KEYPROP );
    public final String prop() throws RecognitionException {
        String value = null;


        CommonTree KEYPROP24=null;
        String property23 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:286:27: ( property | KEYPROP )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==PROP) ) {
                alt10=1;
            }
            else if ( (LA10_0==KEYPROP) ) {
                alt10=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;

            }
            switch (alt10) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:287:5: property
                    {
                    pushFollow(FOLLOW_property_in_prop765);
                    property23=property();

                    state._fsp--;



                            value = property23;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:290:7: KEYPROP
                    {
                    KEYPROP24=(CommonTree)match(input,KEYPROP,FOLLOW_KEYPROP_in_prop775); 


                            value = (KEYPROP24!=null?KEYPROP24.getText():null);
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "prop"



    // $ANTLR start "property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:295:1: property returns [String value] : ( ^( PROP ids ) | ^( PROP STRING ) );
    public final String property() throws RecognitionException {
        String value = null;


        CommonTree STRING26=null;
        String ids25 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:295:31: ( ^( PROP ids ) | ^( PROP STRING ) )
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==PROP) ) {
                int LA11_1 = input.LA(2);

                if ( (LA11_1==DOWN) ) {
                    int LA11_2 = input.LA(3);

                    if ( (LA11_2==STRING) ) {
                        alt11=2;
                    }
                    else if ( (LA11_2==ID) ) {
                        alt11=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 11, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 11, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 11, 0, input);

                throw nvae;

            }
            switch (alt11) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:296:5: ^( PROP ids )
                    {
                    match(input,PROP,FOLLOW_PROP_in_property793); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_ids_in_property795);
                    ids25=ids();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = ids25;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:299:7: ^( PROP STRING )
                    {
                    match(input,PROP,FOLLOW_PROP_in_property807); 

                    match(input, Token.DOWN, null); 
                    STRING26=(CommonTree)match(input,STRING,FOLLOW_STRING_in_property809); 

                    match(input, Token.UP, null); 



                            value = string( (STRING26!=null?STRING26.getText():null) );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "property"


    protected static class ids_scope {
        StringBuilder sb;
    }
    protected Stack ids_stack = new Stack();



    // $ANTLR start "ids"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:304:1: ids returns [String value] : ID ( ids2 )* ;
    public final String ids() throws RecognitionException {
        ids_stack.push(new ids_scope());
        String value = null;


        CommonTree ID27=null;


                ((ids_scope)ids_stack.peek()).sb = new StringBuilder();
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:311:5: ( ID ( ids2 )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:312:5: ID ( ids2 )*
            {
            ID27=(CommonTree)match(input,ID,FOLLOW_ID_in_ids849); 


                    ((ids_scope)ids_stack.peek()).sb.append( (ID27!=null?ID27.getText():null) );
                

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:315:5: ( ids2 )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==ID) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:315:5: ids2
            	    {
            	    pushFollow(FOLLOW_ids2_in_ids857);
            	    ids2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);



                    value = ((ids_scope)ids_stack.peek()).sb.toString();
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            ids_stack.pop();
        }
        return value;
    }
    // $ANTLR end "ids"



    // $ANTLR start "ids2"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:320:1: ids2 returns [String value] : ID ;
    public final String ids2() throws RecognitionException {
        String value = null;


        CommonTree ID28=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:320:27: ( ID )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:321:5: ID
            {
            ID28=(CommonTree)match(input,ID,FOLLOW_ID_in_ids2875); 


                    ((ids_scope)ids_stack.peek()).sb.append( '.' ).append( (ID28!=null?ID28.getText():null) );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "ids2"



    // $ANTLR start "exprimpl"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:326:1: exprimpl returns [Object value] : ( ^( PLUS e1= exprimpl e2= exprimpl ) | ^( UMINUS e1= exprimpl ) | ^( MINUS e1= exprimpl e2= exprimpl ) | ^( MUL e1= exprimpl e2= exprimpl ) | ^( DIV e1= exprimpl e2= exprimpl ) |vov= valorvarobj | KEYPROP | property | ^( FUNC fn= . ( list )? ) | ^( LIST list ) );
    public final Object exprimpl() throws RecognitionException {
        Object value = null;


        CommonTree fn=null;
        Object e1 =null;

        Object e2 =null;

        Object vov =null;

        String property29 =null;

        ArrayList<Object> list30 =null;

        ArrayList<Object> list31 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:326:31: ( ^( PLUS e1= exprimpl e2= exprimpl ) | ^( UMINUS e1= exprimpl ) | ^( MINUS e1= exprimpl e2= exprimpl ) | ^( MUL e1= exprimpl e2= exprimpl ) | ^( DIV e1= exprimpl e2= exprimpl ) |vov= valorvarobj | KEYPROP | property | ^( FUNC fn= . ( list )? ) | ^( LIST list ) )
            int alt14=10;
            switch ( input.LA(1) ) {
            case PLUS:
                {
                alt14=1;
                }
                break;
            case UMINUS:
                {
                alt14=2;
                }
                break;
            case MINUS:
                {
                alt14=3;
                }
                break;
            case MUL:
                {
                alt14=4;
                }
                break;
            case DIV:
                {
                alt14=5;
                }
                break;
            case DATE:
            case DATETIME:
            case FALSE:
            case FLOAT:
            case GEOPT:
            case INT:
            case KEY:
            case NULL:
            case STRING:
            case TIME:
            case TRUE:
            case USER:
            case VARID:
                {
                alt14=6;
                }
                break;
            case KEYPROP:
                {
                alt14=7;
                }
                break;
            case PROP:
                {
                alt14=8;
                }
                break;
            case FUNC:
                {
                alt14=9;
                }
                break;
            case LIST:
                {
                alt14=10;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;

            }

            switch (alt14) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:327:5: ^( PLUS e1= exprimpl e2= exprimpl )
                    {
                    match(input,PLUS,FOLLOW_PLUS_in_exprimpl897); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_exprimpl_in_exprimpl901);
                    e1=exprimpl();

                    state._fsp--;


                    pushFollow(FOLLOW_exprimpl_in_exprimpl905);
                    e2=exprimpl();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = plus( e1, e2 );
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:330:7: ^( UMINUS e1= exprimpl )
                    {
                    match(input,UMINUS,FOLLOW_UMINUS_in_exprimpl917); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_exprimpl_in_exprimpl921);
                    e1=exprimpl();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = minus( 0, e1 );
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:333:7: ^( MINUS e1= exprimpl e2= exprimpl )
                    {
                    match(input,MINUS,FOLLOW_MINUS_in_exprimpl933); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_exprimpl_in_exprimpl937);
                    e1=exprimpl();

                    state._fsp--;


                    pushFollow(FOLLOW_exprimpl_in_exprimpl941);
                    e2=exprimpl();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = minus( e1, e2 );
                        

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:336:7: ^( MUL e1= exprimpl e2= exprimpl )
                    {
                    match(input,MUL,FOLLOW_MUL_in_exprimpl953); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_exprimpl_in_exprimpl957);
                    e1=exprimpl();

                    state._fsp--;


                    pushFollow(FOLLOW_exprimpl_in_exprimpl961);
                    e2=exprimpl();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = mul( e1, e2 );
                        

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:339:7: ^( DIV e1= exprimpl e2= exprimpl )
                    {
                    match(input,DIV,FOLLOW_DIV_in_exprimpl973); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_exprimpl_in_exprimpl977);
                    e1=exprimpl();

                    state._fsp--;


                    pushFollow(FOLLOW_exprimpl_in_exprimpl981);
                    e2=exprimpl();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = div( e1, e2 );
                        

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:342:7: vov= valorvarobj
                    {
                    pushFollow(FOLLOW_valorvarobj_in_exprimpl994);
                    vov=valorvarobj();

                    state._fsp--;



                            value = vov;
                        

                    }
                    break;
                case 7 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:345:7: KEYPROP
                    {
                    match(input,KEYPROP,FOLLOW_KEYPROP_in_exprimpl1004); 


                            value = ent.getKey();
                        

                    }
                    break;
                case 8 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:348:7: property
                    {
                    pushFollow(FOLLOW_property_in_exprimpl1014);
                    property29=property();

                    state._fsp--;



                            value = ent.getProperty( property29 );
                        

                    }
                    break;
                case 9 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:351:7: ^( FUNC fn= . ( list )? )
                    {
                    match(input,FUNC,FOLLOW_FUNC_in_exprimpl1025); 

                    match(input, Token.DOWN, null); 
                    fn=(CommonTree)input.LT(1);

                    matchAny(input); 

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:351:19: ( list )?
                    int alt13=2;
                    int LA13_0 = input.LA(1);

                    if ( ((LA13_0 >= DATE && LA13_0 <= DATETIME)||(LA13_0 >= FALSE && LA13_0 <= FLOAT)||LA13_0==GEOPT||LA13_0==INT||(LA13_0 >= KEY && LA13_0 <= KEYPROP)||LA13_0==MINUS||LA13_0==NULL||(LA13_0 >= PLUS && LA13_0 <= PROP)||LA13_0==STRING||(LA13_0 >= TIME && LA13_0 <= TRUE)||LA13_0==USER||LA13_0==VARID||(LA13_0 >= DIV && LA13_0 <= MUL)||LA13_0==UMINUS) ) {
                        alt13=1;
                    }
                    switch (alt13) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:351:19: list
                            {
                            pushFollow(FOLLOW_list_in_exprimpl1031);
                            list30=list();

                            state._fsp--;


                            }
                            break;

                    }


                    match(input, Token.UP, null); 



                            value = func( fn.toString(), list_stack != null ? list30 : null );
                        

                    }
                    break;
                case 10 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:354:7: ^( LIST list )
                    {
                    match(input,LIST,FOLLOW_LIST_in_exprimpl1044); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_list_in_exprimpl1046);
                    list31=list();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            switch (list31.size()) {
                                case 0: value = null; break;
                                case 1: value = list31.get(0); break;
                                default: value = list31;
                            }
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "exprimpl"


    protected static class list_scope {
        ArrayList<Object> values;
    }
    protected Stack list_stack = new Stack();



    // $ANTLR start "list"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:363:1: list returns [ArrayList<Object> value] : ( listitem )+ ;
    public final ArrayList<Object> list() throws RecognitionException {
        list_stack.push(new list_scope());
        ArrayList<Object> value = null;



                ((list_scope)list_stack.peek()).values = new ArrayList<Object>();
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:370:5: ( ( listitem )+ )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:371:5: ( listitem )+
            {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:371:5: ( listitem )+
            int cnt15=0;
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( ((LA15_0 >= DATE && LA15_0 <= DATETIME)||(LA15_0 >= FALSE && LA15_0 <= FLOAT)||LA15_0==GEOPT||LA15_0==INT||(LA15_0 >= KEY && LA15_0 <= KEYPROP)||LA15_0==MINUS||LA15_0==NULL||(LA15_0 >= PLUS && LA15_0 <= PROP)||LA15_0==STRING||(LA15_0 >= TIME && LA15_0 <= TRUE)||LA15_0==USER||LA15_0==VARID||(LA15_0 >= DIV && LA15_0 <= MUL)||LA15_0==UMINUS) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:371:5: listitem
            	    {
            	    pushFollow(FOLLOW_listitem_in_list1086);
            	    listitem();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt15 >= 1 ) break loop15;
                        EarlyExitException eee =
                            new EarlyExitException(15, input);
                        throw eee;
                }
                cnt15++;
            } while (true);



                    value = ((list_scope)list_stack.peek()).values;
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            list_stack.pop();
        }
        return value;
    }
    // $ANTLR end "list"



    // $ANTLR start "listitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:376:1: listitem : exprimpl ;
    public final void listitem() throws RecognitionException {
        Object exprimpl32 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:376:9: ( exprimpl )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtExprTree.g:377:5: exprimpl
            {
            pushFollow(FOLLOW_exprimpl_in_listitem1102);
            exprimpl32=exprimpl();

            state._fsp--;



                    ((list_scope)list_stack.peek()).values.add( exprimpl32 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "listitem"

    // Delegated rules


 

    public static final BitSet FOLLOW_exprimpl_in_expr71 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEY_in_key97 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_key99 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KEY_in_key111 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_var_in_key113 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KEY_in_key125 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_keypath_in_key127 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypath161 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypath165 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_keypath169 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypath185 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypath189 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_keypath193 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypath209 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypath213 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_var_in_keypath215 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_keypathchild_in_keypath230 = new BitSet(new long[]{0x0000000000000002L,0x0000000020000000L});
    public static final BitSet FOLLOW_PATH_in_keypathchild246 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypathchild250 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_keypathchild254 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypathchild266 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypathchild270 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_keypathchild274 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypathchild286 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypathchild290 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_var_in_keypathchild292 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_STRING_in_valorvarobj310 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_valorvarobj320 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_valorvarobj330 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_valorvarobj340 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_valorvarobj350 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NULL_in_valorvarobj360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_valorvarobj370 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_datetime_in_valorvarobj380 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_key_in_valorvarobj390 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_geopt_in_valorvarobj400 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_user_in_valorvarobj410 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATE_in_datetime433 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_datetime437 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DATETIME_in_datetime449 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_datetime453 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_TIME_in_datetime465 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_datetime469 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DATE_in_datetime481 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intorvar_in_datetime485 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime489 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime493 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DATETIME_in_datetime505 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intorvar_in_datetime509 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime513 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime517 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime521 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime525 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime529 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_TIME_in_datetime541 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intorvar_in_datetime545 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime549 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime553 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_GEOPT_in_geopt577 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_floatorvar_in_geopt581 = new BitSet(new long[]{0x0000002008000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_floatorvar_in_geopt585 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_USER_in_user609 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stringorvar_in_user613 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_INT_in_intorvar636 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_intorvar646 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_floatorvar668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_floatorvar678 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_floatorvar688 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_stringorvar711 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_stringorvar721 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VARID_in_var743 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_prop765 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_prop775 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROP_in_property793 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ids_in_property795 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PROP_in_property807 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_property809 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ID_in_ids849 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_ids2_in_ids857 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_ID_in_ids2875 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_exprimpl897 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl901 = new BitSet(new long[]{0x18120C204C018000L,0x000000005E0121A0L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl905 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_UMINUS_in_exprimpl917 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl921 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MINUS_in_exprimpl933 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl937 = new BitSet(new long[]{0x18120C204C018000L,0x000000005E0121A0L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl941 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MUL_in_exprimpl953 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl957 = new BitSet(new long[]{0x18120C204C018000L,0x000000005E0121A0L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl961 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DIV_in_exprimpl973 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl977 = new BitSet(new long[]{0x18120C204C018000L,0x000000005E0121A0L});
    public static final BitSet FOLLOW_exprimpl_in_exprimpl981 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_valorvarobj_in_exprimpl994 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_exprimpl1004 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_exprimpl1014 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FUNC_in_exprimpl1025 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_list_in_exprimpl1031 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_LIST_in_exprimpl1044 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_list_in_exprimpl1046 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_listitem_in_list1086 = new BitSet(new long[]{0x18120C204C018002L,0x000000005E0121A0L});
    public static final BitSet FOLLOW_exprimpl_in_listitem1102 = new BitSet(new long[]{0x0000000000000002L});

}