// $ANTLR 3.4 /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g 2012-04-10 16:33:57

/*
 * Copyright 2010 Spolecne s.r.o. (www.spoledge.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.spoledge.audao.parser.gql.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import com.google.appengine.api.datastore.DatastoreService;
import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.FetchOptions;
import com.google.appengine.api.datastore.GeoPt;
import com.google.appengine.api.datastore.Key;
import com.google.appengine.api.datastore.KeyFactory;
import com.google.appengine.api.datastore.PreparedQuery;
import com.google.appengine.api.datastore.Query;

import com.google.appengine.api.users.User;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.spoledge.audao.parser.gql.impl.soft.*;
import static com.spoledge.audao.parser.gql.impl.ParserUtils.*;
import static com.spoledge.audao.parser.gql.impl.soft.SoftConstants.__KEY__;



import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked"})
public class GqlExtTree extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "A", "ANCESTOR", "AND", "AS", "ASC", "ASTERISK", "B", "BY", "C", "COMMA", "D", "DATE", "DATETIME", "DELETE", "DESC", "DOT", "DUAL", "E", "EMPTY", "EQ", "EXPONENT", "F", "FALSE", "FLOAT", "FROM", "G", "GEOPT", "H", "HEX_DIGIT", "I", "ID", "IN", "INSERT", "INT", "INTO", "IS", "J", "K", "KEY", "KEYPROP", "KIND", "L", "LEFT_PAR", "LIMIT", "M", "MINUS", "N", "NOT", "NULL", "O", "OFFSET", "OPER", "OR", "ORDER", "P", "PLUS", "PROP", "Q", "R", "RIGHT_PAR", "S", "SELECT", "SET", "SLASH", "SOFT", "STRING", "T", "TIME", "TRUE", "Tokens", "U", "UNINDEXED", "UPDATE", "USER", "V", "VALUES", "VARID", "VARNAME", "W", "WHERE", "WS", "X", "Y", "Z", "COLAS", "DIV", "FUNC", "LIST", "MUL", "PATH", "UMINUS"
    };

    public static final int EOF=-1;
    public static final int A=4;
    public static final int ANCESTOR=5;
    public static final int AND=6;
    public static final int AS=7;
    public static final int ASC=8;
    public static final int ASTERISK=9;
    public static final int B=10;
    public static final int BY=11;
    public static final int C=12;
    public static final int COMMA=13;
    public static final int D=14;
    public static final int DATE=15;
    public static final int DATETIME=16;
    public static final int DELETE=17;
    public static final int DESC=18;
    public static final int DOT=19;
    public static final int DUAL=20;
    public static final int E=21;
    public static final int EMPTY=22;
    public static final int EQ=23;
    public static final int EXPONENT=24;
    public static final int F=25;
    public static final int FALSE=26;
    public static final int FLOAT=27;
    public static final int FROM=28;
    public static final int G=29;
    public static final int GEOPT=30;
    public static final int H=31;
    public static final int HEX_DIGIT=32;
    public static final int I=33;
    public static final int ID=34;
    public static final int IN=35;
    public static final int INSERT=36;
    public static final int INT=37;
    public static final int INTO=38;
    public static final int IS=39;
    public static final int J=40;
    public static final int K=41;
    public static final int KEY=42;
    public static final int KEYPROP=43;
    public static final int KIND=44;
    public static final int L=45;
    public static final int LEFT_PAR=46;
    public static final int LIMIT=47;
    public static final int M=48;
    public static final int MINUS=49;
    public static final int N=50;
    public static final int NOT=51;
    public static final int NULL=52;
    public static final int O=53;
    public static final int OFFSET=54;
    public static final int OPER=55;
    public static final int OR=56;
    public static final int ORDER=57;
    public static final int P=58;
    public static final int PLUS=59;
    public static final int PROP=60;
    public static final int Q=61;
    public static final int R=62;
    public static final int RIGHT_PAR=63;
    public static final int S=64;
    public static final int SELECT=65;
    public static final int SET=66;
    public static final int SLASH=67;
    public static final int SOFT=68;
    public static final int STRING=69;
    public static final int T=70;
    public static final int TIME=71;
    public static final int TRUE=72;
    public static final int Tokens=73;
    public static final int U=74;
    public static final int UNINDEXED=75;
    public static final int UPDATE=76;
    public static final int USER=77;
    public static final int V=78;
    public static final int VALUES=79;
    public static final int VARID=80;
    public static final int VARNAME=81;
    public static final int W=82;
    public static final int WHERE=83;
    public static final int WS=84;
    public static final int X=85;
    public static final int Y=86;
    public static final int Z=87;
    public static final int COLAS=88;
    public static final int DIV=89;
    public static final int FUNC=90;
    public static final int LIST=91;
    public static final int MUL=92;
    public static final int PATH=93;
    public static final int UMINUS=94;

    // delegates
    public TreeParser[] getDelegates() {
        return new TreeParser[] {};
    }

    // delegators

    protected static class Query_scope {
        Query query;
        SoftCondition softCondition;
        boolean isAllColumns;
        boolean isKeyOnly;
        SoftColumn softKeyColumn;
        ArrayList<SoftColumn> softColumns;
        Integer limit;
        Integer offset;
        Iterable<Entity> nestedEntityIterable;
        String[] nestedColumnNames;
    }
    protected Stack Query_stack = new Stack();



    public GqlExtTree(TreeNodeStream input) {
        this(input, new RecognizerSharedState());
    }
    public GqlExtTree(TreeNodeStream input, RecognizerSharedState state) {
        super(input, state);
    }

    public String[] getTokenNames() { return GqlExtTree.tokenNames; }
    public String getGrammarFileName() { return "/Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g"; }



        private static final HashMap<String, Query.FilterOperator> OPERANDS = new HashMap<String, Query.FilterOperator>();

        static {
            OPERANDS.put( "=", Query.FilterOperator.EQUAL );
            OPERANDS.put( ">", Query.FilterOperator.GREATER_THAN );
            OPERANDS.put( ">=", Query.FilterOperator.GREATER_THAN_OR_EQUAL );
            OPERANDS.put( "<", Query.FilterOperator.LESS_THAN );
            OPERANDS.put( "<=", Query.FilterOperator.LESS_THAN_OR_EQUAL );
            OPERANDS.put( "!=", Query.FilterOperator.NOT_EQUAL );
            OPERANDS.put( "IN", Query.FilterOperator.IN );
        }

        /**
         * The logger.
         */
        private Log log = LogFactory.getLog( getClass());

        private RecognitionException firstError;
        private DatastoreService ds;
        private Object[] args;
        private int recordCounter;
        private Iterable<Entity> topEntityIterable;
        private String[] topColumnNames;


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods
        ////////////////////////////////////////////////////////////////////////////

        @Override
        public void reportError(RecognitionException e) {
            if (firstError == null) firstError = e;
            super.reportError( e );
        }


        /**
         * Returns the result iterable.
         * Only valid for SELECT QueryType.
         */
        public Iterable<Entity> getEntityIterable() {
            return topEntityIterable;
        }


        /**
         * Returns the known columns names.
         * Only valid for SELECT QueryType.
         * @return the column names or null if not known
         */
        public String[] getColumnNames() {
            return topColumnNames;
        }


        /**
         * Returns the number of records last updated/deleted.
         */
        public int getRecordCounter() {
            return recordCounter;
        }


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods - private
        ////////////////////////////////////////////////////////////////////////////

        private Iterable<Entity> dual() {
            return new Iterable<Entity>() {
                public Iterator<Entity> iterator() {
                    return new Iterator<Entity>() {
                        private boolean hasNext = true;

                        public boolean hasNext() {
                            return hasNext;
                        }

                        public Entity next() {
                            if (!hasNext) throw new java.util.NoSuchElementException();
                            hasNext = false;

                            return new Entity("__DUAL__");
                        }

                        public void remove() {
                        }
                    };
                }
            };
        }


        /**
         * Returns the FetchOptions.
         */
        private FetchOptions fetchOptions( Integer offset, Integer limit ) {
            FetchOptions ret = FetchOptions.Builder.withOffset( offset != null ? offset : 0);

            if (limit != null) {
                ret = ret.limit( limit );
            }

            return ret;
        }


        private boolean softFilter( SoftCondition softCondition, Entity ent ) {
            if (softCondition == null) return true;

            return softCondition.getConditionValue( args, ent );
        }


        private Object arg(int pos) {
            if (args == null) {
                // when passing 'null' - it is treated as (Object[])
                if (pos == 1) return null;
            }
            else if (pos <= args.length) return args[ pos - 1 ];

            log.error("arg(): no such parameter ':" + pos + "'");

            throw new RuntimeException("No such parameter ':" + pos + "'");
        }


        ////////////////////////////////////////////////////////////////////////////
        // Dynamically generated methods
        ////////////////////////////////////////////////////////////////////////////



    // $ANTLR start "gqlext"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:218:1: gqlext[DatastoreService ds, Object[] args] returns [Query value] : ( gql_select | gql_insert | gql_update | gql_delete );
    public final Query gqlext(DatastoreService ds, Object[] args) throws RecognitionException {
        Query value = null;


        GqlExtTree.gql_select_return gql_select1 =null;



                this.ds = ds;
                this.args = args;
                topEntityIterable = null;
                topColumnNames = null;
                recordCounter = 0;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:226:5: ( gql_select | gql_insert | gql_update | gql_delete )
            int alt1=4;
            switch ( input.LA(1) ) {
            case SELECT:
                {
                alt1=1;
                }
                break;
            case INSERT:
                {
                alt1=2;
                }
                break;
            case UPDATE:
                {
                alt1=3;
                }
                break;
            case DELETE:
                {
                alt1=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;

            }

            switch (alt1) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:226:7: gql_select
                    {
                    pushFollow(FOLLOW_gql_select_in_gqlext78);
                    gql_select1=gql_select();

                    state._fsp--;



                            topEntityIterable = (gql_select1!=null?gql_select1.value:null);
                            topColumnNames = (gql_select1!=null?gql_select1.columnNames:null);
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:230:7: gql_insert
                    {
                    pushFollow(FOLLOW_gql_insert_in_gqlext88);
                    gql_insert();

                    state._fsp--;


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:230:20: gql_update
                    {
                    pushFollow(FOLLOW_gql_update_in_gqlext92);
                    gql_update();

                    state._fsp--;


                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:230:33: gql_delete
                    {
                    pushFollow(FOLLOW_gql_delete_in_gqlext96);
                    gql_delete();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving

                    if (getNumberOfSyntaxErrors() != 0) throw firstError;
                
        }
        return value;
    }
    // $ANTLR end "gqlext"


    public static class gql_select_return extends TreeRuleReturnScope {
        public Iterable<Entity> value;
        public String[] columnNames;
    };


    // $ANTLR start "gql_select"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:236:1: gql_select returns [Iterable<Entity> value, String[] columnNames] : ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final GqlExtTree.gql_select_return gql_select() throws RecognitionException {
        Query_stack.push(new Query_scope());

        GqlExtTree.gql_select_return retval = new GqlExtTree.gql_select_return();
        retval.start = input.LT(1);


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:238:5: ( ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:5: ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? )
            {
            match(input,SELECT,FOLLOW_SELECT_in_gql_select135); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_kindorquery_in_gql_select137);
            kindorquery();

            state._fsp--;


            pushFollow(FOLLOW_get_properties_in_gql_select139);
            get_properties();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:41: ( where )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==WHERE) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:41: where
                    {
                    pushFollow(FOLLOW_where_in_gql_select141);
                    where();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:48: ( orderby )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==ORDER) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:48: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_select144);
                    orderby();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:57: ( limit )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==LIMIT) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:57: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_select147);
                    limit();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:64: ( offset )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==OFFSET) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:239:64: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_select150);
                    offset();

                    state._fsp--;


                    }
                    break;

            }


            match(input, Token.UP, null); 



                    if (((Query_scope)Query_stack.peek()).isKeyOnly && ((Query_scope)Query_stack.peek()).nestedEntityIterable == null) ((Query_scope)Query_stack.peek()).query.setKeysOnly();

                    final Iterable<Entity> nestedEntityIterable = ((Query_scope)Query_stack.peek()).nestedEntityIterable;
                    final PreparedQuery pq = nestedEntityIterable == null ? ds.prepare( ((Query_scope)Query_stack.peek()).query ) : null;
                    final boolean isAllColumns = ((Query_scope)Query_stack.peek()).isAllColumns;
                    final SoftColumn softKeyColumn = ((Query_scope)Query_stack.peek()).softKeyColumn;
                    final ArrayList<SoftColumn> softColumns = ((Query_scope)Query_stack.peek()).softColumns;
                    final SoftCondition softCondition = ((Query_scope)Query_stack.peek()).softCondition;
                    final Integer offset = ((Query_scope)Query_stack.peek()).offset;
                    final Integer limit = ((Query_scope)Query_stack.peek()).limit;

                    retval.value = new Iterable<Entity>() {
                        public Iterator<Entity> iterator() {
                            return new SoftEntityIterator(
                                            isAllColumns,
                                            softKeyColumn,
                                            softColumns,
                                            pq != null ?
                                                pq.asIterator( fetchOptions( offset, limit)) :
                                                nestedEntityIterable.iterator(),
                                            softCondition,
                                            pq == null ? offset : null,
                                            pq == null ? limit : null,
                                            args );
                        }
                    };

                    if (isAllColumns) {
                        retval.columnNames = ((Query_scope)Query_stack.peek()).nestedColumnNames;
                    }
                    else if (((Query_scope)Query_stack.peek()).isKeyOnly) {
                        retval.columnNames = new String[]{ __KEY__ };
                    }
                    else if (softColumns != null) {
                        retval.columnNames = new String[ softColumns.size() ];
                        int i=0;
                        for (SoftColumn sc : softColumns) {
                            retval.columnNames[i++] = sc.getColumnName();
                        }
                    }
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            Query_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "gql_select"



    // $ANTLR start "gql_select_one"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:283:1: gql_select_one returns [Iterable<?> value] : ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final Iterable<?> gql_select_one() throws RecognitionException {
        Query_stack.push(new Query_scope());

        Iterable<?> value = null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:285:5: ( ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:5: ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? )
            {
            match(input,SELECT,FOLLOW_SELECT_in_gql_select_one185); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_kindorquery_in_gql_select_one187);
            kindorquery();

            state._fsp--;


            pushFollow(FOLLOW_get_properties_in_gql_select_one189);
            get_properties();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:41: ( where )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==WHERE) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:41: where
                    {
                    pushFollow(FOLLOW_where_in_gql_select_one191);
                    where();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:48: ( orderby )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==ORDER) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:48: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_select_one194);
                    orderby();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:57: ( limit )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==LIMIT) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:57: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_select_one197);
                    limit();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:64: ( offset )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==OFFSET) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:286:64: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_select_one200);
                    offset();

                    state._fsp--;


                    }
                    break;

            }


            match(input, Token.UP, null); 



                    if (((Query_scope)Query_stack.peek()).isKeyOnly && ((Query_scope)Query_stack.peek()).nestedEntityIterable == null) ((Query_scope)Query_stack.peek()).query.setKeysOnly();

                    final Iterable<Entity> nestedEntityIterable = ((Query_scope)Query_stack.peek()).nestedEntityIterable;
                    final PreparedQuery pq = nestedEntityIterable == null ? ds.prepare( ((Query_scope)Query_stack.peek()).query ) : null;
                    final boolean isAllColumns = ((Query_scope)Query_stack.peek()).isAllColumns;
                    final SoftColumn softKeyColumn = ((Query_scope)Query_stack.peek()).softKeyColumn;
                    final ArrayList<SoftColumn> softColumns = ((Query_scope)Query_stack.peek()).softColumns;
                    final SoftCondition softCondition = ((Query_scope)Query_stack.peek()).softCondition;
                    final Integer offset = ((Query_scope)Query_stack.peek()).offset;
                    final Integer limit = ((Query_scope)Query_stack.peek()).limit;

                    if (((Query_scope)Query_stack.peek()).isKeyOnly) {
                        value = new Iterable<Key>() {
                            public Iterator<Key> iterator() {
                                return new SoftKeyIterator(
                                                softKeyColumn,
                                                pq != null ?
                                                    pq.asIterator( fetchOptions( offset, limit)) :
                                                    nestedEntityIterable.iterator(),
                                                softCondition,
                                                pq == null ? offset : null,
                                                pq == null ? limit : null,
                                                args );
                            }
                        };
                    }
                    else {
                        value = new Iterable<Object>() {
                            public Iterator<Object> iterator() {
                                return new SoftPropertyIterator(
                                                softColumns.get(0),
                                                pq != null ?
                                                    pq.asIterator( fetchOptions( offset, limit)) :
                                                    nestedEntityIterable.iterator(),
                                                softCondition,
                                                pq == null ? offset : null,
                                                pq == null ? limit : null,
                                                args );
                            }
                        };
                    }
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            Query_stack.pop();

        }
        return value;
    }
    // $ANTLR end "gql_select_one"


    protected static class gql_insert_scope {
        ArrayList<SoftColumn> columns;
        ArrayList<SoftColumn> values;
        int keyIndex;
    }
    protected Stack gql_insert_stack = new Stack();



    // $ANTLR start "gql_insert"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:331:1: gql_insert : ^( INSERT kin= kindless columns values ) ;
    public final void gql_insert() throws RecognitionException {
        gql_insert_stack.push(new gql_insert_scope());
        String kin =null;



                ((gql_insert_scope)gql_insert_stack.peek()).columns = new ArrayList<SoftColumn>();
                ((gql_insert_scope)gql_insert_stack.peek()).values = new ArrayList<SoftColumn>();
                ((gql_insert_scope)gql_insert_stack.peek()).keyIndex = -1;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:342:5: ( ^( INSERT kin= kindless columns values ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:343:5: ^( INSERT kin= kindless columns values )
            {
            match(input,INSERT,FOLLOW_INSERT_in_gql_insert238); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_kindless_in_gql_insert242);
            kin=kindless();

            state._fsp--;


            pushFollow(FOLLOW_columns_in_gql_insert244);
            columns();

            state._fsp--;


            pushFollow(FOLLOW_values_in_gql_insert246);
            values();

            state._fsp--;


            match(input, Token.UP, null); 



                    Entity ent = null;
                    if (((gql_insert_scope)gql_insert_stack.peek()).keyIndex != -1) {
                        ent = new Entity( ((gql_insert_scope)gql_insert_stack.peek()).values.get(((gql_insert_scope)gql_insert_stack.peek()).keyIndex).getValueKey( true, args, null ));
                    }
                    else ent = new Entity( kin );

                    for (int i=0; i < ((gql_insert_scope)gql_insert_stack.peek()).values.size(); i++) {
                        if ( i == ((gql_insert_scope)gql_insert_stack.peek()).keyIndex ) continue;
                        SoftColumn sc = ((gql_insert_scope)gql_insert_stack.peek()).values.get(i );
                        String columnName = sc.getColumnName();
                        Object val = sc.getValue( args );

                        if (val == null) {
                            if (sc.isUnindexed() || sc.isEmpty()) continue;
                            ent.setProperty( columnName, null );
                        }
                        else if (sc.isUnindexed()) {
                            ent.setUnindexedProperty( columnName, val );
                        }
                        else ent.setProperty( columnName, val );
                    }

                    ds.put( ent );

                    recordCounter++;
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            gql_insert_stack.pop();
        }
        return ;
    }
    // $ANTLR end "gql_insert"


    protected static class gql_update_scope {
        ArrayList<SoftColumnExpr> changes;
    }
    protected Stack gql_update_stack = new Stack();



    // $ANTLR start "gql_update"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:372:1: gql_update : ^( UPDATE kindquery set_properties ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final void gql_update() throws RecognitionException {
        Query_stack.push(new Query_scope());
        gql_update_stack.push(new gql_update_scope());

                ((gql_update_scope)gql_update_stack.peek()).changes = new ArrayList<SoftColumnExpr>();
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:380:5: ( ^( UPDATE kindquery set_properties ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:5: ^( UPDATE kindquery set_properties ( where )? ( orderby )? ( limit )? ( offset )? )
            {
            match(input,UPDATE,FOLLOW_UPDATE_in_gql_update293); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_kindquery_in_gql_update295);
            kindquery();

            state._fsp--;


            pushFollow(FOLLOW_set_properties_in_gql_update297);
            set_properties();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:39: ( where )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==WHERE) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:39: where
                    {
                    pushFollow(FOLLOW_where_in_gql_update299);
                    where();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:46: ( orderby )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==ORDER) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:46: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_update302);
                    orderby();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:55: ( limit )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==LIMIT) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:55: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_update305);
                    limit();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:62: ( offset )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==OFFSET) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:381:62: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_update308);
                    offset();

                    state._fsp--;


                    }
                    break;

            }


            match(input, Token.UP, null); 



                    PreparedQuery pq = ds.prepare( ((Query_scope)Query_stack.peek()).query );

                    for (Entity ent : pq.asIterable( fetchOptions( ((Query_scope)Query_stack.peek()).offset, ((Query_scope)Query_stack.peek()).limit ))) {
                        if (!softFilter( ((Query_scope)Query_stack.peek()).softCondition, ent )) continue;

                        for (SoftColumn sc : ((gql_update_scope)gql_update_stack.peek()).changes) {
                            String columnName = sc.getColumnName();
                            Object val = sc.getValue( args, ent );

                            if (val == null) {
                                if (sc.isUnindexed() || sc.isEmpty()) ent.removeProperty( columnName );
                                else ent.setProperty( columnName, null );
                            }
                            else if (sc.isUnindexed()) {
                                ent.setUnindexedProperty( columnName, val );
                            }
                            else ent.setProperty( columnName, val );
                        }

                        ds.put( ent );

                        recordCounter++;
                    }
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            Query_stack.pop();
            gql_update_stack.pop();
        }
        return ;
    }
    // $ANTLR end "gql_update"



    // $ANTLR start "gql_delete"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:408:1: gql_delete : ^( DELETE kindquery ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final void gql_delete() throws RecognitionException {
        Query_stack.push(new Query_scope());

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:410:5: ( ^( DELETE kindquery ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:5: ^( DELETE kindquery ( where )? ( orderby )? ( limit )? ( offset )? )
            {
            match(input,DELETE,FOLLOW_DELETE_in_gql_delete339); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_kindquery_in_gql_delete341);
            kindquery();

            state._fsp--;


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:24: ( where )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==WHERE) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:24: where
                    {
                    pushFollow(FOLLOW_where_in_gql_delete343);
                    where();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:31: ( orderby )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==ORDER) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:31: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_delete346);
                    orderby();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:40: ( limit )?
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==LIMIT) ) {
                alt16=1;
            }
            switch (alt16) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:40: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_delete349);
                    limit();

                    state._fsp--;


                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:47: ( offset )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==OFFSET) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:411:47: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_delete352);
                    offset();

                    state._fsp--;


                    }
                    break;

            }


            match(input, Token.UP, null); 



                    ((Query_scope)Query_stack.peek()).query.setKeysOnly();
                    PreparedQuery pq = ds.prepare( ((Query_scope)Query_stack.peek()).query );

                    for (Entity ent : pq.asIterable( fetchOptions( ((Query_scope)Query_stack.peek()).offset, ((Query_scope)Query_stack.peek()).limit))) {
                        if (!softFilter( ((Query_scope)Query_stack.peek()).softCondition, ent )) continue;
                        ds.delete( ent.getKey());
                        recordCounter++;
                    }
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            Query_stack.pop();

        }
        return ;
    }
    // $ANTLR end "gql_delete"



    // $ANTLR start "kindorquery"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:423:1: kindorquery : ( kindquery | DUAL | gql_select );
    public final void kindorquery() throws RecognitionException {
        GqlExtTree.gql_select_return gql_select2 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:423:12: ( kindquery | DUAL | gql_select )
            int alt18=3;
            switch ( input.LA(1) ) {
            case KIND:
                {
                alt18=1;
                }
                break;
            case DUAL:
                {
                alt18=2;
                }
                break;
            case SELECT:
                {
                alt18=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;

            }

            switch (alt18) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:424:5: kindquery
                    {
                    pushFollow(FOLLOW_kindquery_in_kindorquery368);
                    kindquery();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:425:7: DUAL
                    {
                    match(input,DUAL,FOLLOW_DUAL_in_kindorquery376); 


                            ((Query_scope)Query_stack.peek()).nestedEntityIterable = dual();
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:428:7: gql_select
                    {
                    pushFollow(FOLLOW_gql_select_in_kindorquery386);
                    gql_select2=gql_select();

                    state._fsp--;



                            ((Query_scope)Query_stack.peek()).nestedEntityIterable = (gql_select2!=null?gql_select2.value:null);
                            ((Query_scope)Query_stack.peek()).nestedColumnNames = (gql_select2!=null?gql_select2.columnNames:null);
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "kindorquery"



    // $ANTLR start "get_properties"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:434:1: get_properties : ^( PROP ( get_property )+ ) ;
    public final void get_properties() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:434:15: ( ^( PROP ( get_property )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:435:5: ^( PROP ( get_property )+ )
            {
            match(input,PROP,FOLLOW_PROP_in_get_properties401); 

            match(input, Token.DOWN, null); 
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:435:12: ( get_property )+
            int cnt19=0;
            loop19:
            do {
                int alt19=2;
                int LA19_0 = input.LA(1);

                if ( (LA19_0==ASTERISK||LA19_0==KEYPROP||LA19_0==PROP||LA19_0==COLAS) ) {
                    alt19=1;
                }


                switch (alt19) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:435:12: get_property
            	    {
            	    pushFollow(FOLLOW_get_property_in_get_properties403);
            	    get_property();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt19 >= 1 ) break loop19;
                        EarlyExitException eee =
                            new EarlyExitException(19, input);
                        throw eee;
                }
                cnt19++;
            } while (true);


            match(input, Token.UP, null); 


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "get_properties"



    // $ANTLR start "get_property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:438:1: get_property : ( ASTERISK | KEYPROP | property | ^( COLAS alias expr= . ) );
    public final void get_property() throws RecognitionException {
        CommonTree expr=null;
        String property3 =null;

        GqlExtTree.alias_return alias4 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:438:13: ( ASTERISK | KEYPROP | property | ^( COLAS alias expr= . ) )
            int alt20=4;
            switch ( input.LA(1) ) {
            case ASTERISK:
                {
                alt20=1;
                }
                break;
            case KEYPROP:
                {
                alt20=2;
                }
                break;
            case PROP:
                {
                alt20=3;
                }
                break;
            case COLAS:
                {
                alt20=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;

            }

            switch (alt20) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:439:5: ASTERISK
                    {
                    match(input,ASTERISK,FOLLOW_ASTERISK_in_get_property417); 


                            ((Query_scope)Query_stack.peek()).isAllColumns = true;
                            ((Query_scope)Query_stack.peek()).isKeyOnly = false;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:443:7: KEYPROP
                    {
                    match(input,KEYPROP,FOLLOW_KEYPROP_in_get_property427); 


                            if (!((Query_scope)Query_stack.peek()).isAllColumns && ((Query_scope)Query_stack.peek()).softColumns == null) ((Query_scope)Query_stack.peek()).isKeyOnly = true;
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:446:7: property
                    {
                    pushFollow(FOLLOW_property_in_get_property437);
                    property3=property();

                    state._fsp--;



                            if (((Query_scope)Query_stack.peek()).softColumns == null) {
                                ((Query_scope)Query_stack.peek()).softColumns = new ArrayList<SoftColumn>();
                            }

                            ((Query_scope)Query_stack.peek()).softColumns.add( new SoftColumn( property3 ));
                            ((Query_scope)Query_stack.peek()).isKeyOnly = false;
                        

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:454:7: ^( COLAS alias expr= . )
                    {
                    match(input,COLAS,FOLLOW_COLAS_in_get_property448); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_alias_in_get_property450);
                    alias4=alias();

                    state._fsp--;


                    expr=(CommonTree)input.LT(1);

                    matchAny(input); 

                    match(input, Token.UP, null); 



                            SoftColumnExpr sce = new SoftColumnExpr( expr, (alias4!=null?alias4.value:null), (alias4!=null?alias4.isUnindexed:false), (alias4!=null?alias4.isEmpty:false) );

                            if (__KEY__.equals( (alias4!=null?alias4.value:null) )) {
                                if (!((Query_scope)Query_stack.peek()).isAllColumns && ((Query_scope)Query_stack.peek()).softColumns == null) ((Query_scope)Query_stack.peek()).isKeyOnly = true;
                                ((Query_scope)Query_stack.peek()).softKeyColumn = sce;
                            }
                            else {
                                if (((Query_scope)Query_stack.peek()).softColumns == null) {
                                    ((Query_scope)Query_stack.peek()).softColumns = new ArrayList<SoftColumn>();
                                }

                                ((Query_scope)Query_stack.peek()).softColumns.add( sce );
                                ((Query_scope)Query_stack.peek()).isKeyOnly = false;
                            }

                            if (log.isDebugEnabled()) {
                                log.debug("column(): alias=" + (alias4!=null?alias4.value:null) + ", tree=" + expr.toStringTree());
                            }
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "get_property"


    public static class alias_return extends TreeRuleReturnScope {
        public String value;
        public boolean isUnindexed;
        public boolean isEmpty;
    };


    // $ANTLR start "alias"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:476:1: alias returns [String value, boolean isUnindexed, boolean isEmpty] : ( STRING | prop | ^( UNINDEXED STRING ) | ^( EMPTY STRING ) );
    public final GqlExtTree.alias_return alias() throws RecognitionException {
        GqlExtTree.alias_return retval = new GqlExtTree.alias_return();
        retval.start = input.LT(1);


        CommonTree STRING5=null;
        CommonTree STRING7=null;
        CommonTree STRING8=null;
        String prop6 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:476:66: ( STRING | prop | ^( UNINDEXED STRING ) | ^( EMPTY STRING ) )
            int alt21=4;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt21=1;
                }
                break;
            case KEYPROP:
            case PROP:
                {
                alt21=2;
                }
                break;
            case UNINDEXED:
                {
                alt21=3;
                }
                break;
            case EMPTY:
                {
                alt21=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;

            }

            switch (alt21) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:477:5: STRING
                    {
                    STRING5=(CommonTree)match(input,STRING,FOLLOW_STRING_in_alias472); 


                            retval.value = string( (STRING5!=null?STRING5.getText():null) );
                            retval.isUnindexed = false;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:481:7: prop
                    {
                    pushFollow(FOLLOW_prop_in_alias482);
                    prop6=prop();

                    state._fsp--;



                            retval.value = prop6;
                            retval.isUnindexed = false;
                            retval.isEmpty = false;
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:486:7: ^( UNINDEXED STRING )
                    {
                    match(input,UNINDEXED,FOLLOW_UNINDEXED_in_alias493); 

                    match(input, Token.DOWN, null); 
                    STRING7=(CommonTree)match(input,STRING,FOLLOW_STRING_in_alias495); 

                    match(input, Token.UP, null); 



                            retval.value = string( (STRING7!=null?STRING7.getText():null) );
                            retval.isUnindexed = true;
                            retval.isEmpty = false;
                        

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:491:7: ^( EMPTY STRING )
                    {
                    match(input,EMPTY,FOLLOW_EMPTY_in_alias507); 

                    match(input, Token.DOWN, null); 
                    STRING8=(CommonTree)match(input,STRING,FOLLOW_STRING_in_alias509); 

                    match(input, Token.UP, null); 



                            retval.value = string( (STRING8!=null?STRING8.getText():null) );
                            retval.isUnindexed = false;
                            retval.isEmpty = true;
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "alias"



    // $ANTLR start "columns"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:498:1: columns : ^( COLAS ( column )+ ) ;
    public final void columns() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:498:8: ( ^( COLAS ( column )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:499:5: ^( COLAS ( column )+ )
            {
            match(input,COLAS,FOLLOW_COLAS_in_columns525); 

            match(input, Token.DOWN, null); 
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:499:13: ( column )+
            int cnt22=0;
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);

                if ( (LA22_0==EMPTY||LA22_0==KEYPROP||LA22_0==PROP||LA22_0==STRING||LA22_0==UNINDEXED) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:499:13: column
            	    {
            	    pushFollow(FOLLOW_column_in_columns527);
            	    column();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt22 >= 1 ) break loop22;
                        EarlyExitException eee =
                            new EarlyExitException(22, input);
                        throw eee;
                }
                cnt22++;
            } while (true);


            match(input, Token.UP, null); 


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "columns"



    // $ANTLR start "values"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:502:1: values : ^( VALUES ( value )+ ) ;
    public final void values() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:502:7: ( ^( VALUES ( value )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:503:5: ^( VALUES ( value )+ )
            {
            match(input,VALUES,FOLLOW_VALUES_in_values542); 

            match(input, Token.DOWN, null); 
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:503:14: ( value )+
            int cnt23=0;
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( ((LA23_0 >= A && LA23_0 <= UMINUS)) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:503:14: value
            	    {
            	    pushFollow(FOLLOW_value_in_values544);
            	    value();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt23 >= 1 ) break loop23;
                        EarlyExitException eee =
                            new EarlyExitException(23, input);
                        throw eee;
                }
                cnt23++;
            } while (true);


            match(input, Token.UP, null); 


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "values"



    // $ANTLR start "column"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:506:1: column : alias ;
    public final void column() throws RecognitionException {
        GqlExtTree.alias_return alias9 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:506:7: ( alias )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:507:5: alias
            {
            pushFollow(FOLLOW_alias_in_column559);
            alias9=alias();

            state._fsp--;



                    if (__KEY__.equals( (alias9!=null?alias9.value:null) )) {
                        ((gql_insert_scope)gql_insert_stack.peek()).keyIndex = ((gql_insert_scope)gql_insert_stack.peek()).columns.size();
                    }
                    ((gql_insert_scope)gql_insert_stack.peek()).columns.add( new SoftColumn( (alias9!=null?alias9.value:null), (alias9!=null?alias9.isUnindexed:false), (alias9!=null?alias9.isEmpty:false)));
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "column"



    // $ANTLR start "value"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:515:1: value : expr= . ;
    public final void value() throws RecognitionException {
        CommonTree expr=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:515:6: (expr= . )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:516:5: expr= .
            {
            expr=(CommonTree)input.LT(1);

            matchAny(input); 


                    SoftColumn sc = ((gql_insert_scope)gql_insert_stack.peek()).columns.get( ((gql_insert_scope)gql_insert_stack.peek()).values.size());
                    ((gql_insert_scope)gql_insert_stack.peek()).values.add( new SoftColumnExpr( expr, sc ));
                    if (false) throw new RecognitionException(); // fake to fuck compiler
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "value"



    // $ANTLR start "set_properties"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:523:1: set_properties : ^( SET ( set_property )+ ) ;
    public final void set_properties() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:523:15: ( ^( SET ( set_property )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:524:5: ^( SET ( set_property )+ )
            {
            match(input,SET,FOLLOW_SET_in_set_properties591); 

            match(input, Token.DOWN, null); 
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:524:11: ( set_property )+
            int cnt24=0;
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==EQ) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:524:11: set_property
            	    {
            	    pushFollow(FOLLOW_set_property_in_set_properties593);
            	    set_property();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt24 >= 1 ) break loop24;
                        EarlyExitException eee =
                            new EarlyExitException(24, input);
                        throw eee;
                }
                cnt24++;
            } while (true);


            match(input, Token.UP, null); 


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "set_properties"



    // $ANTLR start "set_property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:527:1: set_property : ^( EQ alias expr= . ) ;
    public final void set_property() throws RecognitionException {
        CommonTree expr=null;
        GqlExtTree.alias_return alias10 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:527:13: ( ^( EQ alias expr= . ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:528:5: ^( EQ alias expr= . )
            {
            match(input,EQ,FOLLOW_EQ_in_set_property608); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_alias_in_set_property610);
            alias10=alias();

            state._fsp--;


            expr=(CommonTree)input.LT(1);

            matchAny(input); 

            match(input, Token.UP, null); 



                    ((gql_update_scope)gql_update_stack.peek()).changes.add( new SoftColumnExpr( expr, (alias10!=null?alias10.value:null), (alias10!=null?alias10.isUnindexed:false), (alias10!=null?alias10.isEmpty:false) ));
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "set_property"



    // $ANTLR start "where"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:533:1: where : ^( WHERE ( condition )* ( softwhere )? ) ;
    public final void where() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:533:6: ( ^( WHERE ( condition )* ( softwhere )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:534:5: ^( WHERE ( condition )* ( softwhere )? )
            {
            match(input,WHERE,FOLLOW_WHERE_in_where630); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:534:13: ( condition )*
                loop25:
                do {
                    int alt25=2;
                    int LA25_0 = input.LA(1);

                    if ( (LA25_0==ANCESTOR||LA25_0==EQ||LA25_0==IN||LA25_0==OPER) ) {
                        alt25=1;
                    }


                    switch (alt25) {
                	case 1 :
                	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:534:13: condition
                	    {
                	    pushFollow(FOLLOW_condition_in_where632);
                	    condition();

                	    state._fsp--;


                	    }
                	    break;

                	default :
                	    break loop25;
                    }
                } while (true);


                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:534:24: ( softwhere )?
                int alt26=2;
                int LA26_0 = input.LA(1);

                if ( (LA26_0==SOFT) ) {
                    alt26=1;
                }
                switch (alt26) {
                    case 1 :
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:534:24: softwhere
                        {
                        pushFollow(FOLLOW_softwhere_in_where635);
                        softwhere();

                        state._fsp--;


                        }
                        break;

                }


                match(input, Token.UP, null); 
            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "where"



    // $ANTLR start "softwhere"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:537:1: softwhere : SOFT sc= softcondition ;
    public final void softwhere() throws RecognitionException {
        SoftCondition sc =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:537:10: ( SOFT sc= softcondition )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:538:5: SOFT sc= softcondition
            {
            match(input,SOFT,FOLLOW_SOFT_in_softwhere649); 

            pushFollow(FOLLOW_softcondition_in_softwhere653);
            sc=softcondition();

            state._fsp--;



                    ((Query_scope)Query_stack.peek()).softCondition = sc;
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "softwhere"



    // $ANTLR start "softcondition"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:543:1: softcondition returns [SoftCondition value] : ( ^( AND sc1= softcondition sc2= softcondition ) | ^( OR sc1= softcondition sc2= softcondition ) | ^( NOT sc= softcondition ) | ^( oper expr1= . expr2= . ) | ^( IN expr1= . gql_select_one ) | ^( IN expr1= . ^(expr3= LIST ( . )* ) ) | ^( IN expr1= . var ) | ^( ANCESTOR expr= . ) );
    public final SoftCondition softcondition() throws RecognitionException {
        SoftCondition value = null;


        CommonTree expr3=null;
        CommonTree expr1=null;
        CommonTree expr2=null;
        CommonTree expr=null;
        SoftCondition sc1 =null;

        SoftCondition sc2 =null;

        SoftCondition sc =null;

        String oper11 =null;

        Iterable<?> gql_select_one12 =null;

        Object var13 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:543:43: ( ^( AND sc1= softcondition sc2= softcondition ) | ^( OR sc1= softcondition sc2= softcondition ) | ^( NOT sc= softcondition ) | ^( oper expr1= . expr2= . ) | ^( IN expr1= . gql_select_one ) | ^( IN expr1= . ^(expr3= LIST ( . )* ) ) | ^( IN expr1= . var ) | ^( ANCESTOR expr= . ) )
            int alt28=8;
            alt28 = dfa28.predict(input);
            switch (alt28) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:544:5: ^( AND sc1= softcondition sc2= softcondition )
                    {
                    match(input,AND,FOLLOW_AND_in_softcondition671); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_softcondition_in_softcondition675);
                    sc1=softcondition();

                    state._fsp--;


                    pushFollow(FOLLOW_softcondition_in_softcondition679);
                    sc2=softcondition();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = new SoftCondAnd( sc1, sc2 );
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:547:7: ^( OR sc1= softcondition sc2= softcondition )
                    {
                    match(input,OR,FOLLOW_OR_in_softcondition691); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_softcondition_in_softcondition695);
                    sc1=softcondition();

                    state._fsp--;


                    pushFollow(FOLLOW_softcondition_in_softcondition699);
                    sc2=softcondition();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = new SoftCondOr( sc1, sc2 );
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:550:7: ^( NOT sc= softcondition )
                    {
                    match(input,NOT,FOLLOW_NOT_in_softcondition711); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_softcondition_in_softcondition715);
                    sc=softcondition();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = new SoftCondNot( sc );
                        

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:553:7: ^( oper expr1= . expr2= . )
                    {
                    pushFollow(FOLLOW_oper_in_softcondition727);
                    oper11=oper();

                    state._fsp--;


                    match(input, Token.DOWN, null); 
                    expr1=(CommonTree)input.LT(1);

                    matchAny(input); 

                    expr2=(CommonTree)input.LT(1);

                    matchAny(input); 

                    match(input, Token.UP, null); 



                            value = new SoftCondOper( new SoftColumnExpr( expr1 ), new SoftColumnExpr( expr2 ), oper11 );
                        

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:556:7: ^( IN expr1= . gql_select_one )
                    {
                    match(input,IN,FOLLOW_IN_in_softcondition747); 

                    match(input, Token.DOWN, null); 
                    expr1=(CommonTree)input.LT(1);

                    matchAny(input); 

                    pushFollow(FOLLOW_gql_select_one_in_softcondition753);
                    gql_select_one12=gql_select_one();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = new SoftCondIn( new SoftColumnExpr( expr1 ), gql_select_one12 );
                        

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:559:7: ^( IN expr1= . ^(expr3= LIST ( . )* ) )
                    {
                    match(input,IN,FOLLOW_IN_in_softcondition765); 

                    match(input, Token.DOWN, null); 
                    expr1=(CommonTree)input.LT(1);

                    matchAny(input); 

                    expr3=(CommonTree)match(input,LIST,FOLLOW_LIST_in_softcondition774); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:559:33: ( . )*
                        loop27:
                        do {
                            int alt27=2;
                            int LA27_0 = input.LA(1);

                            if ( ((LA27_0 >= A && LA27_0 <= UMINUS)) ) {
                                alt27=1;
                            }
                            else if ( (LA27_0==UP) ) {
                                alt27=2;
                            }


                            switch (alt27) {
                        	case 1 :
                        	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:559:33: .
                        	    {
                        	    matchAny(input); 

                        	    }
                        	    break;

                        	default :
                        	    break loop27;
                            }
                        } while (true);


                        match(input, Token.UP, null); 
                    }


                    match(input, Token.UP, null); 



                            value = new SoftCondIn( new SoftColumnExpr( expr1 ), new SoftColumnExpr( expr3 ));
                        

                    }
                    break;
                case 7 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:562:7: ^( IN expr1= . var )
                    {
                    match(input,IN,FOLLOW_IN_in_softcondition790); 

                    match(input, Token.DOWN, null); 
                    expr1=(CommonTree)input.LT(1);

                    matchAny(input); 

                    pushFollow(FOLLOW_var_in_softcondition796);
                    var13=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = new SoftCondIn( new SoftColumnExpr( expr1 ), var13);
                        

                    }
                    break;
                case 8 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:565:7: ^( ANCESTOR expr= . )
                    {
                    match(input,ANCESTOR,FOLLOW_ANCESTOR_in_softcondition808); 

                    match(input, Token.DOWN, null); 
                    expr=(CommonTree)input.LT(1);

                    matchAny(input); 

                    match(input, Token.UP, null); 



                            value = new SoftCondAncestor( new SoftColumnExpr( expr ));
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "softcondition"



    // $ANTLR start "condition"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:570:1: condition : ( cond | condkey | condancestor | condin );
    public final void condition() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:570:10: ( cond | condkey | condancestor | condin )
            int alt29=4;
            switch ( input.LA(1) ) {
            case OPER:
                {
                int LA29_1 = input.LA(2);

                if ( (LA29_1==DOWN) ) {
                    int LA29_5 = input.LA(3);

                    if ( (LA29_5==KEYPROP) ) {
                        alt29=2;
                    }
                    else if ( (LA29_5==PROP) ) {
                        alt29=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 29, 5, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 29, 1, input);

                    throw nvae;

                }
                }
                break;
            case EQ:
                {
                int LA29_2 = input.LA(2);

                if ( (LA29_2==DOWN) ) {
                    int LA29_5 = input.LA(3);

                    if ( (LA29_5==KEYPROP) ) {
                        alt29=2;
                    }
                    else if ( (LA29_5==PROP) ) {
                        alt29=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 29, 5, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 29, 2, input);

                    throw nvae;

                }
                }
                break;
            case ANCESTOR:
                {
                alt29=3;
                }
                break;
            case IN:
                {
                alt29=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;

            }

            switch (alt29) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:570:12: cond
                    {
                    pushFollow(FOLLOW_cond_in_condition823);
                    cond();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:570:19: condkey
                    {
                    pushFollow(FOLLOW_condkey_in_condition827);
                    condkey();

                    state._fsp--;


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:570:29: condancestor
                    {
                    pushFollow(FOLLOW_condancestor_in_condition831);
                    condancestor();

                    state._fsp--;


                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:570:44: condin
                    {
                    pushFollow(FOLLOW_condin_in_condition835);
                    condin();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condition"



    // $ANTLR start "cond"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:573:1: cond : ^( oper property vov= valorvarobj ) ;
    public final void cond() throws RecognitionException {
        Object vov =null;

        String oper14 =null;

        String property15 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:573:5: ( ^( oper property vov= valorvarobj ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:574:5: ^( oper property vov= valorvarobj )
            {
            pushFollow(FOLLOW_oper_in_cond848);
            oper14=oper();

            state._fsp--;


            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_property_in_cond850);
            property15=property();

            state._fsp--;


            pushFollow(FOLLOW_valorvarobj_in_cond854);
            vov=valorvarobj();

            state._fsp--;


            match(input, Token.UP, null); 



                    Query.FilterOperator oper = OPERANDS.get( oper14 );

                    if (log.isDebugEnabled()) {
                        if (vov != null && (vov instanceof Collection)) {
                            Collection col = (Collection)vov;

                            if (col.size() == 0) {
                                log.debug("query.addFilter( \"" + property15
                                    + "\", Query.FilterOperator." + oper.name() + ", null)");
                            }
                            else {
                                for (Object o : ((Collection)vov)) {
                                    log.debug("query.addFilter( \"" + property15
                                        + "\", Query.FilterOperator." + oper.name() + ", "
                                        + (o != null ?
                                            o.getClass().getName() + '(' + o + ')'
                                            : "null") + ')');
                                }

                            }
                        }
                        else {
                            log.debug("query.addFilter( \"" + property15
                                + "\", Query.FilterOperator." + oper.name() + ", "
                                + (vov != null ?
                                    vov.getClass().getName() + '(' + vov + ')'
                                    : "null") + ')');
                        }
                    }

                    if (vov != null && (vov instanceof Collection)) {
                        Collection col = (Collection)vov;

                        if (col.size() == 0) {
                            ((Query_scope)Query_stack.peek()).query.addFilter( property15, oper, null );
                        }
                        else {
                            for (Object o : col) {
                                ((Query_scope)Query_stack.peek()).query.addFilter( property15, oper, o );
                            }
                        }
                    }
                    else ((Query_scope)Query_stack.peek()).query.addFilter( property15, oper, vov );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "cond"



    // $ANTLR start "oper"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:622:1: oper returns [String value] : ( OPER | EQ );
    public final String oper() throws RecognitionException {
        String value = null;


        CommonTree OPER16=null;
        CommonTree EQ17=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:622:27: ( OPER | EQ )
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==OPER) ) {
                alt30=1;
            }
            else if ( (LA30_0==EQ) ) {
                alt30=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 30, 0, input);

                throw nvae;

            }
            switch (alt30) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:623:5: OPER
                    {
                    OPER16=(CommonTree)match(input,OPER,FOLLOW_OPER_in_oper877); 

                     value = (OPER16!=null?OPER16.getText():null); 

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:624:7: EQ
                    {
                    EQ17=(CommonTree)match(input,EQ,FOLLOW_EQ_in_oper887); 

                     value = (EQ17!=null?EQ17.getText():null); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "oper"



    // $ANTLR start "condkey"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:627:1: condkey : ^( oper KEYPROP key ) ;
    public final void condkey() throws RecognitionException {
        CommonTree KEYPROP18=null;
        String oper19 =null;

        Key key20 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:627:8: ( ^( oper KEYPROP key ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:628:5: ^( oper KEYPROP key )
            {
            pushFollow(FOLLOW_oper_in_condkey902);
            oper19=oper();

            state._fsp--;


            match(input, Token.DOWN, null); 
            KEYPROP18=(CommonTree)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkey904); 

            pushFollow(FOLLOW_key_in_condkey906);
            key20=key();

            state._fsp--;


            match(input, Token.UP, null); 



                    ((Query_scope)Query_stack.peek()).query.addFilter( (KEYPROP18!=null?KEYPROP18.getText():null), OPERANDS.get( oper19 ), key20 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condkey"



    // $ANTLR start "condancestor"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:633:1: condancestor : ^( ANCESTOR key ) ;
    public final void condancestor() throws RecognitionException {
        Key key21 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:633:13: ( ^( ANCESTOR key ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:634:5: ^( ANCESTOR key )
            {
            match(input,ANCESTOR,FOLLOW_ANCESTOR_in_condancestor922); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_key_in_condancestor924);
            key21=key();

            state._fsp--;


            match(input, Token.UP, null); 



                    ((Query_scope)Query_stack.peek()).query.setAncestor( key21 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condancestor"



    // $ANTLR start "condin"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:639:1: condin : ^( IN prop inval ) ;
    public final void condin() throws RecognitionException {
        String prop22 =null;

        Object inval23 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:639:7: ( ^( IN prop inval ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:640:5: ^( IN prop inval )
            {
            match(input,IN,FOLLOW_IN_in_condin940); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_prop_in_condin942);
            prop22=prop();

            state._fsp--;


            pushFollow(FOLLOW_inval_in_condin944);
            inval23=inval();

            state._fsp--;


            match(input, Token.UP, null); 



                    ((Query_scope)Query_stack.peek()).query.addFilter( prop22, Query.FilterOperator.IN, inval23 );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "condin"



    // $ANTLR start "inval"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:645:1: inval returns [Object value] : ( var | inlist | gql_select_one );
    public final Object inval() throws RecognitionException {
        Object value = null;


        Object var24 =null;

        ArrayList inlist25 =null;

        Iterable<?> gql_select_one26 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:645:28: ( var | inlist | gql_select_one )
            int alt31=3;
            switch ( input.LA(1) ) {
            case VARID:
                {
                alt31=1;
                }
                break;
            case LIST:
                {
                alt31=2;
                }
                break;
            case SELECT:
                {
                alt31=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 31, 0, input);

                throw nvae;

            }

            switch (alt31) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:646:5: var
                    {
                    pushFollow(FOLLOW_var_in_inval962);
                    var24=var();

                    state._fsp--;


                     value = var24; 

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:647:7: inlist
                    {
                    pushFollow(FOLLOW_inlist_in_inval972);
                    inlist25=inlist();

                    state._fsp--;


                     value = inlist25; 

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:648:7: gql_select_one
                    {
                    pushFollow(FOLLOW_gql_select_one_in_inval982);
                    gql_select_one26=gql_select_one();

                    state._fsp--;



                            ArrayList<Object> ret = new ArrayList<Object>();
                            for (Object o : gql_select_one26) {
                                ret.add( o );
                            }

                            value = ret;
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "inval"


    protected static class inlist_scope {
        ArrayList list;
    }
    protected Stack inlist_stack = new Stack();



    // $ANTLR start "inlist"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:658:1: inlist returns [ArrayList value] : ^( LIST ( listitem )+ ) ;
    public final ArrayList inlist() throws RecognitionException {
        inlist_stack.push(new inlist_scope());
        ArrayList value = null;



                ((inlist_scope)inlist_stack.peek()).list = new ArrayList();
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:665:5: ( ^( LIST ( listitem )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:666:5: ^( LIST ( listitem )+ )
            {
            match(input,LIST,FOLLOW_LIST_in_inlist1026); 

            match(input, Token.DOWN, null); 
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:666:12: ( listitem )+
            int cnt32=0;
            loop32:
            do {
                int alt32=2;
                int LA32_0 = input.LA(1);

                if ( ((LA32_0 >= DATE && LA32_0 <= DATETIME)||(LA32_0 >= FALSE && LA32_0 <= FLOAT)||LA32_0==GEOPT||LA32_0==INT||LA32_0==KEY||LA32_0==NULL||LA32_0==STRING||(LA32_0 >= TIME && LA32_0 <= TRUE)||LA32_0==USER||LA32_0==VARID) ) {
                    alt32=1;
                }


                switch (alt32) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:666:12: listitem
            	    {
            	    pushFollow(FOLLOW_listitem_in_inlist1028);
            	    listitem();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt32 >= 1 ) break loop32;
                        EarlyExitException eee =
                            new EarlyExitException(32, input);
                        throw eee;
                }
                cnt32++;
            } while (true);


            match(input, Token.UP, null); 



                    value = ((inlist_scope)inlist_stack.peek()).list;
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            inlist_stack.pop();
        }
        return value;
    }
    // $ANTLR end "inlist"



    // $ANTLR start "listitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:671:1: listitem : vov= valorvarobj ;
    public final void listitem() throws RecognitionException {
        Object vov =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:671:9: (vov= valorvarobj )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:672:5: vov= valorvarobj
            {
            pushFollow(FOLLOW_valorvarobj_in_listitem1046);
            vov=valorvarobj();

            state._fsp--;



                    ((inlist_scope)inlist_stack.peek()).list.add( vov );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "listitem"



    // $ANTLR start "key"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:677:1: key returns [Key value] : ( ^( KEY STRING ) | ^( KEY var ) | ^( KEY keypath ) );
    public final Key key() throws RecognitionException {
        Key value = null;


        CommonTree STRING27=null;
        Object var28 =null;

        KeyFactory.Builder keypath29 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:677:23: ( ^( KEY STRING ) | ^( KEY var ) | ^( KEY keypath ) )
            int alt33=3;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==KEY) ) {
                int LA33_1 = input.LA(2);

                if ( (LA33_1==DOWN) ) {
                    switch ( input.LA(3) ) {
                    case STRING:
                        {
                        alt33=1;
                        }
                        break;
                    case VARID:
                        {
                        alt33=2;
                        }
                        break;
                    case PATH:
                        {
                        alt33=3;
                        }
                        break;
                    default:
                        NoViableAltException nvae =
                            new NoViableAltException("", 33, 2, input);

                        throw nvae;

                    }

                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 33, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 33, 0, input);

                throw nvae;

            }
            switch (alt33) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:678:5: ^( KEY STRING )
                    {
                    match(input,KEY,FOLLOW_KEY_in_key1064); 

                    match(input, Token.DOWN, null); 
                    STRING27=(CommonTree)match(input,STRING,FOLLOW_STRING_in_key1066); 

                    match(input, Token.UP, null); 



                            value = KeyFactory.stringToKey( string( (STRING27!=null?STRING27.getText():null) ));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:681:7: ^( KEY var )
                    {
                    match(input,KEY,FOLLOW_KEY_in_key1078); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_var_in_key1080);
                    var28=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            if (var28 instanceof Key) {
                                value = (Key) var28;
                            }
                            else {
                                value = KeyFactory.stringToKey( argString( var28 ));
                            }
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:689:7: ^( KEY keypath )
                    {
                    match(input,KEY,FOLLOW_KEY_in_key1092); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_keypath_in_key1094);
                    keypath29=keypath();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = keypath29.getKey();
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "key"



    // $ANTLR start "keypath"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:695:1: keypath returns [KeyFactory.Builder value] : ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) ) ( keypathchild[$value] )* ;
    public final KeyFactory.Builder keypath() throws RecognitionException {
        KeyFactory.Builder value = null;


        CommonTree kin=null;
        CommonTree name=null;
        CommonTree id=null;
        Object var30 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:695:42: ( ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) ) ( keypathchild[$value] )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:696:5: ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) ) ( keypathchild[$value] )*
            {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:696:5: ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) )
            int alt34=3;
            int LA34_0 = input.LA(1);

            if ( (LA34_0==PATH) ) {
                int LA34_1 = input.LA(2);

                if ( (LA34_1==DOWN) ) {
                    int LA34_2 = input.LA(3);

                    if ( (LA34_2==STRING) ) {
                        switch ( input.LA(4) ) {
                        case STRING:
                            {
                            alt34=1;
                            }
                            break;
                        case INT:
                            {
                            alt34=2;
                            }
                            break;
                        case VARID:
                            {
                            alt34=3;
                            }
                            break;
                        default:
                            NoViableAltException nvae =
                                new NoViableAltException("", 34, 3, input);

                            throw nvae;

                        }

                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 34, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 34, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 34, 0, input);

                throw nvae;

            }
            switch (alt34) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:697:9: ^( PATH kin= STRING name= STRING )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypath1128); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath1132); 

                    name=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath1136); 

                    match(input, Token.UP, null); 



                                value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), string( (name!=null?name.getText():null) ));
                            

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:700:11: ^( PATH kin= STRING id= INT )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypath1152); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath1156); 

                    id=(CommonTree)match(input,INT,FOLLOW_INT_in_keypath1160); 

                    match(input, Token.UP, null); 



                                value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), new Long( (id!=null?id.getText():null) ));
                            

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:703:11: ^( PATH kin= STRING var )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypath1176); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypath1180); 

                    pushFollow(FOLLOW_var_in_keypath1182);
                    var30=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                                if (var30 instanceof Number) {
                                    value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), argLong( var30 ));
                                }
                                else {
                                    value = new KeyFactory.Builder( string( (kin!=null?kin.getText():null) ), argString( var30 ));
                                }
                            

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:712:5: ( keypathchild[$value] )*
            loop35:
            do {
                int alt35=2;
                int LA35_0 = input.LA(1);

                if ( (LA35_0==PATH) ) {
                    alt35=1;
                }


                switch (alt35) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:712:5: keypathchild[$value]
            	    {
            	    pushFollow(FOLLOW_keypathchild_in_keypath1197);
            	    keypathchild(value);

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop35;
                }
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "keypath"



    // $ANTLR start "keypathchild"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:715:1: keypathchild[KeyFactory.Builder builder] : ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) );
    public final void keypathchild(KeyFactory.Builder builder) throws RecognitionException {
        CommonTree kin=null;
        CommonTree name=null;
        CommonTree id=null;
        Object var31 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:715:41: ( ^( PATH kin= STRING name= STRING ) | ^( PATH kin= STRING id= INT ) | ^( PATH kin= STRING var ) )
            int alt36=3;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==PATH) ) {
                int LA36_1 = input.LA(2);

                if ( (LA36_1==DOWN) ) {
                    int LA36_2 = input.LA(3);

                    if ( (LA36_2==STRING) ) {
                        switch ( input.LA(4) ) {
                        case STRING:
                            {
                            alt36=1;
                            }
                            break;
                        case INT:
                            {
                            alt36=2;
                            }
                            break;
                        case VARID:
                            {
                            alt36=3;
                            }
                            break;
                        default:
                            NoViableAltException nvae =
                                new NoViableAltException("", 36, 3, input);

                            throw nvae;

                        }

                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 36, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 36, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;

            }
            switch (alt36) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:716:5: ^( PATH kin= STRING name= STRING )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypathchild1213); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild1217); 

                    name=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild1221); 

                    match(input, Token.UP, null); 



                            builder.addChild( string( (kin!=null?kin.getText():null) ), string( (name!=null?name.getText():null) ));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:719:7: ^( PATH kin= STRING id= INT )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypathchild1233); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild1237); 

                    id=(CommonTree)match(input,INT,FOLLOW_INT_in_keypathchild1241); 

                    match(input, Token.UP, null); 



                            builder.addChild( string( (kin!=null?kin.getText():null) ), new Long( (id!=null?id.getText():null) ));
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:722:7: ^( PATH kin= STRING var )
                    {
                    match(input,PATH,FOLLOW_PATH_in_keypathchild1253); 

                    match(input, Token.DOWN, null); 
                    kin=(CommonTree)match(input,STRING,FOLLOW_STRING_in_keypathchild1257); 

                    pushFollow(FOLLOW_var_in_keypathchild1259);
                    var31=var();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            if (var31 instanceof Number) {
                                builder.addChild( string( (kin!=null?kin.getText():null) ), argLong( var31 ));
                            }
                            else {
                                builder.addChild( string( (kin!=null?kin.getText():null) ), argString( var31 ));
                            }
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "keypathchild"



    // $ANTLR start "orderby"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:732:1: orderby : ^( ORDER ( orderbyitem )+ ) ;
    public final void orderby() throws RecognitionException {
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:732:8: ( ^( ORDER ( orderbyitem )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:733:5: ^( ORDER ( orderbyitem )+ )
            {
            match(input,ORDER,FOLLOW_ORDER_in_orderby1275); 

            match(input, Token.DOWN, null); 
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:733:13: ( orderbyitem )+
            int cnt37=0;
            loop37:
            do {
                int alt37=2;
                int LA37_0 = input.LA(1);

                if ( (LA37_0==ASC||LA37_0==DESC) ) {
                    alt37=1;
                }


                switch (alt37) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:733:13: orderbyitem
            	    {
            	    pushFollow(FOLLOW_orderbyitem_in_orderby1277);
            	    orderbyitem();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt37 >= 1 ) break loop37;
                        EarlyExitException eee =
                            new EarlyExitException(37, input);
                        throw eee;
                }
                cnt37++;
            } while (true);


            match(input, Token.UP, null); 


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "orderby"



    // $ANTLR start "orderbyitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:736:1: orderbyitem : ( ^( ASC prop ) | ^( DESC prop ) );
    public final void orderbyitem() throws RecognitionException {
        String prop32 =null;

        String prop33 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:736:12: ( ^( ASC prop ) | ^( DESC prop ) )
            int alt38=2;
            int LA38_0 = input.LA(1);

            if ( (LA38_0==ASC) ) {
                alt38=1;
            }
            else if ( (LA38_0==DESC) ) {
                alt38=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 38, 0, input);

                throw nvae;

            }
            switch (alt38) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:737:5: ^( ASC prop )
                    {
                    match(input,ASC,FOLLOW_ASC_in_orderbyitem1292); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_prop_in_orderbyitem1294);
                    prop32=prop();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            ((Query_scope)Query_stack.peek()).query.addSort( prop32, Query.SortDirection.ASCENDING );
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:740:7: ^( DESC prop )
                    {
                    match(input,DESC,FOLLOW_DESC_in_orderbyitem1306); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_prop_in_orderbyitem1308);
                    prop33=prop();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            ((Query_scope)Query_stack.peek()).query.addSort( prop33, Query.SortDirection.DESCENDING );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "orderbyitem"



    // $ANTLR start "limit"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:745:1: limit : ^( LIMIT INT ) ;
    public final void limit() throws RecognitionException {
        CommonTree INT34=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:745:6: ( ^( LIMIT INT ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:746:5: ^( LIMIT INT )
            {
            match(input,LIMIT,FOLLOW_LIMIT_in_limit1324); 

            match(input, Token.DOWN, null); 
            INT34=(CommonTree)match(input,INT,FOLLOW_INT_in_limit1326); 

            match(input, Token.UP, null); 



                     ((Query_scope)Query_stack.peek()).limit = new Integer( (INT34!=null?INT34.getText():null) );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "limit"



    // $ANTLR start "offset"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:751:1: offset : ^( OFFSET INT ) ;
    public final void offset() throws RecognitionException {
        CommonTree INT35=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:751:7: ( ^( OFFSET INT ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:752:5: ^( OFFSET INT )
            {
            match(input,OFFSET,FOLLOW_OFFSET_in_offset1342); 

            match(input, Token.DOWN, null); 
            INT35=(CommonTree)match(input,INT,FOLLOW_INT_in_offset1344); 

            match(input, Token.UP, null); 



                     ((Query_scope)Query_stack.peek()).offset = new Integer( (INT35!=null?INT35.getText():null) );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "offset"



    // $ANTLR start "valorvarobj"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:757:1: valorvarobj returns [Object value] : ( STRING | INT | FLOAT | TRUE | FALSE | NULL | var | datetime | key | geopt | user );
    public final Object valorvarobj() throws RecognitionException {
        Object value = null;


        CommonTree STRING36=null;
        CommonTree INT37=null;
        CommonTree FLOAT38=null;
        Object var39 =null;

        Date datetime40 =null;

        Key key41 =null;

        GeoPt geopt42 =null;

        User user43 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:757:34: ( STRING | INT | FLOAT | TRUE | FALSE | NULL | var | datetime | key | geopt | user )
            int alt39=11;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt39=1;
                }
                break;
            case INT:
                {
                alt39=2;
                }
                break;
            case FLOAT:
                {
                alt39=3;
                }
                break;
            case TRUE:
                {
                alt39=4;
                }
                break;
            case FALSE:
                {
                alt39=5;
                }
                break;
            case NULL:
                {
                alt39=6;
                }
                break;
            case VARID:
                {
                alt39=7;
                }
                break;
            case DATE:
            case DATETIME:
            case TIME:
                {
                alt39=8;
                }
                break;
            case KEY:
                {
                alt39=9;
                }
                break;
            case GEOPT:
                {
                alt39=10;
                }
                break;
            case USER:
                {
                alt39=11;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 39, 0, input);

                throw nvae;

            }

            switch (alt39) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:758:5: STRING
                    {
                    STRING36=(CommonTree)match(input,STRING,FOLLOW_STRING_in_valorvarobj1362); 

                     value = string( (STRING36!=null?STRING36.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:759:7: INT
                    {
                    INT37=(CommonTree)match(input,INT,FOLLOW_INT_in_valorvarobj1372); 

                     value = new Long( (INT37!=null?INT37.getText():null) );

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:760:7: FLOAT
                    {
                    FLOAT38=(CommonTree)match(input,FLOAT,FOLLOW_FLOAT_in_valorvarobj1382); 

                     value = new Double( (FLOAT38!=null?FLOAT38.getText():null) );

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:761:7: TRUE
                    {
                    match(input,TRUE,FOLLOW_TRUE_in_valorvarobj1392); 

                     value = Boolean.TRUE;

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:762:7: FALSE
                    {
                    match(input,FALSE,FOLLOW_FALSE_in_valorvarobj1402); 

                     value = Boolean.FALSE;

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:763:7: NULL
                    {
                    match(input,NULL,FOLLOW_NULL_in_valorvarobj1412); 

                     value = null; 

                    }
                    break;
                case 7 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:764:7: var
                    {
                    pushFollow(FOLLOW_var_in_valorvarobj1422);
                    var39=var();

                    state._fsp--;


                     value = var39;

                    }
                    break;
                case 8 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:765:7: datetime
                    {
                    pushFollow(FOLLOW_datetime_in_valorvarobj1432);
                    datetime40=datetime();

                    state._fsp--;


                     value = datetime40;

                    }
                    break;
                case 9 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:766:7: key
                    {
                    pushFollow(FOLLOW_key_in_valorvarobj1442);
                    key41=key();

                    state._fsp--;


                     value = key41;

                    }
                    break;
                case 10 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:767:7: geopt
                    {
                    pushFollow(FOLLOW_geopt_in_valorvarobj1452);
                    geopt42=geopt();

                    state._fsp--;


                     value = geopt42;

                    }
                    break;
                case 11 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:768:7: user
                    {
                    pushFollow(FOLLOW_user_in_valorvarobj1462);
                    user43=user();

                    state._fsp--;


                     value = user43;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "valorvarobj"



    // $ANTLR start "datetime"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:772:1: datetime returns [Date value] : ( ^( DATE sval= STRING ) | ^( DATETIME sval= STRING ) | ^( TIME sval= STRING ) | ^( DATE year= intorvar month= intorvar day= intorvar ) | ^( DATETIME year= intorvar month= intorvar day= intorvar hour= intorvar minute= intorvar second= intorvar ) | ^( TIME hour= intorvar minute= intorvar second= intorvar ) );
    public final Date datetime() throws RecognitionException {
        Date value = null;


        CommonTree sval=null;
        Integer year =null;

        Integer month =null;

        Integer day =null;

        Integer hour =null;

        Integer minute =null;

        Integer second =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:772:29: ( ^( DATE sval= STRING ) | ^( DATETIME sval= STRING ) | ^( TIME sval= STRING ) | ^( DATE year= intorvar month= intorvar day= intorvar ) | ^( DATETIME year= intorvar month= intorvar day= intorvar hour= intorvar minute= intorvar second= intorvar ) | ^( TIME hour= intorvar minute= intorvar second= intorvar ) )
            int alt40=6;
            switch ( input.LA(1) ) {
            case DATE:
                {
                int LA40_1 = input.LA(2);

                if ( (LA40_1==DOWN) ) {
                    int LA40_4 = input.LA(3);

                    if ( (LA40_4==STRING) ) {
                        alt40=1;
                    }
                    else if ( (LA40_4==INT||LA40_4==VARID) ) {
                        alt40=4;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 40, 4, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 40, 1, input);

                    throw nvae;

                }
                }
                break;
            case DATETIME:
                {
                int LA40_2 = input.LA(2);

                if ( (LA40_2==DOWN) ) {
                    int LA40_5 = input.LA(3);

                    if ( (LA40_5==STRING) ) {
                        alt40=2;
                    }
                    else if ( (LA40_5==INT||LA40_5==VARID) ) {
                        alt40=5;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 40, 5, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 40, 2, input);

                    throw nvae;

                }
                }
                break;
            case TIME:
                {
                int LA40_3 = input.LA(2);

                if ( (LA40_3==DOWN) ) {
                    int LA40_6 = input.LA(3);

                    if ( (LA40_6==STRING) ) {
                        alt40=3;
                    }
                    else if ( (LA40_6==INT||LA40_6==VARID) ) {
                        alt40=6;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 40, 6, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 40, 3, input);

                    throw nvae;

                }
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 40, 0, input);

                throw nvae;

            }

            switch (alt40) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:773:5: ^( DATE sval= STRING )
                    {
                    match(input,DATE,FOLLOW_DATE_in_datetime1485); 

                    match(input, Token.DOWN, null); 
                    sval=(CommonTree)match(input,STRING,FOLLOW_STRING_in_datetime1489); 

                    match(input, Token.UP, null); 



                            value = date( string((sval!=null?sval.getText():null)));
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:776:7: ^( DATETIME sval= STRING )
                    {
                    match(input,DATETIME,FOLLOW_DATETIME_in_datetime1501); 

                    match(input, Token.DOWN, null); 
                    sval=(CommonTree)match(input,STRING,FOLLOW_STRING_in_datetime1505); 

                    match(input, Token.UP, null); 



                            value = ParserUtils.datetime( string((sval!=null?sval.getText():null) ));
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:779:7: ^( TIME sval= STRING )
                    {
                    match(input,TIME,FOLLOW_TIME_in_datetime1517); 

                    match(input, Token.DOWN, null); 
                    sval=(CommonTree)match(input,STRING,FOLLOW_STRING_in_datetime1521); 

                    match(input, Token.UP, null); 



                            value = time( string((sval!=null?sval.getText():null) ));
                        

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:782:7: ^( DATE year= intorvar month= intorvar day= intorvar )
                    {
                    match(input,DATE,FOLLOW_DATE_in_datetime1533); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_intorvar_in_datetime1537);
                    year=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1541);
                    month=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1545);
                    day=intorvar();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = date( year, month, day );
                        

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:785:7: ^( DATETIME year= intorvar month= intorvar day= intorvar hour= intorvar minute= intorvar second= intorvar )
                    {
                    match(input,DATETIME,FOLLOW_DATETIME_in_datetime1557); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_intorvar_in_datetime1561);
                    year=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1565);
                    month=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1569);
                    day=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1573);
                    hour=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1577);
                    minute=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1581);
                    second=intorvar();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = ParserUtils.datetime( year, month, day, hour, minute, second );
                        

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:788:7: ^( TIME hour= intorvar minute= intorvar second= intorvar )
                    {
                    match(input,TIME,FOLLOW_TIME_in_datetime1593); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_intorvar_in_datetime1597);
                    hour=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1601);
                    minute=intorvar();

                    state._fsp--;


                    pushFollow(FOLLOW_intorvar_in_datetime1605);
                    second=intorvar();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = time( hour, minute, second );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "datetime"



    // $ANTLR start "geopt"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:794:1: geopt returns [GeoPt value] : ^( GEOPT lat= floatorvar lon= floatorvar ) ;
    public final GeoPt geopt() throws RecognitionException {
        GeoPt value = null;


        Float lat =null;

        Float lon =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:794:27: ( ^( GEOPT lat= floatorvar lon= floatorvar ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:795:5: ^( GEOPT lat= floatorvar lon= floatorvar )
            {
            match(input,GEOPT,FOLLOW_GEOPT_in_geopt1629); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_floatorvar_in_geopt1633);
            lat=floatorvar();

            state._fsp--;


            pushFollow(FOLLOW_floatorvar_in_geopt1637);
            lon=floatorvar();

            state._fsp--;


            match(input, Token.UP, null); 



                    value = new GeoPt( lat, lon );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "geopt"



    // $ANTLR start "user"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:801:1: user returns [User value] : ^( USER email= stringorvar ) ;
    public final User user() throws RecognitionException {
        User value = null;


        String email =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:801:25: ( ^( USER email= stringorvar ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:802:5: ^( USER email= stringorvar )
            {
            match(input,USER,FOLLOW_USER_in_user1661); 

            match(input, Token.DOWN, null); 
            pushFollow(FOLLOW_stringorvar_in_user1665);
            email=stringorvar();

            state._fsp--;


            match(input, Token.UP, null); 



                    value = new User( email, "gmail.com" );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "user"



    // $ANTLR start "intorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:808:1: intorvar returns [Integer value] : ( INT | var );
    public final Integer intorvar() throws RecognitionException {
        Integer value = null;


        CommonTree INT44=null;
        Object var45 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:808:32: ( INT | var )
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==INT) ) {
                alt41=1;
            }
            else if ( (LA41_0==VARID) ) {
                alt41=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 41, 0, input);

                throw nvae;

            }
            switch (alt41) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:809:5: INT
                    {
                    INT44=(CommonTree)match(input,INT,FOLLOW_INT_in_intorvar1688); 

                     value = new Integer( (INT44!=null?INT44.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:810:7: var
                    {
                    pushFollow(FOLLOW_var_in_intorvar1698);
                    var45=var();

                    state._fsp--;


                     value = argInt( var45 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "intorvar"



    // $ANTLR start "floatorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:814:1: floatorvar returns [Float value] : ( INT | FLOAT | var );
    public final Float floatorvar() throws RecognitionException {
        Float value = null;


        CommonTree INT46=null;
        CommonTree FLOAT47=null;
        Object var48 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:814:32: ( INT | FLOAT | var )
            int alt42=3;
            switch ( input.LA(1) ) {
            case INT:
                {
                alt42=1;
                }
                break;
            case FLOAT:
                {
                alt42=2;
                }
                break;
            case VARID:
                {
                alt42=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;

            }

            switch (alt42) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:815:5: INT
                    {
                    INT46=(CommonTree)match(input,INT,FOLLOW_INT_in_floatorvar1720); 

                     value = new Float( (INT46!=null?INT46.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:816:7: FLOAT
                    {
                    FLOAT47=(CommonTree)match(input,FLOAT,FOLLOW_FLOAT_in_floatorvar1730); 

                     value = new Float( (FLOAT47!=null?FLOAT47.getText():null) );

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:817:7: var
                    {
                    pushFollow(FOLLOW_var_in_floatorvar1740);
                    var48=var();

                    state._fsp--;


                     value = argFloat( var48 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "floatorvar"



    // $ANTLR start "stringorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:822:1: stringorvar returns [String value] : ( STRING | var );
    public final String stringorvar() throws RecognitionException {
        String value = null;


        CommonTree STRING49=null;
        Object var50 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:822:34: ( STRING | var )
            int alt43=2;
            int LA43_0 = input.LA(1);

            if ( (LA43_0==STRING) ) {
                alt43=1;
            }
            else if ( (LA43_0==VARID) ) {
                alt43=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 43, 0, input);

                throw nvae;

            }
            switch (alt43) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:823:5: STRING
                    {
                    STRING49=(CommonTree)match(input,STRING,FOLLOW_STRING_in_stringorvar1763); 

                     value = string( (STRING49!=null?STRING49.getText():null) );

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:824:7: var
                    {
                    pushFollow(FOLLOW_var_in_stringorvar1773);
                    var50=var();

                    state._fsp--;


                     value = argString( var50 );

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "stringorvar"



    // $ANTLR start "var"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:828:1: var returns [Object value] : VARID ;
    public final Object var() throws RecognitionException {
        Object value = null;


        CommonTree VARID51=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:828:26: ( VARID )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:829:5: VARID
            {
            VARID51=(CommonTree)match(input,VARID,FOLLOW_VARID_in_var1795); 

             value = arg( Integer.parseInt( (VARID51!=null?VARID51.getText():null).substring( 1 ))); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "var"



    // $ANTLR start "prop"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:833:1: prop returns [String value] : ( property | KEYPROP );
    public final String prop() throws RecognitionException {
        String value = null;


        CommonTree KEYPROP53=null;
        String property52 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:833:27: ( property | KEYPROP )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==PROP) ) {
                alt44=1;
            }
            else if ( (LA44_0==KEYPROP) ) {
                alt44=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;

            }
            switch (alt44) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:834:5: property
                    {
                    pushFollow(FOLLOW_property_in_prop1817);
                    property52=property();

                    state._fsp--;



                            value = property52;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:837:7: KEYPROP
                    {
                    KEYPROP53=(CommonTree)match(input,KEYPROP,FOLLOW_KEYPROP_in_prop1827); 


                            value = (KEYPROP53!=null?KEYPROP53.getText():null);
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "prop"



    // $ANTLR start "property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:842:1: property returns [String value] : ( ^( PROP ids ) | ^( PROP STRING ) );
    public final String property() throws RecognitionException {
        String value = null;


        CommonTree STRING55=null;
        String ids54 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:842:31: ( ^( PROP ids ) | ^( PROP STRING ) )
            int alt45=2;
            int LA45_0 = input.LA(1);

            if ( (LA45_0==PROP) ) {
                int LA45_1 = input.LA(2);

                if ( (LA45_1==DOWN) ) {
                    int LA45_2 = input.LA(3);

                    if ( (LA45_2==STRING) ) {
                        alt45=2;
                    }
                    else if ( (LA45_2==ID) ) {
                        alt45=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 45, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 45, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 45, 0, input);

                throw nvae;

            }
            switch (alt45) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:843:5: ^( PROP ids )
                    {
                    match(input,PROP,FOLLOW_PROP_in_property1845); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_ids_in_property1847);
                    ids54=ids();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = ids54;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:846:7: ^( PROP STRING )
                    {
                    match(input,PROP,FOLLOW_PROP_in_property1859); 

                    match(input, Token.DOWN, null); 
                    STRING55=(CommonTree)match(input,STRING,FOLLOW_STRING_in_property1861); 

                    match(input, Token.UP, null); 



                            value = string( (STRING55!=null?STRING55.getText():null) );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "property"



    // $ANTLR start "kindquery"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:851:1: kindquery : ( kind | KIND );
    public final void kindquery() throws RecognitionException {
        String kind56 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:851:10: ( kind | KIND )
            int alt46=2;
            int LA46_0 = input.LA(1);

            if ( (LA46_0==KIND) ) {
                int LA46_1 = input.LA(2);

                if ( (LA46_1==DOWN) ) {
                    alt46=1;
                }
                else if ( (LA46_1==UP||LA46_1==LIMIT||LA46_1==OFFSET||LA46_1==ORDER||LA46_1==PROP||LA46_1==SET||LA46_1==WHERE) ) {
                    alt46=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 46, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 46, 0, input);

                throw nvae;

            }
            switch (alt46) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:852:5: kind
                    {
                    pushFollow(FOLLOW_kind_in_kindquery1876);
                    kind56=kind();

                    state._fsp--;



                            ((Query_scope)Query_stack.peek()).query = new Query( kind56 );
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:855:7: KIND
                    {
                    match(input,KIND,FOLLOW_KIND_in_kindquery1886); 


                            ((Query_scope)Query_stack.peek()).query = new Query();
                            log.debug("kindquery(): <all>");
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return ;
    }
    // $ANTLR end "kindquery"



    // $ANTLR start "kindless"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:861:1: kindless returns [String value] : ( kind | KIND );
    public final String kindless() throws RecognitionException {
        String value = null;


        String kind57 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:861:31: ( kind | KIND )
            int alt47=2;
            int LA47_0 = input.LA(1);

            if ( (LA47_0==KIND) ) {
                int LA47_1 = input.LA(2);

                if ( (LA47_1==DOWN) ) {
                    alt47=1;
                }
                else if ( (LA47_1==COLAS) ) {
                    alt47=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 47, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 47, 0, input);

                throw nvae;

            }
            switch (alt47) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:862:5: kind
                    {
                    pushFollow(FOLLOW_kind_in_kindless1903);
                    kind57=kind();

                    state._fsp--;



                            value = kind57;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:865:7: KIND
                    {
                    match(input,KIND,FOLLOW_KIND_in_kindless1913); 


                            value = null;
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "kindless"



    // $ANTLR start "kind"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:870:1: kind returns [String value] : ( ^( KIND ids ) | ^( KIND STRING ) );
    public final String kind() throws RecognitionException {
        String value = null;


        CommonTree STRING59=null;
        String ids58 =null;


        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:870:27: ( ^( KIND ids ) | ^( KIND STRING ) )
            int alt48=2;
            int LA48_0 = input.LA(1);

            if ( (LA48_0==KIND) ) {
                int LA48_1 = input.LA(2);

                if ( (LA48_1==DOWN) ) {
                    int LA48_2 = input.LA(3);

                    if ( (LA48_2==STRING) ) {
                        alt48=2;
                    }
                    else if ( (LA48_2==ID) ) {
                        alt48=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 48, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 48, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 48, 0, input);

                throw nvae;

            }
            switch (alt48) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:871:5: ^( KIND ids )
                    {
                    match(input,KIND,FOLLOW_KIND_in_kind1931); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_ids_in_kind1933);
                    ids58=ids();

                    state._fsp--;


                    match(input, Token.UP, null); 



                            value = ids58;
                        

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:874:7: ^( KIND STRING )
                    {
                    match(input,KIND,FOLLOW_KIND_in_kind1945); 

                    match(input, Token.DOWN, null); 
                    STRING59=(CommonTree)match(input,STRING,FOLLOW_STRING_in_kind1947); 

                    match(input, Token.UP, null); 



                            value = string( (STRING59!=null?STRING59.getText():null) );
                        

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "kind"


    protected static class ids_scope {
        StringBuilder sb;
    }
    protected Stack ids_stack = new Stack();



    // $ANTLR start "ids"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:879:1: ids returns [String value] : ID ( ids2 )* ;
    public final String ids() throws RecognitionException {
        ids_stack.push(new ids_scope());
        String value = null;


        CommonTree ID60=null;


                ((ids_scope)ids_stack.peek()).sb = new StringBuilder();
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:886:5: ( ID ( ids2 )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:887:5: ID ( ids2 )*
            {
            ID60=(CommonTree)match(input,ID,FOLLOW_ID_in_ids1987); 


                    ((ids_scope)ids_stack.peek()).sb.append( (ID60!=null?ID60.getText():null) );
                

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:890:5: ( ids2 )*
            loop49:
            do {
                int alt49=2;
                int LA49_0 = input.LA(1);

                if ( (LA49_0==ID) ) {
                    alt49=1;
                }


                switch (alt49) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:890:5: ids2
            	    {
            	    pushFollow(FOLLOW_ids2_in_ids1995);
            	    ids2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);



                    value = ((ids_scope)ids_stack.peek()).sb.toString();
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
            ids_stack.pop();
        }
        return value;
    }
    // $ANTLR end "ids"



    // $ANTLR start "ids2"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:895:1: ids2 returns [String value] : ID ;
    public final String ids2() throws RecognitionException {
        String value = null;


        CommonTree ID61=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:895:27: ( ID )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtTree.g:896:5: ID
            {
            ID61=(CommonTree)match(input,ID,FOLLOW_ID_in_ids22013); 


                    ((ids_scope)ids_stack.peek()).sb.append( '.' ).append( (ID61!=null?ID61.getText():null) );
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }

        finally {
        	// do for sure before leaving
        }
        return value;
    }
    // $ANTLR end "ids2"

    // Delegated rules


    protected DFA28 dfa28 = new DFA28(this);
    static final String DFA28_eotS =
        "\17\uffff";
    static final String DFA28_eofS =
        "\17\uffff";
    static final String DFA28_minS =
        "\1\5\4\uffff\1\2\1\uffff\1\4\1\2\1\4\3\uffff\1\3\1\101";
    static final String DFA28_maxS =
        "\1\70\4\uffff\1\2\1\uffff\1\136\1\133\1\136\3\uffff\1\136\1\133";
    static final String DFA28_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\uffff\1\10\3\uffff\1\5\1\6\1\7\2\uffff";
    static final String DFA28_specialS =
        "\17\uffff}>";
    static final String[] DFA28_transitionS = {
            "\1\6\1\1\20\uffff\1\4\13\uffff\1\5\17\uffff\1\3\3\uffff\1\4"+
            "\1\2",
            "",
            "",
            "",
            "",
            "\1\7",
            "",
            "\133\10",
            "\1\11\76\uffff\1\12\16\uffff\1\14\12\uffff\1\13",
            "\133\15",
            "",
            "",
            "",
            "\1\16\133\15",
            "\1\12\16\uffff\1\14\12\uffff\1\13"
    };

    static final short[] DFA28_eot = DFA.unpackEncodedString(DFA28_eotS);
    static final short[] DFA28_eof = DFA.unpackEncodedString(DFA28_eofS);
    static final char[] DFA28_min = DFA.unpackEncodedStringToUnsignedChars(DFA28_minS);
    static final char[] DFA28_max = DFA.unpackEncodedStringToUnsignedChars(DFA28_maxS);
    static final short[] DFA28_accept = DFA.unpackEncodedString(DFA28_acceptS);
    static final short[] DFA28_special = DFA.unpackEncodedString(DFA28_specialS);
    static final short[][] DFA28_transition;

    static {
        int numStates = DFA28_transitionS.length;
        DFA28_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA28_transition[i] = DFA.unpackEncodedString(DFA28_transitionS[i]);
        }
    }

    class DFA28 extends DFA {

        public DFA28(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 28;
            this.eot = DFA28_eot;
            this.eof = DFA28_eof;
            this.min = DFA28_min;
            this.max = DFA28_max;
            this.accept = DFA28_accept;
            this.special = DFA28_special;
            this.transition = DFA28_transition;
        }
        public String getDescription() {
            return "543:1: softcondition returns [SoftCondition value] : ( ^( AND sc1= softcondition sc2= softcondition ) | ^( OR sc1= softcondition sc2= softcondition ) | ^( NOT sc= softcondition ) | ^( oper expr1= . expr2= . ) | ^( IN expr1= . gql_select_one ) | ^( IN expr1= . ^(expr3= LIST ( . )* ) ) | ^( IN expr1= . var ) | ^( ANCESTOR expr= . ) );";
        }
    }
 

    public static final BitSet FOLLOW_gql_select_in_gqlext78 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_insert_in_gqlext88 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_update_in_gqlext92 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_delete_in_gqlext96 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SELECT_in_gql_select135 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_kindorquery_in_gql_select137 = new BitSet(new long[]{0x1000000000000000L});
    public static final BitSet FOLLOW_get_properties_in_gql_select139 = new BitSet(new long[]{0x0240800000000008L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_select141 = new BitSet(new long[]{0x0240800000000008L});
    public static final BitSet FOLLOW_orderby_in_gql_select144 = new BitSet(new long[]{0x0040800000000008L});
    public static final BitSet FOLLOW_limit_in_gql_select147 = new BitSet(new long[]{0x0040000000000008L});
    public static final BitSet FOLLOW_offset_in_gql_select150 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_SELECT_in_gql_select_one185 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_kindorquery_in_gql_select_one187 = new BitSet(new long[]{0x1000000000000000L});
    public static final BitSet FOLLOW_get_properties_in_gql_select_one189 = new BitSet(new long[]{0x0240800000000008L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_select_one191 = new BitSet(new long[]{0x0240800000000008L});
    public static final BitSet FOLLOW_orderby_in_gql_select_one194 = new BitSet(new long[]{0x0040800000000008L});
    public static final BitSet FOLLOW_limit_in_gql_select_one197 = new BitSet(new long[]{0x0040000000000008L});
    public static final BitSet FOLLOW_offset_in_gql_select_one200 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_INSERT_in_gql_insert238 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_kindless_in_gql_insert242 = new BitSet(new long[]{0x0000000000000000L,0x0000000001000000L});
    public static final BitSet FOLLOW_columns_in_gql_insert244 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L});
    public static final BitSet FOLLOW_values_in_gql_insert246 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_UPDATE_in_gql_update293 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_kindquery_in_gql_update295 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_set_properties_in_gql_update297 = new BitSet(new long[]{0x0240800000000008L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_update299 = new BitSet(new long[]{0x0240800000000008L});
    public static final BitSet FOLLOW_orderby_in_gql_update302 = new BitSet(new long[]{0x0040800000000008L});
    public static final BitSet FOLLOW_limit_in_gql_update305 = new BitSet(new long[]{0x0040000000000008L});
    public static final BitSet FOLLOW_offset_in_gql_update308 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DELETE_in_gql_delete339 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_kindquery_in_gql_delete341 = new BitSet(new long[]{0x0240800000000008L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_delete343 = new BitSet(new long[]{0x0240800000000008L});
    public static final BitSet FOLLOW_orderby_in_gql_delete346 = new BitSet(new long[]{0x0040800000000008L});
    public static final BitSet FOLLOW_limit_in_gql_delete349 = new BitSet(new long[]{0x0040000000000008L});
    public static final BitSet FOLLOW_offset_in_gql_delete352 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_kindquery_in_kindorquery368 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DUAL_in_kindorquery376 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_select_in_kindorquery386 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROP_in_get_properties401 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_get_property_in_get_properties403 = new BitSet(new long[]{0x1000080000000208L,0x0000000001000000L});
    public static final BitSet FOLLOW_ASTERISK_in_get_property417 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_get_property427 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_get_property437 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COLAS_in_get_property448 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_alias_in_get_property450 = new BitSet(new long[]{0xFFFFFFFFFFFFFFF0L,0x000000007FFFFFFFL});
    public static final BitSet FOLLOW_STRING_in_alias472 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prop_in_alias482 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNINDEXED_in_alias493 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_alias495 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_EMPTY_in_alias507 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_alias509 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COLAS_in_columns525 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_column_in_columns527 = new BitSet(new long[]{0x1000080000400008L,0x0000000000000820L});
    public static final BitSet FOLLOW_VALUES_in_values542 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_value_in_values544 = new BitSet(new long[]{0xFFFFFFFFFFFFFFF8L,0x000000007FFFFFFFL});
    public static final BitSet FOLLOW_alias_in_column559 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SET_in_set_properties591 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_property_in_set_properties593 = new BitSet(new long[]{0x0000000000800008L});
    public static final BitSet FOLLOW_EQ_in_set_property608 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_alias_in_set_property610 = new BitSet(new long[]{0xFFFFFFFFFFFFFFF0L,0x000000007FFFFFFFL});
    public static final BitSet FOLLOW_WHERE_in_where630 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condition_in_where632 = new BitSet(new long[]{0x0080000800800028L,0x0000000000000010L});
    public static final BitSet FOLLOW_softwhere_in_where635 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_SOFT_in_softwhere649 = new BitSet(new long[]{0x0188000800800060L});
    public static final BitSet FOLLOW_softcondition_in_softwhere653 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AND_in_softcondition671 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_softcondition_in_softcondition675 = new BitSet(new long[]{0x0188000800800060L});
    public static final BitSet FOLLOW_softcondition_in_softcondition679 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_OR_in_softcondition691 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_softcondition_in_softcondition695 = new BitSet(new long[]{0x0188000800800060L});
    public static final BitSet FOLLOW_softcondition_in_softcondition699 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_NOT_in_softcondition711 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_softcondition_in_softcondition715 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_oper_in_softcondition727 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IN_in_softcondition747 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_gql_select_one_in_softcondition753 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_softcondition765 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LIST_in_softcondition774 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_IN_in_softcondition790 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_var_in_softcondition796 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ANCESTOR_in_softcondition808 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_condition823 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condkey_in_condition827 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condancestor_in_condition831 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condin_in_condition835 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_oper_in_cond848 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_property_in_cond850 = new BitSet(new long[]{0x001004204C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_valorvarobj_in_cond854 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_OPER_in_oper877 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EQ_in_oper887 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_oper_in_condkey902 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_KEYPROP_in_condkey904 = new BitSet(new long[]{0x0000040000000000L});
    public static final BitSet FOLLOW_key_in_condkey906 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ANCESTOR_in_condancestor922 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_key_in_condancestor924 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_condin940 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_prop_in_condin942 = new BitSet(new long[]{0x0000000000000000L,0x0000000008010002L});
    public static final BitSet FOLLOW_inval_in_condin944 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_var_in_inval962 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_inlist_in_inval972 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_select_one_in_inval982 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LIST_in_inlist1026 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_listitem_in_inlist1028 = new BitSet(new long[]{0x001004204C018008L,0x00000000000121A0L});
    public static final BitSet FOLLOW_valorvarobj_in_listitem1046 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEY_in_key1064 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_key1066 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KEY_in_key1078 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_var_in_key1080 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KEY_in_key1092 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_keypath_in_key1094 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypath1128 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypath1132 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_keypath1136 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypath1152 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypath1156 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_keypath1160 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypath1176 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypath1180 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_var_in_keypath1182 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_keypathchild_in_keypath1197 = new BitSet(new long[]{0x0000000000000002L,0x0000000020000000L});
    public static final BitSet FOLLOW_PATH_in_keypathchild1213 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypathchild1217 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_keypathchild1221 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypathchild1233 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypathchild1237 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_keypathchild1241 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PATH_in_keypathchild1253 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_keypathchild1257 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_var_in_keypathchild1259 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ORDER_in_orderby1275 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderbyitem_in_orderby1277 = new BitSet(new long[]{0x0000000000040108L});
    public static final BitSet FOLLOW_ASC_in_orderbyitem1292 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_prop_in_orderbyitem1294 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DESC_in_orderbyitem1306 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_prop_in_orderbyitem1308 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_LIMIT_in_limit1324 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INT_in_limit1326 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_OFFSET_in_offset1342 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INT_in_offset1344 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_STRING_in_valorvarobj1362 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_valorvarobj1372 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_valorvarobj1382 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_valorvarobj1392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_valorvarobj1402 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NULL_in_valorvarobj1412 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_valorvarobj1422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_datetime_in_valorvarobj1432 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_key_in_valorvarobj1442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_geopt_in_valorvarobj1452 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_user_in_valorvarobj1462 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATE_in_datetime1485 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_datetime1489 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DATETIME_in_datetime1501 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_datetime1505 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_TIME_in_datetime1517 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_datetime1521 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DATE_in_datetime1533 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intorvar_in_datetime1537 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1541 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1545 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DATETIME_in_datetime1557 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intorvar_in_datetime1561 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1565 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1569 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1573 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1577 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1581 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_TIME_in_datetime1593 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intorvar_in_datetime1597 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1601 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1605 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_GEOPT_in_geopt1629 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_floatorvar_in_geopt1633 = new BitSet(new long[]{0x0000002008000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_floatorvar_in_geopt1637 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_USER_in_user1661 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stringorvar_in_user1665 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_INT_in_intorvar1688 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_intorvar1698 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_floatorvar1720 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_floatorvar1730 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_floatorvar1740 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_stringorvar1763 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_stringorvar1773 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VARID_in_var1795 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_prop1817 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_prop1827 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROP_in_property1845 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ids_in_property1847 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PROP_in_property1859 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_property1861 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_kind_in_kindquery1876 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KIND_in_kindquery1886 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_kind_in_kindless1903 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KIND_in_kindless1913 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KIND_in_kind1931 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ids_in_kind1933 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KIND_in_kind1945 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_STRING_in_kind1947 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ID_in_ids1987 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_ids2_in_ids1995 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_ID_in_ids22013 = new BitSet(new long[]{0x0000000000000002L});

}