// $ANTLR 3.4 /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g 2012-04-10 16:33:54

/*
 * Copyright 2010 Spolecne s.r.o. (www.spoledge.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.spoledge.audao.parser.gql.impl;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

import org.antlr.runtime.tree.*;


@SuppressWarnings({"all", "warnings", "unchecked"})
public class GqlExtParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "A", "ANCESTOR", "AND", "AS", "ASC", "ASTERISK", "B", "BY", "C", "COMMA", "D", "DATE", "DATETIME", "DELETE", "DESC", "DOT", "DUAL", "E", "EMPTY", "EQ", "EXPONENT", "F", "FALSE", "FLOAT", "FROM", "G", "GEOPT", "H", "HEX_DIGIT", "I", "ID", "IN", "INSERT", "INT", "INTO", "IS", "J", "K", "KEY", "KEYPROP", "KIND", "L", "LEFT_PAR", "LIMIT", "M", "MINUS", "N", "NOT", "NULL", "O", "OFFSET", "OPER", "OR", "ORDER", "P", "PLUS", "PROP", "Q", "R", "RIGHT_PAR", "S", "SELECT", "SET", "SLASH", "SOFT", "STRING", "T", "TIME", "TRUE", "Tokens", "U", "UNINDEXED", "UPDATE", "USER", "V", "VALUES", "VARID", "VARNAME", "W", "WHERE", "WS", "X", "Y", "Z", "COLAS", "DIV", "FUNC", "LIST", "MUL", "PATH", "UMINUS"
    };

    public static final int EOF=-1;
    public static final int A=4;
    public static final int ANCESTOR=5;
    public static final int AND=6;
    public static final int AS=7;
    public static final int ASC=8;
    public static final int ASTERISK=9;
    public static final int B=10;
    public static final int BY=11;
    public static final int C=12;
    public static final int COMMA=13;
    public static final int D=14;
    public static final int DATE=15;
    public static final int DATETIME=16;
    public static final int DELETE=17;
    public static final int DESC=18;
    public static final int DOT=19;
    public static final int DUAL=20;
    public static final int E=21;
    public static final int EMPTY=22;
    public static final int EQ=23;
    public static final int EXPONENT=24;
    public static final int F=25;
    public static final int FALSE=26;
    public static final int FLOAT=27;
    public static final int FROM=28;
    public static final int G=29;
    public static final int GEOPT=30;
    public static final int H=31;
    public static final int HEX_DIGIT=32;
    public static final int I=33;
    public static final int ID=34;
    public static final int IN=35;
    public static final int INSERT=36;
    public static final int INT=37;
    public static final int INTO=38;
    public static final int IS=39;
    public static final int J=40;
    public static final int K=41;
    public static final int KEY=42;
    public static final int KEYPROP=43;
    public static final int KIND=44;
    public static final int L=45;
    public static final int LEFT_PAR=46;
    public static final int LIMIT=47;
    public static final int M=48;
    public static final int MINUS=49;
    public static final int N=50;
    public static final int NOT=51;
    public static final int NULL=52;
    public static final int O=53;
    public static final int OFFSET=54;
    public static final int OPER=55;
    public static final int OR=56;
    public static final int ORDER=57;
    public static final int P=58;
    public static final int PLUS=59;
    public static final int PROP=60;
    public static final int Q=61;
    public static final int R=62;
    public static final int RIGHT_PAR=63;
    public static final int S=64;
    public static final int SELECT=65;
    public static final int SET=66;
    public static final int SLASH=67;
    public static final int SOFT=68;
    public static final int STRING=69;
    public static final int T=70;
    public static final int TIME=71;
    public static final int TRUE=72;
    public static final int Tokens=73;
    public static final int U=74;
    public static final int UNINDEXED=75;
    public static final int UPDATE=76;
    public static final int USER=77;
    public static final int V=78;
    public static final int VALUES=79;
    public static final int VARID=80;
    public static final int VARNAME=81;
    public static final int W=82;
    public static final int WHERE=83;
    public static final int WS=84;
    public static final int X=85;
    public static final int Y=86;
    public static final int Z=87;
    public static final int COLAS=88;
    public static final int DIV=89;
    public static final int FUNC=90;
    public static final int LIST=91;
    public static final int MUL=92;
    public static final int PATH=93;
    public static final int UMINUS=94;

    // delegates
    public Parser[] getDelegates() {
        return new Parser[] {};
    }

    // delegators

    protected static class Query_scope {
        boolean hasNestedQuery;
    }
    protected Stack Query_stack = new Stack();


    protected static class Expr_scope {
        boolean hasEntity;
        boolean isNestedQueryAllowed;
    }
    protected Stack Expr_stack = new Stack();



    public GqlExtParser(TokenStream input) {
        this(input, new RecognizerSharedState());
    }
    public GqlExtParser(TokenStream input, RecognizerSharedState state) {
        super(input, state);
    }

protected TreeAdaptor adaptor = new CommonTreeAdaptor();

public void setTreeAdaptor(TreeAdaptor adaptor) {
    this.adaptor = adaptor;
}
public TreeAdaptor getTreeAdaptor() {
    return adaptor;
}
    public String[] getTokenNames() { return GqlExtParser.tokenNames; }
    public String getGrammarFileName() { return "/Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g"; }


        public enum QueryType {
            SELECT, INSERT, UPDATE, DELETE
        }

        /**
         * The logger.
         */
        private Log log = LogFactory.getLog( getClass());

        private List<String> errors;
        private QueryType queryType;


        ////////////////////////////////////////////////////////////////////////////
        // Manually created methods
        ////////////////////////////////////////////////////////////////////////////

        @Override
        public void displayRecognitionError(String[] tokenNames, RecognitionException e) {
            String hdr = getErrorHeader(e);
            String msg = getErrorMessage(e, tokenNames);

            if (errors == null) errors = new ArrayList<String>();
            errors.add( hdr + " " + msg );
        }


        public List<String> getErrors() {
            return errors;
        }


        public QueryType getQueryType() {
            return queryType;
        }


        ////////////////////////////////////////////////////////////////////////////
        // Dynamically generated methods
        ////////////////////////////////////////////////////////////////////////////


    public static class gqlext_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "gqlext"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:113:1: gqlext : ( gql_select | gql_insert | gql_update | gql_delete );
    public final GqlExtParser.gqlext_return gqlext() throws RecognitionException {
        GqlExtParser.gqlext_return retval = new GqlExtParser.gqlext_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.gql_select_return gql_select1 =null;

        GqlExtParser.gql_insert_return gql_insert2 =null;

        GqlExtParser.gql_update_return gql_update3 =null;

        GqlExtParser.gql_delete_return gql_delete4 =null;




                errors = null;
                queryType = null;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:118:5: ( gql_select | gql_insert | gql_update | gql_delete )
            int alt1=4;
            switch ( input.LA(1) ) {
            case SELECT:
                {
                alt1=1;
                }
                break;
            case INSERT:
                {
                alt1=2;
                }
                break;
            case UPDATE:
                {
                alt1=3;
                }
                break;
            case DELETE:
                {
                alt1=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;

            }

            switch (alt1) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:118:7: gql_select
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_gql_select_in_gqlext135);
                    gql_select1=gql_select();

                    state._fsp--;

                    adaptor.addChild(root_0, gql_select1.getTree());

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:118:20: gql_insert
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_gql_insert_in_gqlext139);
                    gql_insert2=gql_insert();

                    state._fsp--;

                    adaptor.addChild(root_0, gql_insert2.getTree());

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:118:33: gql_update
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_gql_update_in_gqlext143);
                    gql_update3=gql_update();

                    state._fsp--;

                    adaptor.addChild(root_0, gql_update3.getTree());

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:118:46: gql_delete
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_gql_delete_in_gqlext147);
                    gql_delete4=gql_delete();

                    state._fsp--;

                    adaptor.addChild(root_0, gql_delete4.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "gqlext"


    public static class gql_select_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "gql_select"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:121:1: gql_select : SELECT get_properties FROM kindorquery ( where )? ( orderby )? ( limit )? ( offset )? -> ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final GqlExtParser.gql_select_return gql_select() throws RecognitionException {
        Query_stack.push(new Query_scope());

        GqlExtParser.gql_select_return retval = new GqlExtParser.gql_select_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token SELECT5=null;
        Token FROM7=null;
        GqlExtParser.get_properties_return get_properties6 =null;

        GqlExtParser.kindorquery_return kindorquery8 =null;

        GqlExtParser.where_return where9 =null;

        GqlExtParser.orderby_return orderby10 =null;

        GqlExtParser.limit_return limit11 =null;

        GqlExtParser.offset_return offset12 =null;


        Object SELECT5_tree=null;
        Object FROM7_tree=null;
        RewriteRuleTokenStream stream_FROM=new RewriteRuleTokenStream(adaptor,"token FROM");
        RewriteRuleTokenStream stream_SELECT=new RewriteRuleTokenStream(adaptor,"token SELECT");
        RewriteRuleSubtreeStream stream_limit=new RewriteRuleSubtreeStream(adaptor,"rule limit");
        RewriteRuleSubtreeStream stream_kindorquery=new RewriteRuleSubtreeStream(adaptor,"rule kindorquery");
        RewriteRuleSubtreeStream stream_get_properties=new RewriteRuleSubtreeStream(adaptor,"rule get_properties");
        RewriteRuleSubtreeStream stream_orderby=new RewriteRuleSubtreeStream(adaptor,"rule orderby");
        RewriteRuleSubtreeStream stream_where=new RewriteRuleSubtreeStream(adaptor,"rule where");
        RewriteRuleSubtreeStream stream_offset=new RewriteRuleSubtreeStream(adaptor,"rule offset");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:123:5: ( SELECT get_properties FROM kindorquery ( where )? ( orderby )? ( limit )? ( offset )? -> ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:5: SELECT get_properties FROM kindorquery ( where )? ( orderby )? ( limit )? ( offset )?
            {
            SELECT5=(Token)match(input,SELECT,FOLLOW_SELECT_in_gql_select173);  
            stream_SELECT.add(SELECT5);


            pushFollow(FOLLOW_get_properties_in_gql_select175);
            get_properties6=get_properties();

            state._fsp--;

            stream_get_properties.add(get_properties6.getTree());

            FROM7=(Token)match(input,FROM,FOLLOW_FROM_in_gql_select177);  
            stream_FROM.add(FROM7);


            pushFollow(FOLLOW_kindorquery_in_gql_select179);
            kindorquery8=kindorquery();

            state._fsp--;

            stream_kindorquery.add(kindorquery8.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:44: ( where )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==WHERE) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:44: where
                    {
                    pushFollow(FOLLOW_where_in_gql_select181);
                    where9=where();

                    state._fsp--;

                    stream_where.add(where9.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:51: ( orderby )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==ORDER) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:51: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_select184);
                    orderby10=orderby();

                    state._fsp--;

                    stream_orderby.add(orderby10.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:60: ( limit )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==LIMIT) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:60: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_select187);
                    limit11=limit();

                    state._fsp--;

                    stream_limit.add(limit11.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:67: ( offset )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==OFFSET) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:124:67: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_select190);
                    offset12=offset();

                    state._fsp--;

                    stream_offset.add(offset12.getTree());

                    }
                    break;

            }



                    queryType = QueryType.SELECT;
                

            // AST REWRITE
            // elements: SELECT, kindorquery, offset, orderby, limit, where, get_properties
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 127:5: -> ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:127:8: ^( SELECT kindorquery get_properties ( where )? ( orderby )? ( limit )? ( offset )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_SELECT.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_kindorquery.nextTree());

                adaptor.addChild(root_1, stream_get_properties.nextTree());

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:127:44: ( where )?
                if ( stream_where.hasNext() ) {
                    adaptor.addChild(root_1, stream_where.nextTree());

                }
                stream_where.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:127:51: ( orderby )?
                if ( stream_orderby.hasNext() ) {
                    adaptor.addChild(root_1, stream_orderby.nextTree());

                }
                stream_orderby.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:127:60: ( limit )?
                if ( stream_limit.hasNext() ) {
                    adaptor.addChild(root_1, stream_limit.nextTree());

                }
                stream_limit.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:127:67: ( offset )?
                if ( stream_offset.hasNext() ) {
                    adaptor.addChild(root_1, stream_offset.nextTree());

                }
                stream_offset.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            Query_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "gql_select"


    protected static class gql_insert_scope {
        int columnCount;
        int valueCount;
    }
    protected Stack gql_insert_stack = new Stack();


    public static class gql_insert_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "gql_insert"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:130:1: gql_insert : INSERT INTO kind columns values -> ^( INSERT kind columns values ) ;
    public final GqlExtParser.gql_insert_return gql_insert() throws RecognitionException {
        gql_insert_stack.push(new gql_insert_scope());
        GqlExtParser.gql_insert_return retval = new GqlExtParser.gql_insert_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token INSERT13=null;
        Token INTO14=null;
        GqlExtParser.kind_return kind15 =null;

        GqlExtParser.columns_return columns16 =null;

        GqlExtParser.values_return values17 =null;


        Object INSERT13_tree=null;
        Object INTO14_tree=null;
        RewriteRuleTokenStream stream_INSERT=new RewriteRuleTokenStream(adaptor,"token INSERT");
        RewriteRuleTokenStream stream_INTO=new RewriteRuleTokenStream(adaptor,"token INTO");
        RewriteRuleSubtreeStream stream_values=new RewriteRuleSubtreeStream(adaptor,"rule values");
        RewriteRuleSubtreeStream stream_columns=new RewriteRuleSubtreeStream(adaptor,"rule columns");
        RewriteRuleSubtreeStream stream_kind=new RewriteRuleSubtreeStream(adaptor,"rule kind");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:135:5: ( INSERT INTO kind columns values -> ^( INSERT kind columns values ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:136:5: INSERT INTO kind columns values
            {
            INSERT13=(Token)match(input,INSERT,FOLLOW_INSERT_in_gql_insert245);  
            stream_INSERT.add(INSERT13);


            INTO14=(Token)match(input,INTO,FOLLOW_INTO_in_gql_insert247);  
            stream_INTO.add(INTO14);


            pushFollow(FOLLOW_kind_in_gql_insert249);
            kind15=kind();

            state._fsp--;

            stream_kind.add(kind15.getTree());

            pushFollow(FOLLOW_columns_in_gql_insert251);
            columns16=columns();

            state._fsp--;

            stream_columns.add(columns16.getTree());

            pushFollow(FOLLOW_values_in_gql_insert253);
            values17=values();

            state._fsp--;

            stream_values.add(values17.getTree());


                    queryType = QueryType.INSERT;

                    if (((gql_insert_scope)gql_insert_stack.peek()).columnCount != ((gql_insert_scope)gql_insert_stack.peek()).valueCount)
                        throw new RuntimeException("Number of columns and values does not match");
                

            // AST REWRITE
            // elements: kind, values, columns, INSERT
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 142:5: -> ^( INSERT kind columns values )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:142:8: ^( INSERT kind columns values )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_INSERT.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_kind.nextTree());

                adaptor.addChild(root_1, stream_columns.nextTree());

                adaptor.addChild(root_1, stream_values.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            gql_insert_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "gql_insert"


    public static class gql_update_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "gql_update"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:145:1: gql_update : UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )? -> ^( UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final GqlExtParser.gql_update_return gql_update() throws RecognitionException {
        GqlExtParser.gql_update_return retval = new GqlExtParser.gql_update_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token UPDATE18=null;
        GqlExtParser.kind_return kind19 =null;

        GqlExtParser.set_properties_return set_properties20 =null;

        GqlExtParser.where_return where21 =null;

        GqlExtParser.orderby_return orderby22 =null;

        GqlExtParser.limit_return limit23 =null;

        GqlExtParser.offset_return offset24 =null;


        Object UPDATE18_tree=null;
        RewriteRuleTokenStream stream_UPDATE=new RewriteRuleTokenStream(adaptor,"token UPDATE");
        RewriteRuleSubtreeStream stream_limit=new RewriteRuleSubtreeStream(adaptor,"rule limit");
        RewriteRuleSubtreeStream stream_set_properties=new RewriteRuleSubtreeStream(adaptor,"rule set_properties");
        RewriteRuleSubtreeStream stream_orderby=new RewriteRuleSubtreeStream(adaptor,"rule orderby");
        RewriteRuleSubtreeStream stream_where=new RewriteRuleSubtreeStream(adaptor,"rule where");
        RewriteRuleSubtreeStream stream_offset=new RewriteRuleSubtreeStream(adaptor,"rule offset");
        RewriteRuleSubtreeStream stream_kind=new RewriteRuleSubtreeStream(adaptor,"rule kind");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:145:11: ( UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )? -> ^( UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:5: UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )?
            {
            UPDATE18=(Token)match(input,UPDATE,FOLLOW_UPDATE_in_gql_update283);  
            stream_UPDATE.add(UPDATE18);


            pushFollow(FOLLOW_kind_in_gql_update285);
            kind19=kind();

            state._fsp--;

            stream_kind.add(kind19.getTree());

            pushFollow(FOLLOW_set_properties_in_gql_update287);
            set_properties20=set_properties();

            state._fsp--;

            stream_set_properties.add(set_properties20.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:32: ( where )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==WHERE) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:32: where
                    {
                    pushFollow(FOLLOW_where_in_gql_update289);
                    where21=where();

                    state._fsp--;

                    stream_where.add(where21.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:39: ( orderby )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==ORDER) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:39: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_update292);
                    orderby22=orderby();

                    state._fsp--;

                    stream_orderby.add(orderby22.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:48: ( limit )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==LIMIT) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:48: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_update295);
                    limit23=limit();

                    state._fsp--;

                    stream_limit.add(limit23.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:55: ( offset )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==OFFSET) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:146:55: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_update298);
                    offset24=offset();

                    state._fsp--;

                    stream_offset.add(offset24.getTree());

                    }
                    break;

            }



                    queryType = QueryType.UPDATE;
                

            // AST REWRITE
            // elements: offset, UPDATE, where, set_properties, kind, orderby, limit
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 149:5: -> ^( UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )? )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:149:8: ^( UPDATE kind set_properties ( where )? ( orderby )? ( limit )? ( offset )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_UPDATE.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_kind.nextTree());

                adaptor.addChild(root_1, stream_set_properties.nextTree());

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:149:37: ( where )?
                if ( stream_where.hasNext() ) {
                    adaptor.addChild(root_1, stream_where.nextTree());

                }
                stream_where.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:149:44: ( orderby )?
                if ( stream_orderby.hasNext() ) {
                    adaptor.addChild(root_1, stream_orderby.nextTree());

                }
                stream_orderby.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:149:53: ( limit )?
                if ( stream_limit.hasNext() ) {
                    adaptor.addChild(root_1, stream_limit.nextTree());

                }
                stream_limit.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:149:60: ( offset )?
                if ( stream_offset.hasNext() ) {
                    adaptor.addChild(root_1, stream_offset.nextTree());

                }
                stream_offset.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "gql_update"


    public static class gql_delete_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "gql_delete"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:152:1: gql_delete : DELETE ( FROM )? kind ( where )? ( orderby )? ( limit )? ( offset )? -> ^( DELETE kind ( where )? ( orderby )? ( limit )? ( offset )? ) ;
    public final GqlExtParser.gql_delete_return gql_delete() throws RecognitionException {
        GqlExtParser.gql_delete_return retval = new GqlExtParser.gql_delete_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token DELETE25=null;
        Token FROM26=null;
        GqlExtParser.kind_return kind27 =null;

        GqlExtParser.where_return where28 =null;

        GqlExtParser.orderby_return orderby29 =null;

        GqlExtParser.limit_return limit30 =null;

        GqlExtParser.offset_return offset31 =null;


        Object DELETE25_tree=null;
        Object FROM26_tree=null;
        RewriteRuleTokenStream stream_DELETE=new RewriteRuleTokenStream(adaptor,"token DELETE");
        RewriteRuleTokenStream stream_FROM=new RewriteRuleTokenStream(adaptor,"token FROM");
        RewriteRuleSubtreeStream stream_limit=new RewriteRuleSubtreeStream(adaptor,"rule limit");
        RewriteRuleSubtreeStream stream_orderby=new RewriteRuleSubtreeStream(adaptor,"rule orderby");
        RewriteRuleSubtreeStream stream_where=new RewriteRuleSubtreeStream(adaptor,"rule where");
        RewriteRuleSubtreeStream stream_offset=new RewriteRuleSubtreeStream(adaptor,"rule offset");
        RewriteRuleSubtreeStream stream_kind=new RewriteRuleSubtreeStream(adaptor,"rule kind");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:152:11: ( DELETE ( FROM )? kind ( where )? ( orderby )? ( limit )? ( offset )? -> ^( DELETE kind ( where )? ( orderby )? ( limit )? ( offset )? ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:5: DELETE ( FROM )? kind ( where )? ( orderby )? ( limit )? ( offset )?
            {
            DELETE25=(Token)match(input,DELETE,FOLLOW_DELETE_in_gql_delete339);  
            stream_DELETE.add(DELETE25);


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:12: ( FROM )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==FROM) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:12: FROM
                    {
                    FROM26=(Token)match(input,FROM,FOLLOW_FROM_in_gql_delete341);  
                    stream_FROM.add(FROM26);


                    }
                    break;

            }


            pushFollow(FOLLOW_kind_in_gql_delete344);
            kind27=kind();

            state._fsp--;

            stream_kind.add(kind27.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:23: ( where )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==WHERE) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:23: where
                    {
                    pushFollow(FOLLOW_where_in_gql_delete346);
                    where28=where();

                    state._fsp--;

                    stream_where.add(where28.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:30: ( orderby )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==ORDER) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:30: orderby
                    {
                    pushFollow(FOLLOW_orderby_in_gql_delete349);
                    orderby29=orderby();

                    state._fsp--;

                    stream_orderby.add(orderby29.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:39: ( limit )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==LIMIT) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:39: limit
                    {
                    pushFollow(FOLLOW_limit_in_gql_delete352);
                    limit30=limit();

                    state._fsp--;

                    stream_limit.add(limit30.getTree());

                    }
                    break;

            }


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:46: ( offset )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==OFFSET) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:153:46: offset
                    {
                    pushFollow(FOLLOW_offset_in_gql_delete355);
                    offset31=offset();

                    state._fsp--;

                    stream_offset.add(offset31.getTree());

                    }
                    break;

            }



                    queryType = QueryType.DELETE;
                

            // AST REWRITE
            // elements: limit, kind, offset, DELETE, orderby, where
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 156:5: -> ^( DELETE kind ( where )? ( orderby )? ( limit )? ( offset )? )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:156:8: ^( DELETE kind ( where )? ( orderby )? ( limit )? ( offset )? )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_DELETE.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_kind.nextTree());

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:156:22: ( where )?
                if ( stream_where.hasNext() ) {
                    adaptor.addChild(root_1, stream_where.nextTree());

                }
                stream_where.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:156:29: ( orderby )?
                if ( stream_orderby.hasNext() ) {
                    adaptor.addChild(root_1, stream_orderby.nextTree());

                }
                stream_orderby.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:156:38: ( limit )?
                if ( stream_limit.hasNext() ) {
                    adaptor.addChild(root_1, stream_limit.nextTree());

                }
                stream_limit.reset();

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:156:45: ( offset )?
                if ( stream_offset.hasNext() ) {
                    adaptor.addChild(root_1, stream_offset.nextTree());

                }
                stream_offset.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "gql_delete"


    public static class kindorquery_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "kindorquery"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:159:1: kindorquery : ( kind -> kind | DUAL -> DUAL | LEFT_PAR gql_select RIGHT_PAR -> gql_select );
    public final GqlExtParser.kindorquery_return kindorquery() throws RecognitionException {
        GqlExtParser.kindorquery_return retval = new GqlExtParser.kindorquery_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token DUAL33=null;
        Token LEFT_PAR34=null;
        Token RIGHT_PAR36=null;
        GqlExtParser.kind_return kind32 =null;

        GqlExtParser.gql_select_return gql_select35 =null;


        Object DUAL33_tree=null;
        Object LEFT_PAR34_tree=null;
        Object RIGHT_PAR36_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_DUAL=new RewriteRuleTokenStream(adaptor,"token DUAL");
        RewriteRuleSubtreeStream stream_gql_select=new RewriteRuleSubtreeStream(adaptor,"rule gql_select");
        RewriteRuleSubtreeStream stream_kind=new RewriteRuleSubtreeStream(adaptor,"rule kind");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:159:12: ( kind -> kind | DUAL -> DUAL | LEFT_PAR gql_select RIGHT_PAR -> gql_select )
            int alt15=3;
            switch ( input.LA(1) ) {
            case ID:
            case KIND:
                {
                alt15=1;
                }
                break;
            case DUAL:
                {
                alt15=2;
                }
                break;
            case LEFT_PAR:
                {
                alt15=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 15, 0, input);

                throw nvae;

            }

            switch (alt15) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:160:5: kind
                    {
                    pushFollow(FOLLOW_kind_in_kindorquery394);
                    kind32=kind();

                    state._fsp--;

                    stream_kind.add(kind32.getTree());

                    // AST REWRITE
                    // elements: kind
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 160:10: -> kind
                    {
                        adaptor.addChild(root_0, stream_kind.nextTree());

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:161:7: DUAL
                    {
                    DUAL33=(Token)match(input,DUAL,FOLLOW_DUAL_in_kindorquery406);  
                    stream_DUAL.add(DUAL33);


                    // AST REWRITE
                    // elements: DUAL
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 161:12: -> DUAL
                    {
                        adaptor.addChild(root_0, 
                        stream_DUAL.nextNode()
                        );

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:162:7: LEFT_PAR gql_select RIGHT_PAR
                    {
                    LEFT_PAR34=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_kindorquery418);  
                    stream_LEFT_PAR.add(LEFT_PAR34);


                    pushFollow(FOLLOW_gql_select_in_kindorquery420);
                    gql_select35=gql_select();

                    state._fsp--;

                    stream_gql_select.add(gql_select35.getTree());

                    RIGHT_PAR36=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_kindorquery422);  
                    stream_RIGHT_PAR.add(RIGHT_PAR36);



                            ((Query_scope)Query_stack.peek()).hasNestedQuery = true;
                        

                    // AST REWRITE
                    // elements: gql_select
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 164:7: -> gql_select
                    {
                        adaptor.addChild(root_0, stream_gql_select.nextTree());

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "kindorquery"


    public static class get_properties_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "get_properties"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:167:1: get_properties : get_property ( COMMA get_property )* -> ^( PROP ( get_property )+ ) ;
    public final GqlExtParser.get_properties_return get_properties() throws RecognitionException {
        Expr_stack.push(new Expr_scope());

        GqlExtParser.get_properties_return retval = new GqlExtParser.get_properties_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token COMMA38=null;
        GqlExtParser.get_property_return get_property37 =null;

        GqlExtParser.get_property_return get_property39 =null;


        Object COMMA38_tree=null;
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_get_property=new RewriteRuleSubtreeStream(adaptor,"rule get_property");

                ((Expr_scope)Expr_stack.peek()).hasEntity = true;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:172:5: ( get_property ( COMMA get_property )* -> ^( PROP ( get_property )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:173:5: get_property ( COMMA get_property )*
            {
            pushFollow(FOLLOW_get_property_in_get_properties463);
            get_property37=get_property();

            state._fsp--;

            stream_get_property.add(get_property37.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:173:18: ( COMMA get_property )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==COMMA) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:173:19: COMMA get_property
            	    {
            	    COMMA38=(Token)match(input,COMMA,FOLLOW_COMMA_in_get_properties466);  
            	    stream_COMMA.add(COMMA38);


            	    pushFollow(FOLLOW_get_property_in_get_properties468);
            	    get_property39=get_property();

            	    state._fsp--;

            	    stream_get_property.add(get_property39.getTree());

            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);


            // AST REWRITE
            // elements: get_property
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 174:5: -> ^( PROP ( get_property )+ )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:174:8: ^( PROP ( get_property )+ )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                (Object)adaptor.create(PROP, "PROP")
                , root_1);

                if ( !(stream_get_property.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_get_property.hasNext() ) {
                    adaptor.addChild(root_1, stream_get_property.nextTree());

                }
                stream_get_property.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            Expr_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "get_properties"


    public static class get_property_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "get_property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:177:1: get_property : ( ASTERISK | prop | get_property_expr );
    public final GqlExtParser.get_property_return get_property() throws RecognitionException {
        GqlExtParser.get_property_return retval = new GqlExtParser.get_property_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token ASTERISK40=null;
        GqlExtParser.prop_return prop41 =null;

        GqlExtParser.get_property_expr_return get_property_expr42 =null;


        Object ASTERISK40_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:177:13: ( ASTERISK | prop | get_property_expr )
            int alt17=3;
            alt17 = dfa17.predict(input);
            switch (alt17) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:177:15: ASTERISK
                    {
                    root_0 = (Object)adaptor.nil();


                    ASTERISK40=(Token)match(input,ASTERISK,FOLLOW_ASTERISK_in_get_property491); 
                    ASTERISK40_tree = 
                    (Object)adaptor.create(ASTERISK40)
                    ;
                    adaptor.addChild(root_0, ASTERISK40_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:177:26: prop
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_prop_in_get_property495);
                    prop41=prop();

                    state._fsp--;

                    adaptor.addChild(root_0, prop41.getTree());

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:177:33: get_property_expr
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_get_property_expr_in_get_property499);
                    get_property_expr42=get_property_expr();

                    state._fsp--;

                    adaptor.addChild(root_0, get_property_expr42.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "get_property"


    public static class get_property_expr_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "get_property_expr"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:179:1: get_property_expr : expr ( AS )? alias -> ^( COLAS alias expr ) ;
    public final GqlExtParser.get_property_expr_return get_property_expr() throws RecognitionException {
        GqlExtParser.get_property_expr_return retval = new GqlExtParser.get_property_expr_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token AS44=null;
        GqlExtParser.expr_return expr43 =null;

        GqlExtParser.alias_return alias45 =null;


        Object AS44_tree=null;
        RewriteRuleTokenStream stream_AS=new RewriteRuleTokenStream(adaptor,"token AS");
        RewriteRuleSubtreeStream stream_alias=new RewriteRuleSubtreeStream(adaptor,"rule alias");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:179:18: ( expr ( AS )? alias -> ^( COLAS alias expr ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:180:5: expr ( AS )? alias
            {
            pushFollow(FOLLOW_expr_in_get_property_expr510);
            expr43=expr();

            state._fsp--;

            stream_expr.add(expr43.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:180:10: ( AS )?
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==AS) ) {
                alt18=1;
            }
            switch (alt18) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:180:10: AS
                    {
                    AS44=(Token)match(input,AS,FOLLOW_AS_in_get_property_expr512);  
                    stream_AS.add(AS44);


                    }
                    break;

            }


            pushFollow(FOLLOW_alias_in_get_property_expr515);
            alias45=alias();

            state._fsp--;

            stream_alias.add(alias45.getTree());

            // AST REWRITE
            // elements: expr, alias
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 180:20: -> ^( COLAS alias expr )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:180:23: ^( COLAS alias expr )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                (Object)adaptor.create(COLAS, "COLAS")
                , root_1);

                adaptor.addChild(root_1, stream_alias.nextTree());

                adaptor.addChild(root_1, stream_expr.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "get_property_expr"


    public static class alias_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "alias"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:183:1: alias : ( KEYPROP | aliasnokey );
    public final GqlExtParser.alias_return alias() throws RecognitionException {
        GqlExtParser.alias_return retval = new GqlExtParser.alias_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token KEYPROP46=null;
        GqlExtParser.aliasnokey_return aliasnokey47 =null;


        Object KEYPROP46_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:183:6: ( KEYPROP | aliasnokey )
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==KEYPROP) ) {
                alt19=1;
            }
            else if ( (LA19_0==EMPTY||LA19_0==ID||LA19_0==PROP||LA19_0==STRING||LA19_0==UNINDEXED) ) {
                alt19=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;

            }
            switch (alt19) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:183:8: KEYPROP
                    {
                    root_0 = (Object)adaptor.nil();


                    KEYPROP46=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_alias533); 
                    KEYPROP46_tree = 
                    (Object)adaptor.create(KEYPROP46)
                    ;
                    adaptor.addChild(root_0, KEYPROP46_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:183:18: aliasnokey
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_aliasnokey_in_alias537);
                    aliasnokey47=aliasnokey();

                    state._fsp--;

                    adaptor.addChild(root_0, aliasnokey47.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "alias"


    public static class aliasnokey_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "aliasnokey"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:185:1: aliasnokey : ( STRING | property | ( UNINDEXED LEFT_PAR STRING RIGHT_PAR -> ^( UNINDEXED STRING ) ) | ( EMPTY LEFT_PAR STRING RIGHT_PAR -> ^( EMPTY STRING ) ) );
    public final GqlExtParser.aliasnokey_return aliasnokey() throws RecognitionException {
        GqlExtParser.aliasnokey_return retval = new GqlExtParser.aliasnokey_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token STRING48=null;
        Token UNINDEXED50=null;
        Token LEFT_PAR51=null;
        Token STRING52=null;
        Token RIGHT_PAR53=null;
        Token EMPTY54=null;
        Token LEFT_PAR55=null;
        Token STRING56=null;
        Token RIGHT_PAR57=null;
        GqlExtParser.property_return property49 =null;


        Object STRING48_tree=null;
        Object UNINDEXED50_tree=null;
        Object LEFT_PAR51_tree=null;
        Object STRING52_tree=null;
        Object RIGHT_PAR53_tree=null;
        Object EMPTY54_tree=null;
        Object LEFT_PAR55_tree=null;
        Object STRING56_tree=null;
        Object RIGHT_PAR57_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_UNINDEXED=new RewriteRuleTokenStream(adaptor,"token UNINDEXED");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleTokenStream stream_EMPTY=new RewriteRuleTokenStream(adaptor,"token EMPTY");

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:185:11: ( STRING | property | ( UNINDEXED LEFT_PAR STRING RIGHT_PAR -> ^( UNINDEXED STRING ) ) | ( EMPTY LEFT_PAR STRING RIGHT_PAR -> ^( EMPTY STRING ) ) )
            int alt20=4;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt20=1;
                }
                break;
            case ID:
            case PROP:
                {
                alt20=2;
                }
                break;
            case UNINDEXED:
                {
                alt20=3;
                }
                break;
            case EMPTY:
                {
                alt20=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;

            }

            switch (alt20) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:186:5: STRING
                    {
                    root_0 = (Object)adaptor.nil();


                    STRING48=(Token)match(input,STRING,FOLLOW_STRING_in_aliasnokey548); 
                    STRING48_tree = 
                    (Object)adaptor.create(STRING48)
                    ;
                    adaptor.addChild(root_0, STRING48_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:187:7: property
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_property_in_aliasnokey557);
                    property49=property();

                    state._fsp--;

                    adaptor.addChild(root_0, property49.getTree());

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:188:7: ( UNINDEXED LEFT_PAR STRING RIGHT_PAR -> ^( UNINDEXED STRING ) )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:188:7: ( UNINDEXED LEFT_PAR STRING RIGHT_PAR -> ^( UNINDEXED STRING ) )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:188:8: UNINDEXED LEFT_PAR STRING RIGHT_PAR
                    {
                    UNINDEXED50=(Token)match(input,UNINDEXED,FOLLOW_UNINDEXED_in_aliasnokey566);  
                    stream_UNINDEXED.add(UNINDEXED50);


                    LEFT_PAR51=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_aliasnokey568);  
                    stream_LEFT_PAR.add(LEFT_PAR51);


                    STRING52=(Token)match(input,STRING,FOLLOW_STRING_in_aliasnokey570);  
                    stream_STRING.add(STRING52);


                    RIGHT_PAR53=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_aliasnokey572);  
                    stream_RIGHT_PAR.add(RIGHT_PAR53);


                    // AST REWRITE
                    // elements: STRING, UNINDEXED
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 188:44: -> ^( UNINDEXED STRING )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:188:47: ^( UNINDEXED STRING )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_UNINDEXED.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_STRING.nextNode()
                        );

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }


                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:189:7: ( EMPTY LEFT_PAR STRING RIGHT_PAR -> ^( EMPTY STRING ) )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:189:7: ( EMPTY LEFT_PAR STRING RIGHT_PAR -> ^( EMPTY STRING ) )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:189:8: EMPTY LEFT_PAR STRING RIGHT_PAR
                    {
                    EMPTY54=(Token)match(input,EMPTY,FOLLOW_EMPTY_in_aliasnokey590);  
                    stream_EMPTY.add(EMPTY54);


                    LEFT_PAR55=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_aliasnokey592);  
                    stream_LEFT_PAR.add(LEFT_PAR55);


                    STRING56=(Token)match(input,STRING,FOLLOW_STRING_in_aliasnokey594);  
                    stream_STRING.add(STRING56);


                    RIGHT_PAR57=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_aliasnokey596);  
                    stream_RIGHT_PAR.add(RIGHT_PAR57);


                    // AST REWRITE
                    // elements: EMPTY, STRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 189:40: -> ^( EMPTY STRING )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:189:43: ^( EMPTY STRING )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_EMPTY.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_STRING.nextNode()
                        );

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }


                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "aliasnokey"


    public static class columns_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "columns"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:192:1: columns : LEFT_PAR column ( COMMA column )* RIGHT_PAR -> ^( COLAS ( column )+ ) ;
    public final GqlExtParser.columns_return columns() throws RecognitionException {
        GqlExtParser.columns_return retval = new GqlExtParser.columns_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token LEFT_PAR58=null;
        Token COMMA60=null;
        Token RIGHT_PAR62=null;
        GqlExtParser.column_return column59 =null;

        GqlExtParser.column_return column61 =null;


        Object LEFT_PAR58_tree=null;
        Object COMMA60_tree=null;
        Object RIGHT_PAR62_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleSubtreeStream stream_column=new RewriteRuleSubtreeStream(adaptor,"rule column");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:192:8: ( LEFT_PAR column ( COMMA column )* RIGHT_PAR -> ^( COLAS ( column )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:193:5: LEFT_PAR column ( COMMA column )* RIGHT_PAR
            {
            LEFT_PAR58=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_columns617);  
            stream_LEFT_PAR.add(LEFT_PAR58);


            pushFollow(FOLLOW_column_in_columns619);
            column59=column();

            state._fsp--;

            stream_column.add(column59.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:193:21: ( COMMA column )*
            loop21:
            do {
                int alt21=2;
                int LA21_0 = input.LA(1);

                if ( (LA21_0==COMMA) ) {
                    alt21=1;
                }


                switch (alt21) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:193:22: COMMA column
            	    {
            	    COMMA60=(Token)match(input,COMMA,FOLLOW_COMMA_in_columns622);  
            	    stream_COMMA.add(COMMA60);


            	    pushFollow(FOLLOW_column_in_columns624);
            	    column61=column();

            	    state._fsp--;

            	    stream_column.add(column61.getTree());

            	    }
            	    break;

            	default :
            	    break loop21;
                }
            } while (true);


            RIGHT_PAR62=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_columns628);  
            stream_RIGHT_PAR.add(RIGHT_PAR62);


            // AST REWRITE
            // elements: column
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 194:5: -> ^( COLAS ( column )+ )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:194:8: ^( COLAS ( column )+ )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                (Object)adaptor.create(COLAS, "COLAS")
                , root_1);

                if ( !(stream_column.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_column.hasNext() ) {
                    adaptor.addChild(root_1, stream_column.nextTree());

                }
                stream_column.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "columns"


    public static class column_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "column"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:197:1: column : alias ;
    public final GqlExtParser.column_return column() throws RecognitionException {
        GqlExtParser.column_return retval = new GqlExtParser.column_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.alias_return alias63 =null;



        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:197:7: ( alias )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:198:5: alias
            {
            root_0 = (Object)adaptor.nil();


            pushFollow(FOLLOW_alias_in_column653);
            alias63=alias();

            state._fsp--;

            adaptor.addChild(root_0, alias63.getTree());


                    ((gql_insert_scope)gql_insert_stack.peek()).columnCount++;
                

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "column"


    public static class values_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "values"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:203:1: values : VALUES LEFT_PAR value ( COMMA value )* RIGHT_PAR -> ^( VALUES ( value )+ ) ;
    public final GqlExtParser.values_return values() throws RecognitionException {
        Expr_stack.push(new Expr_scope());

        GqlExtParser.values_return retval = new GqlExtParser.values_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token VALUES64=null;
        Token LEFT_PAR65=null;
        Token COMMA67=null;
        Token RIGHT_PAR69=null;
        GqlExtParser.value_return value66 =null;

        GqlExtParser.value_return value68 =null;


        Object VALUES64_tree=null;
        Object LEFT_PAR65_tree=null;
        Object COMMA67_tree=null;
        Object RIGHT_PAR69_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_VALUES=new RewriteRuleTokenStream(adaptor,"token VALUES");
        RewriteRuleSubtreeStream stream_value=new RewriteRuleSubtreeStream(adaptor,"rule value");

                ((Expr_scope)Expr_stack.peek()).hasEntity = false;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:208:5: ( VALUES LEFT_PAR value ( COMMA value )* RIGHT_PAR -> ^( VALUES ( value )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:209:5: VALUES LEFT_PAR value ( COMMA value )* RIGHT_PAR
            {
            VALUES64=(Token)match(input,VALUES,FOLLOW_VALUES_in_values690);  
            stream_VALUES.add(VALUES64);


            LEFT_PAR65=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_values692);  
            stream_LEFT_PAR.add(LEFT_PAR65);


            pushFollow(FOLLOW_value_in_values694);
            value66=value();

            state._fsp--;

            stream_value.add(value66.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:209:27: ( COMMA value )*
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);

                if ( (LA22_0==COMMA) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:209:28: COMMA value
            	    {
            	    COMMA67=(Token)match(input,COMMA,FOLLOW_COMMA_in_values697);  
            	    stream_COMMA.add(COMMA67);


            	    pushFollow(FOLLOW_value_in_values699);
            	    value68=value();

            	    state._fsp--;

            	    stream_value.add(value68.getTree());

            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);


            RIGHT_PAR69=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_values703);  
            stream_RIGHT_PAR.add(RIGHT_PAR69);


            // AST REWRITE
            // elements: value, VALUES
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 210:5: -> ^( VALUES ( value )+ )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:210:8: ^( VALUES ( value )+ )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_VALUES.nextNode()
                , root_1);

                if ( !(stream_value.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_value.hasNext() ) {
                    adaptor.addChild(root_1, stream_value.nextTree());

                }
                stream_value.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            Expr_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "values"


    public static class value_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "value"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:213:1: value : expr ;
    public final GqlExtParser.value_return value() throws RecognitionException {
        GqlExtParser.value_return retval = new GqlExtParser.value_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.expr_return expr70 =null;



        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:213:6: ( expr )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:214:5: expr
            {
            root_0 = (Object)adaptor.nil();


            pushFollow(FOLLOW_expr_in_value728);
            expr70=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr70.getTree());


                    ((gql_insert_scope)gql_insert_stack.peek()).valueCount++;
                

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "value"


    public static class set_properties_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "set_properties"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:219:1: set_properties : SET set_property ( COMMA set_property )* -> ^( SET ( set_property )+ ) ;
    public final GqlExtParser.set_properties_return set_properties() throws RecognitionException {
        Expr_stack.push(new Expr_scope());

        GqlExtParser.set_properties_return retval = new GqlExtParser.set_properties_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token SET71=null;
        Token COMMA73=null;
        GqlExtParser.set_property_return set_property72 =null;

        GqlExtParser.set_property_return set_property74 =null;


        Object SET71_tree=null;
        Object COMMA73_tree=null;
        RewriteRuleTokenStream stream_SET=new RewriteRuleTokenStream(adaptor,"token SET");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_set_property=new RewriteRuleSubtreeStream(adaptor,"rule set_property");

                ((Expr_scope)Expr_stack.peek()).hasEntity = true;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:224:5: ( SET set_property ( COMMA set_property )* -> ^( SET ( set_property )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:225:5: SET set_property ( COMMA set_property )*
            {
            SET71=(Token)match(input,SET,FOLLOW_SET_in_set_properties765);  
            stream_SET.add(SET71);


            pushFollow(FOLLOW_set_property_in_set_properties767);
            set_property72=set_property();

            state._fsp--;

            stream_set_property.add(set_property72.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:225:22: ( COMMA set_property )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==COMMA) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:225:23: COMMA set_property
            	    {
            	    COMMA73=(Token)match(input,COMMA,FOLLOW_COMMA_in_set_properties770);  
            	    stream_COMMA.add(COMMA73);


            	    pushFollow(FOLLOW_set_property_in_set_properties772);
            	    set_property74=set_property();

            	    state._fsp--;

            	    stream_set_property.add(set_property74.getTree());

            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);


            // AST REWRITE
            // elements: SET, set_property
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 226:5: -> ^( SET ( set_property )+ )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:226:8: ^( SET ( set_property )+ )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_SET.nextNode()
                , root_1);

                if ( !(stream_set_property.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_set_property.hasNext() ) {
                    adaptor.addChild(root_1, stream_set_property.nextTree());

                }
                stream_set_property.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            Expr_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "set_properties"


    public static class set_property_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "set_property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:229:1: set_property : aliasnokey EQ expr -> ^( EQ aliasnokey expr ) ;
    public final GqlExtParser.set_property_return set_property() throws RecognitionException {
        GqlExtParser.set_property_return retval = new GqlExtParser.set_property_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token EQ76=null;
        GqlExtParser.aliasnokey_return aliasnokey75 =null;

        GqlExtParser.expr_return expr77 =null;


        Object EQ76_tree=null;
        RewriteRuleTokenStream stream_EQ=new RewriteRuleTokenStream(adaptor,"token EQ");
        RewriteRuleSubtreeStream stream_aliasnokey=new RewriteRuleSubtreeStream(adaptor,"rule aliasnokey");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:229:13: ( aliasnokey EQ expr -> ^( EQ aliasnokey expr ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:230:5: aliasnokey EQ expr
            {
            pushFollow(FOLLOW_aliasnokey_in_set_property799);
            aliasnokey75=aliasnokey();

            state._fsp--;

            stream_aliasnokey.add(aliasnokey75.getTree());

            EQ76=(Token)match(input,EQ,FOLLOW_EQ_in_set_property801);  
            stream_EQ.add(EQ76);


            pushFollow(FOLLOW_expr_in_set_property803);
            expr77=expr();

            state._fsp--;

            stream_expr.add(expr77.getTree());

            // AST REWRITE
            // elements: EQ, aliasnokey, expr
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 231:5: -> ^( EQ aliasnokey expr )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:231:8: ^( EQ aliasnokey expr )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_EQ.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_aliasnokey.nextTree());

                adaptor.addChild(root_1, stream_expr.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "set_property"


    public static class where_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "where"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:234:1: where : ( WHERE condition ( AND condition )* ( softwhere )? -> ^( WHERE ( condition )+ ( softwhere )? ) | WHERE softwhere -> ^( WHERE softwhere ) );
    public final GqlExtParser.where_return where() throws RecognitionException {
        GqlExtParser.where_return retval = new GqlExtParser.where_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token WHERE78=null;
        Token AND80=null;
        Token WHERE83=null;
        GqlExtParser.condition_return condition79 =null;

        GqlExtParser.condition_return condition81 =null;

        GqlExtParser.softwhere_return softwhere82 =null;

        GqlExtParser.softwhere_return softwhere84 =null;


        Object WHERE78_tree=null;
        Object AND80_tree=null;
        Object WHERE83_tree=null;
        RewriteRuleTokenStream stream_WHERE=new RewriteRuleTokenStream(adaptor,"token WHERE");
        RewriteRuleTokenStream stream_AND=new RewriteRuleTokenStream(adaptor,"token AND");
        RewriteRuleSubtreeStream stream_softwhere=new RewriteRuleSubtreeStream(adaptor,"rule softwhere");
        RewriteRuleSubtreeStream stream_condition=new RewriteRuleSubtreeStream(adaptor,"rule condition");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:234:6: ( WHERE condition ( AND condition )* ( softwhere )? -> ^( WHERE ( condition )+ ( softwhere )? ) | WHERE softwhere -> ^( WHERE softwhere ) )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==WHERE) ) {
                int LA26_1 = input.LA(2);

                if ( (LA26_1==ANCESTOR||LA26_1==ID||LA26_1==KEYPROP||LA26_1==PROP) ) {
                    alt26=1;
                }
                else if ( (LA26_1==SOFT) ) {
                    alt26=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 26, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;

            }
            switch (alt26) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:5: WHERE condition ( AND condition )* ( softwhere )?
                    {
                    WHERE78=(Token)match(input,WHERE,FOLLOW_WHERE_in_where829);  
                    stream_WHERE.add(WHERE78);


                    pushFollow(FOLLOW_condition_in_where831);
                    condition79=condition();

                    state._fsp--;

                    stream_condition.add(condition79.getTree());

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:21: ( AND condition )*
                    loop24:
                    do {
                        int alt24=2;
                        int LA24_0 = input.LA(1);

                        if ( (LA24_0==AND) ) {
                            alt24=1;
                        }


                        switch (alt24) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:22: AND condition
                    	    {
                    	    AND80=(Token)match(input,AND,FOLLOW_AND_in_where834);  
                    	    stream_AND.add(AND80);


                    	    pushFollow(FOLLOW_condition_in_where836);
                    	    condition81=condition();

                    	    state._fsp--;

                    	    stream_condition.add(condition81.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop24;
                        }
                    } while (true);


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:38: ( softwhere )?
                    int alt25=2;
                    int LA25_0 = input.LA(1);

                    if ( (LA25_0==SOFT) ) {
                        alt25=1;
                    }
                    switch (alt25) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:38: softwhere
                            {
                            pushFollow(FOLLOW_softwhere_in_where840);
                            softwhere82=softwhere();

                            state._fsp--;

                            stream_softwhere.add(softwhere82.getTree());

                            }
                            break;

                    }


                    // AST REWRITE
                    // elements: WHERE, condition, softwhere
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 235:49: -> ^( WHERE ( condition )+ ( softwhere )? )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:52: ^( WHERE ( condition )+ ( softwhere )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_WHERE.nextNode()
                        , root_1);

                        if ( !(stream_condition.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_condition.hasNext() ) {
                            adaptor.addChild(root_1, stream_condition.nextTree());

                        }
                        stream_condition.reset();

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:235:71: ( softwhere )?
                        if ( stream_softwhere.hasNext() ) {
                            adaptor.addChild(root_1, stream_softwhere.nextTree());

                        }
                        stream_softwhere.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:236:7: WHERE softwhere
                    {
                    WHERE83=(Token)match(input,WHERE,FOLLOW_WHERE_in_where861);  
                    stream_WHERE.add(WHERE83);


                    pushFollow(FOLLOW_softwhere_in_where863);
                    softwhere84=softwhere();

                    state._fsp--;

                    stream_softwhere.add(softwhere84.getTree());

                    // AST REWRITE
                    // elements: WHERE, softwhere
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 236:23: -> ^( WHERE softwhere )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:236:26: ^( WHERE softwhere )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_WHERE.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_softwhere.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "where"


    public static class softwhere_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "softwhere"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:239:1: softwhere : SOFT softcondmul ( OR ^ softcondmul )* ;
    public final GqlExtParser.softwhere_return softwhere() throws RecognitionException {
        Expr_stack.push(new Expr_scope());

        GqlExtParser.softwhere_return retval = new GqlExtParser.softwhere_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token SOFT85=null;
        Token OR87=null;
        GqlExtParser.softcondmul_return softcondmul86 =null;

        GqlExtParser.softcondmul_return softcondmul88 =null;


        Object SOFT85_tree=null;
        Object OR87_tree=null;


                ((Expr_scope)Expr_stack.peek()).hasEntity = true;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:244:5: ( SOFT softcondmul ( OR ^ softcondmul )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:245:5: SOFT softcondmul ( OR ^ softcondmul )*
            {
            root_0 = (Object)adaptor.nil();


            SOFT85=(Token)match(input,SOFT,FOLLOW_SOFT_in_softwhere906); 
            SOFT85_tree = 
            (Object)adaptor.create(SOFT85)
            ;
            adaptor.addChild(root_0, SOFT85_tree);


            pushFollow(FOLLOW_softcondmul_in_softwhere908);
            softcondmul86=softcondmul();

            state._fsp--;

            adaptor.addChild(root_0, softcondmul86.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:245:22: ( OR ^ softcondmul )*
            loop27:
            do {
                int alt27=2;
                int LA27_0 = input.LA(1);

                if ( (LA27_0==OR) ) {
                    alt27=1;
                }


                switch (alt27) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:245:23: OR ^ softcondmul
            	    {
            	    OR87=(Token)match(input,OR,FOLLOW_OR_in_softwhere911); 
            	    OR87_tree = 
            	    (Object)adaptor.create(OR87)
            	    ;
            	    root_0 = (Object)adaptor.becomeRoot(OR87_tree, root_0);


            	    pushFollow(FOLLOW_softcondmul_in_softwhere914);
            	    softcondmul88=softcondmul();

            	    state._fsp--;

            	    adaptor.addChild(root_0, softcondmul88.getTree());

            	    }
            	    break;

            	default :
            	    break loop27;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            Expr_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "softwhere"


    public static class condition_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "condition"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:1: condition : ( cond | condkey | condancestor | condin | condkeyin );
    public final GqlExtParser.condition_return condition() throws RecognitionException {
        GqlExtParser.condition_return retval = new GqlExtParser.condition_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.cond_return cond89 =null;

        GqlExtParser.condkey_return condkey90 =null;

        GqlExtParser.condancestor_return condancestor91 =null;

        GqlExtParser.condin_return condin92 =null;

        GqlExtParser.condkeyin_return condkeyin93 =null;



        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:10: ( cond | condkey | condancestor | condin | condkeyin )
            int alt28=5;
            alt28 = dfa28.predict(input);
            switch (alt28) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:12: cond
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_cond_in_condition924);
                    cond89=cond();

                    state._fsp--;

                    adaptor.addChild(root_0, cond89.getTree());

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:19: condkey
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_condkey_in_condition928);
                    condkey90=condkey();

                    state._fsp--;

                    adaptor.addChild(root_0, condkey90.getTree());

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:29: condancestor
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_condancestor_in_condition932);
                    condancestor91=condancestor();

                    state._fsp--;

                    adaptor.addChild(root_0, condancestor91.getTree());

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:44: condin
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_condin_in_condition936);
                    condin92=condin();

                    state._fsp--;

                    adaptor.addChild(root_0, condin92.getTree());

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:248:53: condkeyin
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_condkeyin_in_condition940);
                    condkeyin93=condkeyin();

                    state._fsp--;

                    adaptor.addChild(root_0, condkeyin93.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "condition"


    public static class cond_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "cond"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:251:1: cond : property oper valorvarobj -> ^( oper property valorvarobj ) ;
    public final GqlExtParser.cond_return cond() throws RecognitionException {
        GqlExtParser.cond_return retval = new GqlExtParser.cond_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.property_return property94 =null;

        GqlExtParser.oper_return oper95 =null;

        GqlExtParser.valorvarobj_return valorvarobj96 =null;


        RewriteRuleSubtreeStream stream_valorvarobj=new RewriteRuleSubtreeStream(adaptor,"rule valorvarobj");
        RewriteRuleSubtreeStream stream_oper=new RewriteRuleSubtreeStream(adaptor,"rule oper");
        RewriteRuleSubtreeStream stream_property=new RewriteRuleSubtreeStream(adaptor,"rule property");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:251:5: ( property oper valorvarobj -> ^( oper property valorvarobj ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:252:5: property oper valorvarobj
            {
            pushFollow(FOLLOW_property_in_cond952);
            property94=property();

            state._fsp--;

            stream_property.add(property94.getTree());

            pushFollow(FOLLOW_oper_in_cond954);
            oper95=oper();

            state._fsp--;

            stream_oper.add(oper95.getTree());

            pushFollow(FOLLOW_valorvarobj_in_cond956);
            valorvarobj96=valorvarobj();

            state._fsp--;

            stream_valorvarobj.add(valorvarobj96.getTree());

            // AST REWRITE
            // elements: valorvarobj, property, oper
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 253:5: -> ^( oper property valorvarobj )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:253:8: ^( oper property valorvarobj )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_oper.nextNode(), root_1);

                adaptor.addChild(root_1, stream_property.nextTree());

                adaptor.addChild(root_1, stream_valorvarobj.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "cond"


    public static class condkey_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "condkey"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:256:1: condkey : KEYPROP oper key -> ^( oper KEYPROP key ) ;
    public final GqlExtParser.condkey_return condkey() throws RecognitionException {
        GqlExtParser.condkey_return retval = new GqlExtParser.condkey_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token KEYPROP97=null;
        GqlExtParser.oper_return oper98 =null;

        GqlExtParser.key_return key99 =null;


        Object KEYPROP97_tree=null;
        RewriteRuleTokenStream stream_KEYPROP=new RewriteRuleTokenStream(adaptor,"token KEYPROP");
        RewriteRuleSubtreeStream stream_oper=new RewriteRuleSubtreeStream(adaptor,"rule oper");
        RewriteRuleSubtreeStream stream_key=new RewriteRuleSubtreeStream(adaptor,"rule key");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:256:8: ( KEYPROP oper key -> ^( oper KEYPROP key ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:257:5: KEYPROP oper key
            {
            KEYPROP97=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkey982);  
            stream_KEYPROP.add(KEYPROP97);


            pushFollow(FOLLOW_oper_in_condkey984);
            oper98=oper();

            state._fsp--;

            stream_oper.add(oper98.getTree());

            pushFollow(FOLLOW_key_in_condkey986);
            key99=key();

            state._fsp--;

            stream_key.add(key99.getTree());

            // AST REWRITE
            // elements: key, oper, KEYPROP
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 258:5: -> ^( oper KEYPROP key )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:258:8: ^( oper KEYPROP key )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(stream_oper.nextNode(), root_1);

                adaptor.addChild(root_1, 
                stream_KEYPROP.nextNode()
                );

                adaptor.addChild(root_1, stream_key.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "condkey"


    public static class condancestor_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "condancestor"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:261:1: condancestor : ANCESTOR IS key -> ^( ANCESTOR key ) ;
    public final GqlExtParser.condancestor_return condancestor() throws RecognitionException {
        GqlExtParser.condancestor_return retval = new GqlExtParser.condancestor_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token ANCESTOR100=null;
        Token IS101=null;
        GqlExtParser.key_return key102 =null;


        Object ANCESTOR100_tree=null;
        Object IS101_tree=null;
        RewriteRuleTokenStream stream_ANCESTOR=new RewriteRuleTokenStream(adaptor,"token ANCESTOR");
        RewriteRuleTokenStream stream_IS=new RewriteRuleTokenStream(adaptor,"token IS");
        RewriteRuleSubtreeStream stream_key=new RewriteRuleSubtreeStream(adaptor,"rule key");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:261:13: ( ANCESTOR IS key -> ^( ANCESTOR key ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:262:5: ANCESTOR IS key
            {
            ANCESTOR100=(Token)match(input,ANCESTOR,FOLLOW_ANCESTOR_in_condancestor1012);  
            stream_ANCESTOR.add(ANCESTOR100);


            IS101=(Token)match(input,IS,FOLLOW_IS_in_condancestor1014);  
            stream_IS.add(IS101);


            pushFollow(FOLLOW_key_in_condancestor1016);
            key102=key();

            state._fsp--;

            stream_key.add(key102.getTree());

            // AST REWRITE
            // elements: key, ANCESTOR
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 263:5: -> ^( ANCESTOR key )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:263:8: ^( ANCESTOR key )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_ANCESTOR.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_key.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "condancestor"


    public static class condin_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "condin"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:266:1: condin : ( property IN LEFT_PAR listitem ( COMMA listitem )* RIGHT_PAR -> ^( IN property ^( LIST ( listitem )+ ) ) | property IN var -> ^( IN property var ) | property IN LEFT_PAR gql_select RIGHT_PAR -> ^( IN property gql_select ) );
    public final GqlExtParser.condin_return condin() throws RecognitionException {
        GqlExtParser.condin_return retval = new GqlExtParser.condin_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token IN104=null;
        Token LEFT_PAR105=null;
        Token COMMA107=null;
        Token RIGHT_PAR109=null;
        Token IN111=null;
        Token IN114=null;
        Token LEFT_PAR115=null;
        Token RIGHT_PAR117=null;
        GqlExtParser.property_return property103 =null;

        GqlExtParser.listitem_return listitem106 =null;

        GqlExtParser.listitem_return listitem108 =null;

        GqlExtParser.property_return property110 =null;

        GqlExtParser.var_return var112 =null;

        GqlExtParser.property_return property113 =null;

        GqlExtParser.gql_select_return gql_select116 =null;


        Object IN104_tree=null;
        Object LEFT_PAR105_tree=null;
        Object COMMA107_tree=null;
        Object RIGHT_PAR109_tree=null;
        Object IN111_tree=null;
        Object IN114_tree=null;
        Object LEFT_PAR115_tree=null;
        Object RIGHT_PAR117_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_IN=new RewriteRuleTokenStream(adaptor,"token IN");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"rule var");
        RewriteRuleSubtreeStream stream_gql_select=new RewriteRuleSubtreeStream(adaptor,"rule gql_select");
        RewriteRuleSubtreeStream stream_listitem=new RewriteRuleSubtreeStream(adaptor,"rule listitem");
        RewriteRuleSubtreeStream stream_property=new RewriteRuleSubtreeStream(adaptor,"rule property");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:266:7: ( property IN LEFT_PAR listitem ( COMMA listitem )* RIGHT_PAR -> ^( IN property ^( LIST ( listitem )+ ) ) | property IN var -> ^( IN property var ) | property IN LEFT_PAR gql_select RIGHT_PAR -> ^( IN property gql_select ) )
            int alt30=3;
            alt30 = dfa30.predict(input);
            switch (alt30) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:267:5: property IN LEFT_PAR listitem ( COMMA listitem )* RIGHT_PAR
                    {
                    pushFollow(FOLLOW_property_in_condin1040);
                    property103=property();

                    state._fsp--;

                    stream_property.add(property103.getTree());

                    IN104=(Token)match(input,IN,FOLLOW_IN_in_condin1042);  
                    stream_IN.add(IN104);


                    LEFT_PAR105=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_condin1044);  
                    stream_LEFT_PAR.add(LEFT_PAR105);


                    pushFollow(FOLLOW_listitem_in_condin1046);
                    listitem106=listitem();

                    state._fsp--;

                    stream_listitem.add(listitem106.getTree());

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:267:35: ( COMMA listitem )*
                    loop29:
                    do {
                        int alt29=2;
                        int LA29_0 = input.LA(1);

                        if ( (LA29_0==COMMA) ) {
                            alt29=1;
                        }


                        switch (alt29) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:267:36: COMMA listitem
                    	    {
                    	    COMMA107=(Token)match(input,COMMA,FOLLOW_COMMA_in_condin1049);  
                    	    stream_COMMA.add(COMMA107);


                    	    pushFollow(FOLLOW_listitem_in_condin1051);
                    	    listitem108=listitem();

                    	    state._fsp--;

                    	    stream_listitem.add(listitem108.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop29;
                        }
                    } while (true);


                    RIGHT_PAR109=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_condin1055);  
                    stream_RIGHT_PAR.add(RIGHT_PAR109);


                    // AST REWRITE
                    // elements: IN, listitem, property
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 267:63: -> ^( IN property ^( LIST ( listitem )+ ) )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:267:66: ^( IN property ^( LIST ( listitem )+ ) )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_IN.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_property.nextTree());

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:267:80: ^( LIST ( listitem )+ )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(LIST, "LIST")
                        , root_2);

                        if ( !(stream_listitem.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_listitem.hasNext() ) {
                            adaptor.addChild(root_2, stream_listitem.nextTree());

                        }
                        stream_listitem.reset();

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:268:7: property IN var
                    {
                    pushFollow(FOLLOW_property_in_condin1078);
                    property110=property();

                    state._fsp--;

                    stream_property.add(property110.getTree());

                    IN111=(Token)match(input,IN,FOLLOW_IN_in_condin1080);  
                    stream_IN.add(IN111);


                    pushFollow(FOLLOW_var_in_condin1082);
                    var112=var();

                    state._fsp--;

                    stream_var.add(var112.getTree());

                    // AST REWRITE
                    // elements: var, IN, property
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 268:23: -> ^( IN property var )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:268:26: ^( IN property var )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_IN.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_property.nextTree());

                        adaptor.addChild(root_1, stream_var.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:269:7: property IN LEFT_PAR gql_select RIGHT_PAR
                    {
                    pushFollow(FOLLOW_property_in_condin1100);
                    property113=property();

                    state._fsp--;

                    stream_property.add(property113.getTree());

                    IN114=(Token)match(input,IN,FOLLOW_IN_in_condin1102);  
                    stream_IN.add(IN114);


                    LEFT_PAR115=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_condin1104);  
                    stream_LEFT_PAR.add(LEFT_PAR115);


                    pushFollow(FOLLOW_gql_select_in_condin1106);
                    gql_select116=gql_select();

                    state._fsp--;

                    stream_gql_select.add(gql_select116.getTree());

                    RIGHT_PAR117=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_condin1108);  
                    stream_RIGHT_PAR.add(RIGHT_PAR117);


                    // AST REWRITE
                    // elements: gql_select, property, IN
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 269:49: -> ^( IN property gql_select )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:269:52: ^( IN property gql_select )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_IN.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_property.nextTree());

                        adaptor.addChild(root_1, stream_gql_select.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "condin"


    public static class condkeyin_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "condkeyin"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:272:1: condkeyin : ( KEYPROP IN LEFT_PAR key ( COMMA key )* RIGHT_PAR -> ^( IN KEYPROP ^( LIST ( key )+ ) ) | KEYPROP IN var -> ^( IN KEYPROP var ) | KEYPROP IN LEFT_PAR gql_select RIGHT_PAR -> ^( IN KEYPROP gql_select ) );
    public final GqlExtParser.condkeyin_return condkeyin() throws RecognitionException {
        GqlExtParser.condkeyin_return retval = new GqlExtParser.condkeyin_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token KEYPROP118=null;
        Token IN119=null;
        Token LEFT_PAR120=null;
        Token COMMA122=null;
        Token RIGHT_PAR124=null;
        Token KEYPROP125=null;
        Token IN126=null;
        Token KEYPROP128=null;
        Token IN129=null;
        Token LEFT_PAR130=null;
        Token RIGHT_PAR132=null;
        GqlExtParser.key_return key121 =null;

        GqlExtParser.key_return key123 =null;

        GqlExtParser.var_return var127 =null;

        GqlExtParser.gql_select_return gql_select131 =null;


        Object KEYPROP118_tree=null;
        Object IN119_tree=null;
        Object LEFT_PAR120_tree=null;
        Object COMMA122_tree=null;
        Object RIGHT_PAR124_tree=null;
        Object KEYPROP125_tree=null;
        Object IN126_tree=null;
        Object KEYPROP128_tree=null;
        Object IN129_tree=null;
        Object LEFT_PAR130_tree=null;
        Object RIGHT_PAR132_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_IN=new RewriteRuleTokenStream(adaptor,"token IN");
        RewriteRuleTokenStream stream_KEYPROP=new RewriteRuleTokenStream(adaptor,"token KEYPROP");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"rule var");
        RewriteRuleSubtreeStream stream_gql_select=new RewriteRuleSubtreeStream(adaptor,"rule gql_select");
        RewriteRuleSubtreeStream stream_key=new RewriteRuleSubtreeStream(adaptor,"rule key");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:272:10: ( KEYPROP IN LEFT_PAR key ( COMMA key )* RIGHT_PAR -> ^( IN KEYPROP ^( LIST ( key )+ ) ) | KEYPROP IN var -> ^( IN KEYPROP var ) | KEYPROP IN LEFT_PAR gql_select RIGHT_PAR -> ^( IN KEYPROP gql_select ) )
            int alt32=3;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==KEYPROP) ) {
                int LA32_1 = input.LA(2);

                if ( (LA32_1==IN) ) {
                    int LA32_2 = input.LA(3);

                    if ( (LA32_2==LEFT_PAR) ) {
                        int LA32_3 = input.LA(4);

                        if ( (LA32_3==KEY||LA32_3==STRING||LA32_3==VARID) ) {
                            alt32=1;
                        }
                        else if ( (LA32_3==SELECT) ) {
                            alt32=3;
                        }
                        else {
                            NoViableAltException nvae =
                                new NoViableAltException("", 32, 3, input);

                            throw nvae;

                        }
                    }
                    else if ( (LA32_2==VARID) ) {
                        alt32=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 32, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 32, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;

            }
            switch (alt32) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:273:5: KEYPROP IN LEFT_PAR key ( COMMA key )* RIGHT_PAR
                    {
                    KEYPROP118=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkeyin1130);  
                    stream_KEYPROP.add(KEYPROP118);


                    IN119=(Token)match(input,IN,FOLLOW_IN_in_condkeyin1132);  
                    stream_IN.add(IN119);


                    LEFT_PAR120=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_condkeyin1134);  
                    stream_LEFT_PAR.add(LEFT_PAR120);


                    pushFollow(FOLLOW_key_in_condkeyin1136);
                    key121=key();

                    state._fsp--;

                    stream_key.add(key121.getTree());

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:273:29: ( COMMA key )*
                    loop31:
                    do {
                        int alt31=2;
                        int LA31_0 = input.LA(1);

                        if ( (LA31_0==COMMA) ) {
                            alt31=1;
                        }


                        switch (alt31) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:273:30: COMMA key
                    	    {
                    	    COMMA122=(Token)match(input,COMMA,FOLLOW_COMMA_in_condkeyin1139);  
                    	    stream_COMMA.add(COMMA122);


                    	    pushFollow(FOLLOW_key_in_condkeyin1141);
                    	    key123=key();

                    	    state._fsp--;

                    	    stream_key.add(key123.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop31;
                        }
                    } while (true);


                    RIGHT_PAR124=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_condkeyin1145);  
                    stream_RIGHT_PAR.add(RIGHT_PAR124);


                    // AST REWRITE
                    // elements: IN, KEYPROP, key
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 273:52: -> ^( IN KEYPROP ^( LIST ( key )+ ) )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:273:55: ^( IN KEYPROP ^( LIST ( key )+ ) )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_IN.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_KEYPROP.nextNode()
                        );

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:273:68: ^( LIST ( key )+ )
                        {
                        Object root_2 = (Object)adaptor.nil();
                        root_2 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(LIST, "LIST")
                        , root_2);

                        if ( !(stream_key.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_key.hasNext() ) {
                            adaptor.addChild(root_2, stream_key.nextTree());

                        }
                        stream_key.reset();

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:274:7: KEYPROP IN var
                    {
                    KEYPROP125=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkeyin1168);  
                    stream_KEYPROP.add(KEYPROP125);


                    IN126=(Token)match(input,IN,FOLLOW_IN_in_condkeyin1170);  
                    stream_IN.add(IN126);


                    pushFollow(FOLLOW_var_in_condkeyin1172);
                    var127=var();

                    state._fsp--;

                    stream_var.add(var127.getTree());

                    // AST REWRITE
                    // elements: IN, KEYPROP, var
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 274:22: -> ^( IN KEYPROP var )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:274:25: ^( IN KEYPROP var )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_IN.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_KEYPROP.nextNode()
                        );

                        adaptor.addChild(root_1, stream_var.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:275:7: KEYPROP IN LEFT_PAR gql_select RIGHT_PAR
                    {
                    KEYPROP128=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_condkeyin1190);  
                    stream_KEYPROP.add(KEYPROP128);


                    IN129=(Token)match(input,IN,FOLLOW_IN_in_condkeyin1192);  
                    stream_IN.add(IN129);


                    LEFT_PAR130=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_condkeyin1194);  
                    stream_LEFT_PAR.add(LEFT_PAR130);


                    pushFollow(FOLLOW_gql_select_in_condkeyin1196);
                    gql_select131=gql_select();

                    state._fsp--;

                    stream_gql_select.add(gql_select131.getTree());

                    RIGHT_PAR132=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_condkeyin1198);  
                    stream_RIGHT_PAR.add(RIGHT_PAR132);


                    // AST REWRITE
                    // elements: gql_select, KEYPROP, IN
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 275:48: -> ^( IN KEYPROP gql_select )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:275:51: ^( IN KEYPROP gql_select )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_IN.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_KEYPROP.nextNode()
                        );

                        adaptor.addChild(root_1, stream_gql_select.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "condkeyin"


    public static class softcondmul_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "softcondmul"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:278:1: softcondmul : softcondat ( AND ^ softcondat )* ;
    public final GqlExtParser.softcondmul_return softcondmul() throws RecognitionException {
        GqlExtParser.softcondmul_return retval = new GqlExtParser.softcondmul_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token AND134=null;
        GqlExtParser.softcondat_return softcondat133 =null;

        GqlExtParser.softcondat_return softcondat135 =null;


        Object AND134_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:278:12: ( softcondat ( AND ^ softcondat )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:279:5: softcondat ( AND ^ softcondat )*
            {
            root_0 = (Object)adaptor.nil();


            pushFollow(FOLLOW_softcondat_in_softcondmul1220);
            softcondat133=softcondat();

            state._fsp--;

            adaptor.addChild(root_0, softcondat133.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:279:16: ( AND ^ softcondat )*
            loop33:
            do {
                int alt33=2;
                int LA33_0 = input.LA(1);

                if ( (LA33_0==AND) ) {
                    alt33=1;
                }


                switch (alt33) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:279:17: AND ^ softcondat
            	    {
            	    AND134=(Token)match(input,AND,FOLLOW_AND_in_softcondmul1223); 
            	    AND134_tree = 
            	    (Object)adaptor.create(AND134)
            	    ;
            	    root_0 = (Object)adaptor.becomeRoot(AND134_tree, root_0);


            	    pushFollow(FOLLOW_softcondat_in_softcondmul1226);
            	    softcondat135=softcondat();

            	    state._fsp--;

            	    adaptor.addChild(root_0, softcondat135.getTree());

            	    }
            	    break;

            	default :
            	    break loop33;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "softcondmul"


    public static class softcondat_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "softcondat"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:282:1: softcondat : ( NOT softcondat -> ^( NOT softcondat ) | ANCESTOR IS expr -> ^( ANCESTOR expr ) | expr operin expr -> ^( operin ( expr )+ ) );
    public final GqlExtParser.softcondat_return softcondat() throws RecognitionException {
        Expr_stack.push(new Expr_scope());

        GqlExtParser.softcondat_return retval = new GqlExtParser.softcondat_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token NOT136=null;
        Token ANCESTOR138=null;
        Token IS139=null;
        GqlExtParser.softcondat_return softcondat137 =null;

        GqlExtParser.expr_return expr140 =null;

        GqlExtParser.expr_return expr141 =null;

        GqlExtParser.operin_return operin142 =null;

        GqlExtParser.expr_return expr143 =null;


        Object NOT136_tree=null;
        Object ANCESTOR138_tree=null;
        Object IS139_tree=null;
        RewriteRuleTokenStream stream_ANCESTOR=new RewriteRuleTokenStream(adaptor,"token ANCESTOR");
        RewriteRuleTokenStream stream_NOT=new RewriteRuleTokenStream(adaptor,"token NOT");
        RewriteRuleTokenStream stream_IS=new RewriteRuleTokenStream(adaptor,"token IS");
        RewriteRuleSubtreeStream stream_operin=new RewriteRuleSubtreeStream(adaptor,"rule operin");
        RewriteRuleSubtreeStream stream_softcondat=new RewriteRuleSubtreeStream(adaptor,"rule softcondat");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");

                ((Expr_scope)Expr_stack.peek()).hasEntity = true;
            
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:287:5: ( NOT softcondat -> ^( NOT softcondat ) | ANCESTOR IS expr -> ^( ANCESTOR expr ) | expr operin expr -> ^( operin ( expr )+ ) )
            int alt34=3;
            switch ( input.LA(1) ) {
            case NOT:
                {
                alt34=1;
                }
                break;
            case ANCESTOR:
                {
                alt34=2;
                }
                break;
            case DATE:
            case DATETIME:
            case FALSE:
            case FLOAT:
            case GEOPT:
            case ID:
            case INT:
            case KEY:
            case KEYPROP:
            case LEFT_PAR:
            case MINUS:
            case NULL:
            case PLUS:
            case PROP:
            case STRING:
            case TIME:
            case TRUE:
            case USER:
            case VARID:
                {
                alt34=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 34, 0, input);

                throw nvae;

            }

            switch (alt34) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:288:5: NOT softcondat
                    {
                    NOT136=(Token)match(input,NOT,FOLLOW_NOT_in_softcondat1263);  
                    stream_NOT.add(NOT136);


                    pushFollow(FOLLOW_softcondat_in_softcondat1265);
                    softcondat137=softcondat();

                    state._fsp--;

                    stream_softcondat.add(softcondat137.getTree());

                    // AST REWRITE
                    // elements: softcondat, NOT
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 288:20: -> ^( NOT softcondat )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:288:23: ^( NOT softcondat )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_NOT.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_softcondat.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:289:7: ANCESTOR IS expr
                    {
                    ANCESTOR138=(Token)match(input,ANCESTOR,FOLLOW_ANCESTOR_in_softcondat1281);  
                    stream_ANCESTOR.add(ANCESTOR138);


                    IS139=(Token)match(input,IS,FOLLOW_IS_in_softcondat1283);  
                    stream_IS.add(IS139);


                    pushFollow(FOLLOW_expr_in_softcondat1285);
                    expr140=expr();

                    state._fsp--;

                    stream_expr.add(expr140.getTree());

                    // AST REWRITE
                    // elements: expr, ANCESTOR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 289:24: -> ^( ANCESTOR expr )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:289:27: ^( ANCESTOR expr )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_ANCESTOR.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_expr.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:290:7: expr operin expr
                    {
                    pushFollow(FOLLOW_expr_in_softcondat1301);
                    expr141=expr();

                    state._fsp--;

                    stream_expr.add(expr141.getTree());

                    pushFollow(FOLLOW_operin_in_softcondat1303);
                    operin142=operin();

                    state._fsp--;

                    stream_operin.add(operin142.getTree());

                    pushFollow(FOLLOW_expr_in_softcondat1305);
                    expr143=expr();

                    state._fsp--;

                    stream_expr.add(expr143.getTree());

                    // AST REWRITE
                    // elements: expr, operin
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 290:24: -> ^( operin ( expr )+ )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:290:27: ^( operin ( expr )+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(stream_operin.nextNode(), root_1);

                        if ( !(stream_expr.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_expr.hasNext() ) {
                            adaptor.addChild(root_1, stream_expr.nextTree());

                        }
                        stream_expr.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
            Expr_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "softcondat"


    public static class oper_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "oper"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:293:1: oper : ( OPER | EQ );
    public final GqlExtParser.oper_return oper() throws RecognitionException {
        GqlExtParser.oper_return retval = new GqlExtParser.oper_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token set144=null;

        Object set144_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:293:5: ( OPER | EQ )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:
            {
            root_0 = (Object)adaptor.nil();


            set144=(Token)input.LT(1);

            if ( input.LA(1)==EQ||input.LA(1)==OPER ) {
                input.consume();
                adaptor.addChild(root_0, 
                (Object)adaptor.create(set144)
                );
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "oper"


    public static class operin_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "operin"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:295:1: operin : ( OPER | EQ | IN );
    public final GqlExtParser.operin_return operin() throws RecognitionException {
        GqlExtParser.operin_return retval = new GqlExtParser.operin_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token OPER145=null;
        Token EQ146=null;
        Token IN147=null;

        Object OPER145_tree=null;
        Object EQ146_tree=null;
        Object IN147_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:295:7: ( OPER | EQ | IN )
            int alt35=3;
            switch ( input.LA(1) ) {
            case OPER:
                {
                alt35=1;
                }
                break;
            case EQ:
                {
                alt35=2;
                }
                break;
            case IN:
                {
                alt35=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 35, 0, input);

                throw nvae;

            }

            switch (alt35) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:295:9: OPER
                    {
                    root_0 = (Object)adaptor.nil();


                    OPER145=(Token)match(input,OPER,FOLLOW_OPER_in_operin1333); 
                    OPER145_tree = 
                    (Object)adaptor.create(OPER145)
                    ;
                    adaptor.addChild(root_0, OPER145_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:295:16: EQ
                    {
                    root_0 = (Object)adaptor.nil();


                    EQ146=(Token)match(input,EQ,FOLLOW_EQ_in_operin1337); 
                    EQ146_tree = 
                    (Object)adaptor.create(EQ146)
                    ;
                    adaptor.addChild(root_0, EQ146_tree);


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:295:21: IN
                    {
                    root_0 = (Object)adaptor.nil();


                    IN147=(Token)match(input,IN,FOLLOW_IN_in_operin1341); 
                    IN147_tree = 
                    (Object)adaptor.create(IN147)
                    ;
                    adaptor.addChild(root_0, IN147_tree);


                     ((Expr_scope)Expr_stack.peek()).isNestedQueryAllowed = true; 

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "operin"


    public static class listitem_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "listitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:298:1: listitem : valorvarobj ;
    public final GqlExtParser.listitem_return listitem() throws RecognitionException {
        GqlExtParser.listitem_return retval = new GqlExtParser.listitem_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.valorvarobj_return valorvarobj148 =null;



        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:298:9: ( valorvarobj )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:298:11: valorvarobj
            {
            root_0 = (Object)adaptor.nil();


            pushFollow(FOLLOW_valorvarobj_in_listitem1351);
            valorvarobj148=valorvarobj();

            state._fsp--;

            adaptor.addChild(root_0, valorvarobj148.getTree());

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "listitem"


    public static class key_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "key"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:301:1: key : ( ( STRING -> ^( KEY STRING ) ) | ( var -> ^( KEY var ) ) | keyfunc );
    public final GqlExtParser.key_return key() throws RecognitionException {
        GqlExtParser.key_return retval = new GqlExtParser.key_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token STRING149=null;
        GqlExtParser.var_return var150 =null;

        GqlExtParser.keyfunc_return keyfunc151 =null;


        Object STRING149_tree=null;
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"rule var");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:301:4: ( ( STRING -> ^( KEY STRING ) ) | ( var -> ^( KEY var ) ) | keyfunc )
            int alt36=3;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt36=1;
                }
                break;
            case VARID:
                {
                alt36=2;
                }
                break;
            case KEY:
                {
                alt36=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;

            }

            switch (alt36) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:301:6: ( STRING -> ^( KEY STRING ) )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:301:6: ( STRING -> ^( KEY STRING ) )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:301:7: STRING
                    {
                    STRING149=(Token)match(input,STRING,FOLLOW_STRING_in_key1360);  
                    stream_STRING.add(STRING149);


                    // AST REWRITE
                    // elements: STRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 301:14: -> ^( KEY STRING )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:301:17: ^( KEY STRING )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(KEY, "KEY")
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_STRING.nextNode()
                        );

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:302:7: ( var -> ^( KEY var ) )
                    {
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:302:7: ( var -> ^( KEY var ) )
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:302:8: var
                    {
                    pushFollow(FOLLOW_var_in_key1378);
                    var150=var();

                    state._fsp--;

                    stream_var.add(var150.getTree());

                    // AST REWRITE
                    // elements: var
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 302:12: -> ^( KEY var )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:302:15: ^( KEY var )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(KEY, "KEY")
                        , root_1);

                        adaptor.addChild(root_1, stream_var.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:303:7: keyfunc
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_keyfunc_in_key1395);
                    keyfunc151=keyfunc();

                    state._fsp--;

                    adaptor.addChild(root_0, keyfunc151.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "key"


    public static class keyfunc_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "keyfunc"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:306:1: keyfunc : ( KEY LEFT_PAR stringorvar RIGHT_PAR -> ^( KEY stringorvar ) | KEY LEFT_PAR keypath RIGHT_PAR -> ^( KEY keypath ) );
    public final GqlExtParser.keyfunc_return keyfunc() throws RecognitionException {
        GqlExtParser.keyfunc_return retval = new GqlExtParser.keyfunc_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token KEY152=null;
        Token LEFT_PAR153=null;
        Token RIGHT_PAR155=null;
        Token KEY156=null;
        Token LEFT_PAR157=null;
        Token RIGHT_PAR159=null;
        GqlExtParser.stringorvar_return stringorvar154 =null;

        GqlExtParser.keypath_return keypath158 =null;


        Object KEY152_tree=null;
        Object LEFT_PAR153_tree=null;
        Object RIGHT_PAR155_tree=null;
        Object KEY156_tree=null;
        Object LEFT_PAR157_tree=null;
        Object RIGHT_PAR159_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_KEY=new RewriteRuleTokenStream(adaptor,"token KEY");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleSubtreeStream stream_keypath=new RewriteRuleSubtreeStream(adaptor,"rule keypath");
        RewriteRuleSubtreeStream stream_stringorvar=new RewriteRuleSubtreeStream(adaptor,"rule stringorvar");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:306:8: ( KEY LEFT_PAR stringorvar RIGHT_PAR -> ^( KEY stringorvar ) | KEY LEFT_PAR keypath RIGHT_PAR -> ^( KEY keypath ) )
            int alt37=2;
            int LA37_0 = input.LA(1);

            if ( (LA37_0==KEY) ) {
                int LA37_1 = input.LA(2);

                if ( (LA37_1==LEFT_PAR) ) {
                    int LA37_2 = input.LA(3);

                    if ( (LA37_2==STRING) ) {
                        int LA37_3 = input.LA(4);

                        if ( (LA37_3==COMMA) ) {
                            alt37=2;
                        }
                        else if ( (LA37_3==RIGHT_PAR) ) {
                            alt37=1;
                        }
                        else {
                            NoViableAltException nvae =
                                new NoViableAltException("", 37, 3, input);

                            throw nvae;

                        }
                    }
                    else if ( (LA37_2==VARID) ) {
                        alt37=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 37, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 37, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 37, 0, input);

                throw nvae;

            }
            switch (alt37) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:307:5: KEY LEFT_PAR stringorvar RIGHT_PAR
                    {
                    KEY152=(Token)match(input,KEY,FOLLOW_KEY_in_keyfunc1407);  
                    stream_KEY.add(KEY152);


                    LEFT_PAR153=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_keyfunc1409);  
                    stream_LEFT_PAR.add(LEFT_PAR153);


                    pushFollow(FOLLOW_stringorvar_in_keyfunc1411);
                    stringorvar154=stringorvar();

                    state._fsp--;

                    stream_stringorvar.add(stringorvar154.getTree());

                    RIGHT_PAR155=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_keyfunc1413);  
                    stream_RIGHT_PAR.add(RIGHT_PAR155);


                    // AST REWRITE
                    // elements: stringorvar, KEY
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 307:40: -> ^( KEY stringorvar )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:307:43: ^( KEY stringorvar )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_KEY.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_stringorvar.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:308:7: KEY LEFT_PAR keypath RIGHT_PAR
                    {
                    KEY156=(Token)match(input,KEY,FOLLOW_KEY_in_keyfunc1429);  
                    stream_KEY.add(KEY156);


                    LEFT_PAR157=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_keyfunc1431);  
                    stream_LEFT_PAR.add(LEFT_PAR157);


                    pushFollow(FOLLOW_keypath_in_keyfunc1433);
                    keypath158=keypath();

                    state._fsp--;

                    stream_keypath.add(keypath158.getTree());

                    RIGHT_PAR159=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_keyfunc1435);  
                    stream_RIGHT_PAR.add(RIGHT_PAR159);


                    // AST REWRITE
                    // elements: keypath, KEY
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 308:38: -> ^( KEY keypath )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:308:41: ^( KEY keypath )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_KEY.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_keypath.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "keyfunc"


    public static class keypath_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "keypath"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:311:1: keypath : kin= STRING COMMA intstringorvar ( COMMA keypath )? -> ^( PATH $kin intstringorvar ) ( keypath )? ;
    public final GqlExtParser.keypath_return keypath() throws RecognitionException {
        GqlExtParser.keypath_return retval = new GqlExtParser.keypath_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token kin=null;
        Token COMMA160=null;
        Token COMMA162=null;
        GqlExtParser.intstringorvar_return intstringorvar161 =null;

        GqlExtParser.keypath_return keypath163 =null;


        Object kin_tree=null;
        Object COMMA160_tree=null;
        Object COMMA162_tree=null;
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleSubtreeStream stream_intstringorvar=new RewriteRuleSubtreeStream(adaptor,"rule intstringorvar");
        RewriteRuleSubtreeStream stream_keypath=new RewriteRuleSubtreeStream(adaptor,"rule keypath");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:311:8: (kin= STRING COMMA intstringorvar ( COMMA keypath )? -> ^( PATH $kin intstringorvar ) ( keypath )? )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:312:5: kin= STRING COMMA intstringorvar ( COMMA keypath )?
            {
            kin=(Token)match(input,STRING,FOLLOW_STRING_in_keypath1457);  
            stream_STRING.add(kin);


            COMMA160=(Token)match(input,COMMA,FOLLOW_COMMA_in_keypath1459);  
            stream_COMMA.add(COMMA160);


            pushFollow(FOLLOW_intstringorvar_in_keypath1461);
            intstringorvar161=intstringorvar();

            state._fsp--;

            stream_intstringorvar.add(intstringorvar161.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:312:37: ( COMMA keypath )?
            int alt38=2;
            int LA38_0 = input.LA(1);

            if ( (LA38_0==COMMA) ) {
                alt38=1;
            }
            switch (alt38) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:312:38: COMMA keypath
                    {
                    COMMA162=(Token)match(input,COMMA,FOLLOW_COMMA_in_keypath1464);  
                    stream_COMMA.add(COMMA162);


                    pushFollow(FOLLOW_keypath_in_keypath1466);
                    keypath163=keypath();

                    state._fsp--;

                    stream_keypath.add(keypath163.getTree());

                    }
                    break;

            }


            // AST REWRITE
            // elements: keypath, intstringorvar, kin
            // token labels: kin
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleTokenStream stream_kin=new RewriteRuleTokenStream(adaptor,"token kin",kin);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 313:5: -> ^( PATH $kin intstringorvar ) ( keypath )?
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:313:8: ^( PATH $kin intstringorvar )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                (Object)adaptor.create(PATH, "PATH")
                , root_1);

                adaptor.addChild(root_1, stream_kin.nextNode());

                adaptor.addChild(root_1, stream_intstringorvar.nextTree());

                adaptor.addChild(root_0, root_1);
                }

                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:313:36: ( keypath )?
                if ( stream_keypath.hasNext() ) {
                    adaptor.addChild(root_0, stream_keypath.nextTree());

                }
                stream_keypath.reset();

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "keypath"


    public static class orderby_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "orderby"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:316:1: orderby : ( ORDER BY orderbyitem ( COMMA orderbyitem )* ( softorderby )? -> ^( ORDER ( orderbyitem )+ ( softorderby )? ) | ORDER BY softorderby -> ^( ORDER softorderby ) );
    public final GqlExtParser.orderby_return orderby() throws RecognitionException {
        GqlExtParser.orderby_return retval = new GqlExtParser.orderby_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token ORDER164=null;
        Token BY165=null;
        Token COMMA167=null;
        Token ORDER170=null;
        Token BY171=null;
        GqlExtParser.orderbyitem_return orderbyitem166 =null;

        GqlExtParser.orderbyitem_return orderbyitem168 =null;

        GqlExtParser.softorderby_return softorderby169 =null;

        GqlExtParser.softorderby_return softorderby172 =null;


        Object ORDER164_tree=null;
        Object BY165_tree=null;
        Object COMMA167_tree=null;
        Object ORDER170_tree=null;
        Object BY171_tree=null;
        RewriteRuleTokenStream stream_BY=new RewriteRuleTokenStream(adaptor,"token BY");
        RewriteRuleTokenStream stream_ORDER=new RewriteRuleTokenStream(adaptor,"token ORDER");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_orderbyitem=new RewriteRuleSubtreeStream(adaptor,"rule orderbyitem");
        RewriteRuleSubtreeStream stream_softorderby=new RewriteRuleSubtreeStream(adaptor,"rule softorderby");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:316:8: ( ORDER BY orderbyitem ( COMMA orderbyitem )* ( softorderby )? -> ^( ORDER ( orderbyitem )+ ( softorderby )? ) | ORDER BY softorderby -> ^( ORDER softorderby ) )
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==ORDER) ) {
                int LA41_1 = input.LA(2);

                if ( (LA41_1==BY) ) {
                    int LA41_2 = input.LA(3);

                    if ( (LA41_2==ID||LA41_2==KEYPROP||LA41_2==PROP) ) {
                        alt41=1;
                    }
                    else if ( (LA41_2==SOFT) ) {
                        alt41=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 41, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 41, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 41, 0, input);

                throw nvae;

            }
            switch (alt41) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:5: ORDER BY orderbyitem ( COMMA orderbyitem )* ( softorderby )?
                    {
                    ORDER164=(Token)match(input,ORDER,FOLLOW_ORDER_in_orderby1498);  
                    stream_ORDER.add(ORDER164);


                    BY165=(Token)match(input,BY,FOLLOW_BY_in_orderby1500);  
                    stream_BY.add(BY165);


                    pushFollow(FOLLOW_orderbyitem_in_orderby1502);
                    orderbyitem166=orderbyitem();

                    state._fsp--;

                    stream_orderbyitem.add(orderbyitem166.getTree());

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:26: ( COMMA orderbyitem )*
                    loop39:
                    do {
                        int alt39=2;
                        int LA39_0 = input.LA(1);

                        if ( (LA39_0==COMMA) ) {
                            alt39=1;
                        }


                        switch (alt39) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:27: COMMA orderbyitem
                    	    {
                    	    COMMA167=(Token)match(input,COMMA,FOLLOW_COMMA_in_orderby1505);  
                    	    stream_COMMA.add(COMMA167);


                    	    pushFollow(FOLLOW_orderbyitem_in_orderby1507);
                    	    orderbyitem168=orderbyitem();

                    	    state._fsp--;

                    	    stream_orderbyitem.add(orderbyitem168.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop39;
                        }
                    } while (true);


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:47: ( softorderby )?
                    int alt40=2;
                    int LA40_0 = input.LA(1);

                    if ( (LA40_0==SOFT) ) {
                        alt40=1;
                    }
                    switch (alt40) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:47: softorderby
                            {
                            pushFollow(FOLLOW_softorderby_in_orderby1511);
                            softorderby169=softorderby();

                            state._fsp--;

                            stream_softorderby.add(softorderby169.getTree());

                            }
                            break;

                    }


                    // AST REWRITE
                    // elements: softorderby, orderbyitem, ORDER
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 317:60: -> ^( ORDER ( orderbyitem )+ ( softorderby )? )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:63: ^( ORDER ( orderbyitem )+ ( softorderby )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_ORDER.nextNode()
                        , root_1);

                        if ( !(stream_orderbyitem.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_orderbyitem.hasNext() ) {
                            adaptor.addChild(root_1, stream_orderbyitem.nextTree());

                        }
                        stream_orderbyitem.reset();

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:317:84: ( softorderby )?
                        if ( stream_softorderby.hasNext() ) {
                            adaptor.addChild(root_1, stream_softorderby.nextTree());

                        }
                        stream_softorderby.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:318:7: ORDER BY softorderby
                    {
                    ORDER170=(Token)match(input,ORDER,FOLLOW_ORDER_in_orderby1532);  
                    stream_ORDER.add(ORDER170);


                    BY171=(Token)match(input,BY,FOLLOW_BY_in_orderby1534);  
                    stream_BY.add(BY171);


                    pushFollow(FOLLOW_softorderby_in_orderby1536);
                    softorderby172=softorderby();

                    state._fsp--;

                    stream_softorderby.add(softorderby172.getTree());

                    // AST REWRITE
                    // elements: ORDER, softorderby
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 318:28: -> ^( ORDER softorderby )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:318:31: ^( ORDER softorderby )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_ORDER.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_softorderby.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "orderby"


    public static class softorderby_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "softorderby"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:321:1: softorderby : SOFT orderbyitem ( COMMA orderbyitem )* -> ^( SOFT ( orderbyitem )+ ) ;
    public final GqlExtParser.softorderby_return softorderby() throws RecognitionException {
        GqlExtParser.softorderby_return retval = new GqlExtParser.softorderby_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token SOFT173=null;
        Token COMMA175=null;
        GqlExtParser.orderbyitem_return orderbyitem174 =null;

        GqlExtParser.orderbyitem_return orderbyitem176 =null;


        Object SOFT173_tree=null;
        Object COMMA175_tree=null;
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_SOFT=new RewriteRuleTokenStream(adaptor,"token SOFT");
        RewriteRuleSubtreeStream stream_orderbyitem=new RewriteRuleSubtreeStream(adaptor,"rule orderbyitem");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:321:12: ( SOFT orderbyitem ( COMMA orderbyitem )* -> ^( SOFT ( orderbyitem )+ ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:322:5: SOFT orderbyitem ( COMMA orderbyitem )*
            {
            SOFT173=(Token)match(input,SOFT,FOLLOW_SOFT_in_softorderby1556);  
            stream_SOFT.add(SOFT173);


            pushFollow(FOLLOW_orderbyitem_in_softorderby1558);
            orderbyitem174=orderbyitem();

            state._fsp--;

            stream_orderbyitem.add(orderbyitem174.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:322:22: ( COMMA orderbyitem )*
            loop42:
            do {
                int alt42=2;
                int LA42_0 = input.LA(1);

                if ( (LA42_0==COMMA) ) {
                    alt42=1;
                }


                switch (alt42) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:322:23: COMMA orderbyitem
            	    {
            	    COMMA175=(Token)match(input,COMMA,FOLLOW_COMMA_in_softorderby1561);  
            	    stream_COMMA.add(COMMA175);


            	    pushFollow(FOLLOW_orderbyitem_in_softorderby1563);
            	    orderbyitem176=orderbyitem();

            	    state._fsp--;

            	    stream_orderbyitem.add(orderbyitem176.getTree());

            	    }
            	    break;

            	default :
            	    break loop42;
                }
            } while (true);


            // AST REWRITE
            // elements: SOFT, orderbyitem
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 323:5: -> ^( SOFT ( orderbyitem )+ )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:323:8: ^( SOFT ( orderbyitem )+ )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_SOFT.nextNode()
                , root_1);

                if ( !(stream_orderbyitem.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_orderbyitem.hasNext() ) {
                    adaptor.addChild(root_1, stream_orderbyitem.nextTree());

                }
                stream_orderbyitem.reset();

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "softorderby"


    public static class orderbyitem_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "orderbyitem"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:326:1: orderbyitem : ( prop -> ^( ASC prop ) | prop ASC -> ^( ASC prop ) | prop DESC -> ^( DESC prop ) );
    public final GqlExtParser.orderbyitem_return orderbyitem() throws RecognitionException {
        GqlExtParser.orderbyitem_return retval = new GqlExtParser.orderbyitem_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token ASC179=null;
        Token DESC181=null;
        GqlExtParser.prop_return prop177 =null;

        GqlExtParser.prop_return prop178 =null;

        GqlExtParser.prop_return prop180 =null;


        Object ASC179_tree=null;
        Object DESC181_tree=null;
        RewriteRuleTokenStream stream_DESC=new RewriteRuleTokenStream(adaptor,"token DESC");
        RewriteRuleTokenStream stream_ASC=new RewriteRuleTokenStream(adaptor,"token ASC");
        RewriteRuleSubtreeStream stream_prop=new RewriteRuleSubtreeStream(adaptor,"rule prop");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:326:12: ( prop -> ^( ASC prop ) | prop ASC -> ^( ASC prop ) | prop DESC -> ^( DESC prop ) )
            int alt43=3;
            alt43 = dfa43.predict(input);
            switch (alt43) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:327:5: prop
                    {
                    pushFollow(FOLLOW_prop_in_orderbyitem1590);
                    prop177=prop();

                    state._fsp--;

                    stream_prop.add(prop177.getTree());

                    // AST REWRITE
                    // elements: prop
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 327:10: -> ^( ASC prop )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:327:13: ^( ASC prop )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(ASC, "ASC")
                        , root_1);

                        adaptor.addChild(root_1, stream_prop.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:328:7: prop ASC
                    {
                    pushFollow(FOLLOW_prop_in_orderbyitem1606);
                    prop178=prop();

                    state._fsp--;

                    stream_prop.add(prop178.getTree());

                    ASC179=(Token)match(input,ASC,FOLLOW_ASC_in_orderbyitem1608);  
                    stream_ASC.add(ASC179);


                    // AST REWRITE
                    // elements: prop, ASC
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 328:16: -> ^( ASC prop )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:328:19: ^( ASC prop )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_ASC.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_prop.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:329:7: prop DESC
                    {
                    pushFollow(FOLLOW_prop_in_orderbyitem1624);
                    prop180=prop();

                    state._fsp--;

                    stream_prop.add(prop180.getTree());

                    DESC181=(Token)match(input,DESC,FOLLOW_DESC_in_orderbyitem1626);  
                    stream_DESC.add(DESC181);


                    // AST REWRITE
                    // elements: prop, DESC
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 329:17: -> ^( DESC prop )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:329:20: ^( DESC prop )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_DESC.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_prop.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "orderbyitem"


    public static class limit_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "limit"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:332:1: limit : ( LIMIT off= INT COMMA lim= INT -> ^( LIMIT $lim) ^( OFFSET $off) | LIMIT lim= INT -> ^( LIMIT $lim) );
    public final GqlExtParser.limit_return limit() throws RecognitionException {
        GqlExtParser.limit_return retval = new GqlExtParser.limit_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token off=null;
        Token lim=null;
        Token LIMIT182=null;
        Token COMMA183=null;
        Token LIMIT184=null;

        Object off_tree=null;
        Object lim_tree=null;
        Object LIMIT182_tree=null;
        Object COMMA183_tree=null;
        Object LIMIT184_tree=null;
        RewriteRuleTokenStream stream_INT=new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_LIMIT=new RewriteRuleTokenStream(adaptor,"token LIMIT");

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:332:6: ( LIMIT off= INT COMMA lim= INT -> ^( LIMIT $lim) ^( OFFSET $off) | LIMIT lim= INT -> ^( LIMIT $lim) )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==LIMIT) ) {
                int LA44_1 = input.LA(2);

                if ( (LA44_1==INT) ) {
                    int LA44_2 = input.LA(3);

                    if ( (LA44_2==COMMA) ) {
                        alt44=1;
                    }
                    else if ( (LA44_2==EOF||LA44_2==OFFSET||LA44_2==RIGHT_PAR) ) {
                        alt44=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 44, 2, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 44, 1, input);

                    throw nvae;

                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;

            }
            switch (alt44) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:333:5: LIMIT off= INT COMMA lim= INT
                    {
                    LIMIT182=(Token)match(input,LIMIT,FOLLOW_LIMIT_in_limit1646);  
                    stream_LIMIT.add(LIMIT182);


                    off=(Token)match(input,INT,FOLLOW_INT_in_limit1650);  
                    stream_INT.add(off);


                    COMMA183=(Token)match(input,COMMA,FOLLOW_COMMA_in_limit1652);  
                    stream_COMMA.add(COMMA183);


                    lim=(Token)match(input,INT,FOLLOW_INT_in_limit1656);  
                    stream_INT.add(lim);


                    // AST REWRITE
                    // elements: off, lim, LIMIT
                    // token labels: lim, off
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_lim=new RewriteRuleTokenStream(adaptor,"token lim",lim);
                    RewriteRuleTokenStream stream_off=new RewriteRuleTokenStream(adaptor,"token off",off);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 333:33: -> ^( LIMIT $lim) ^( OFFSET $off)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:333:36: ^( LIMIT $lim)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_LIMIT.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_lim.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:333:50: ^( OFFSET $off)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(OFFSET, "OFFSET")
                        , root_1);

                        adaptor.addChild(root_1, stream_off.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:334:7: LIMIT lim= INT
                    {
                    LIMIT184=(Token)match(input,LIMIT,FOLLOW_LIMIT_in_limit1680);  
                    stream_LIMIT.add(LIMIT184);


                    lim=(Token)match(input,INT,FOLLOW_INT_in_limit1684);  
                    stream_INT.add(lim);


                    // AST REWRITE
                    // elements: LIMIT, lim
                    // token labels: lim
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_lim=new RewriteRuleTokenStream(adaptor,"token lim",lim);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 334:21: -> ^( LIMIT $lim)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:334:24: ^( LIMIT $lim)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_LIMIT.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_lim.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "limit"


    public static class offset_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "offset"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:337:1: offset : OFFSET INT -> ^( OFFSET INT ) ;
    public final GqlExtParser.offset_return offset() throws RecognitionException {
        GqlExtParser.offset_return retval = new GqlExtParser.offset_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token OFFSET185=null;
        Token INT186=null;

        Object OFFSET185_tree=null;
        Object INT186_tree=null;
        RewriteRuleTokenStream stream_INT=new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_OFFSET=new RewriteRuleTokenStream(adaptor,"token OFFSET");

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:337:7: ( OFFSET INT -> ^( OFFSET INT ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:338:5: OFFSET INT
            {
            OFFSET185=(Token)match(input,OFFSET,FOLLOW_OFFSET_in_offset1705);  
            stream_OFFSET.add(OFFSET185);


            INT186=(Token)match(input,INT,FOLLOW_INT_in_offset1707);  
            stream_INT.add(INT186);


            // AST REWRITE
            // elements: OFFSET, INT
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (Object)adaptor.nil();
            // 339:5: -> ^( OFFSET INT )
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:339:8: ^( OFFSET INT )
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_OFFSET.nextNode()
                , root_1);

                adaptor.addChild(root_1, 
                stream_INT.nextNode()
                );

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "offset"


    public static class valorvarobj_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "valorvarobj"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:342:1: valorvarobj : ( STRING | INT | FLOAT | TRUE | FALSE | NULL | var | datetime | keyfunc | geopt | user );
    public final GqlExtParser.valorvarobj_return valorvarobj() throws RecognitionException {
        GqlExtParser.valorvarobj_return retval = new GqlExtParser.valorvarobj_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token STRING187=null;
        Token INT188=null;
        Token FLOAT189=null;
        Token TRUE190=null;
        Token FALSE191=null;
        Token NULL192=null;
        GqlExtParser.var_return var193 =null;

        GqlExtParser.datetime_return datetime194 =null;

        GqlExtParser.keyfunc_return keyfunc195 =null;

        GqlExtParser.geopt_return geopt196 =null;

        GqlExtParser.user_return user197 =null;


        Object STRING187_tree=null;
        Object INT188_tree=null;
        Object FLOAT189_tree=null;
        Object TRUE190_tree=null;
        Object FALSE191_tree=null;
        Object NULL192_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:342:12: ( STRING | INT | FLOAT | TRUE | FALSE | NULL | var | datetime | keyfunc | geopt | user )
            int alt45=11;
            switch ( input.LA(1) ) {
            case STRING:
                {
                alt45=1;
                }
                break;
            case INT:
                {
                alt45=2;
                }
                break;
            case FLOAT:
                {
                alt45=3;
                }
                break;
            case TRUE:
                {
                alt45=4;
                }
                break;
            case FALSE:
                {
                alt45=5;
                }
                break;
            case NULL:
                {
                alt45=6;
                }
                break;
            case VARID:
                {
                alt45=7;
                }
                break;
            case DATE:
            case DATETIME:
            case TIME:
                {
                alt45=8;
                }
                break;
            case KEY:
                {
                alt45=9;
                }
                break;
            case GEOPT:
                {
                alt45=10;
                }
                break;
            case USER:
                {
                alt45=11;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 45, 0, input);

                throw nvae;

            }

            switch (alt45) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:343:5: STRING
                    {
                    root_0 = (Object)adaptor.nil();


                    STRING187=(Token)match(input,STRING,FOLLOW_STRING_in_valorvarobj1731); 
                    STRING187_tree = 
                    (Object)adaptor.create(STRING187)
                    ;
                    adaptor.addChild(root_0, STRING187_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:344:7: INT
                    {
                    root_0 = (Object)adaptor.nil();


                    INT188=(Token)match(input,INT,FOLLOW_INT_in_valorvarobj1739); 
                    INT188_tree = 
                    (Object)adaptor.create(INT188)
                    ;
                    adaptor.addChild(root_0, INT188_tree);


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:345:7: FLOAT
                    {
                    root_0 = (Object)adaptor.nil();


                    FLOAT189=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_valorvarobj1747); 
                    FLOAT189_tree = 
                    (Object)adaptor.create(FLOAT189)
                    ;
                    adaptor.addChild(root_0, FLOAT189_tree);


                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:346:7: TRUE
                    {
                    root_0 = (Object)adaptor.nil();


                    TRUE190=(Token)match(input,TRUE,FOLLOW_TRUE_in_valorvarobj1755); 
                    TRUE190_tree = 
                    (Object)adaptor.create(TRUE190)
                    ;
                    adaptor.addChild(root_0, TRUE190_tree);


                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:347:7: FALSE
                    {
                    root_0 = (Object)adaptor.nil();


                    FALSE191=(Token)match(input,FALSE,FOLLOW_FALSE_in_valorvarobj1763); 
                    FALSE191_tree = 
                    (Object)adaptor.create(FALSE191)
                    ;
                    adaptor.addChild(root_0, FALSE191_tree);


                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:348:7: NULL
                    {
                    root_0 = (Object)adaptor.nil();


                    NULL192=(Token)match(input,NULL,FOLLOW_NULL_in_valorvarobj1771); 
                    NULL192_tree = 
                    (Object)adaptor.create(NULL192)
                    ;
                    adaptor.addChild(root_0, NULL192_tree);


                    }
                    break;
                case 7 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:349:7: var
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_var_in_valorvarobj1779);
                    var193=var();

                    state._fsp--;

                    adaptor.addChild(root_0, var193.getTree());

                    }
                    break;
                case 8 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:350:7: datetime
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_datetime_in_valorvarobj1787);
                    datetime194=datetime();

                    state._fsp--;

                    adaptor.addChild(root_0, datetime194.getTree());

                    }
                    break;
                case 9 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:351:7: keyfunc
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_keyfunc_in_valorvarobj1795);
                    keyfunc195=keyfunc();

                    state._fsp--;

                    adaptor.addChild(root_0, keyfunc195.getTree());

                    }
                    break;
                case 10 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:352:7: geopt
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_geopt_in_valorvarobj1803);
                    geopt196=geopt();

                    state._fsp--;

                    adaptor.addChild(root_0, geopt196.getTree());

                    }
                    break;
                case 11 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:353:7: user
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_user_in_valorvarobj1811);
                    user197=user();

                    state._fsp--;

                    adaptor.addChild(root_0, user197.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "valorvarobj"


    public static class datetime_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "datetime"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:357:1: datetime : ( DATE LEFT_PAR sval= STRING RIGHT_PAR -> ^( DATE $sval) | DATETIME LEFT_PAR sval= STRING RIGHT_PAR -> ^( DATETIME $sval) | TIME LEFT_PAR sval= STRING RIGHT_PAR -> ^( TIME $sval) | DATE LEFT_PAR year= intorvar COMMA month= intorvar COMMA day= intorvar RIGHT_PAR -> ^( DATE $year $month $day) | DATETIME LEFT_PAR year= intorvar COMMA month= intorvar COMMA day= intorvar COMMA hour= intorvar COMMA minute= intorvar COMMA second= intorvar RIGHT_PAR -> ^( DATETIME $year $month $day $hour $minute $second) | TIME LEFT_PAR hour= intorvar COMMA minute= intorvar COMMA second= intorvar RIGHT_PAR -> ^( TIME $hour $minute $second) );
    public final GqlExtParser.datetime_return datetime() throws RecognitionException {
        GqlExtParser.datetime_return retval = new GqlExtParser.datetime_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token sval=null;
        Token DATE198=null;
        Token LEFT_PAR199=null;
        Token RIGHT_PAR200=null;
        Token DATETIME201=null;
        Token LEFT_PAR202=null;
        Token RIGHT_PAR203=null;
        Token TIME204=null;
        Token LEFT_PAR205=null;
        Token RIGHT_PAR206=null;
        Token DATE207=null;
        Token LEFT_PAR208=null;
        Token COMMA209=null;
        Token COMMA210=null;
        Token RIGHT_PAR211=null;
        Token DATETIME212=null;
        Token LEFT_PAR213=null;
        Token COMMA214=null;
        Token COMMA215=null;
        Token COMMA216=null;
        Token COMMA217=null;
        Token COMMA218=null;
        Token RIGHT_PAR219=null;
        Token TIME220=null;
        Token LEFT_PAR221=null;
        Token COMMA222=null;
        Token COMMA223=null;
        Token RIGHT_PAR224=null;
        GqlExtParser.intorvar_return year =null;

        GqlExtParser.intorvar_return month =null;

        GqlExtParser.intorvar_return day =null;

        GqlExtParser.intorvar_return hour =null;

        GqlExtParser.intorvar_return minute =null;

        GqlExtParser.intorvar_return second =null;


        Object sval_tree=null;
        Object DATE198_tree=null;
        Object LEFT_PAR199_tree=null;
        Object RIGHT_PAR200_tree=null;
        Object DATETIME201_tree=null;
        Object LEFT_PAR202_tree=null;
        Object RIGHT_PAR203_tree=null;
        Object TIME204_tree=null;
        Object LEFT_PAR205_tree=null;
        Object RIGHT_PAR206_tree=null;
        Object DATE207_tree=null;
        Object LEFT_PAR208_tree=null;
        Object COMMA209_tree=null;
        Object COMMA210_tree=null;
        Object RIGHT_PAR211_tree=null;
        Object DATETIME212_tree=null;
        Object LEFT_PAR213_tree=null;
        Object COMMA214_tree=null;
        Object COMMA215_tree=null;
        Object COMMA216_tree=null;
        Object COMMA217_tree=null;
        Object COMMA218_tree=null;
        Object RIGHT_PAR219_tree=null;
        Object TIME220_tree=null;
        Object LEFT_PAR221_tree=null;
        Object COMMA222_tree=null;
        Object COMMA223_tree=null;
        Object RIGHT_PAR224_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_TIME=new RewriteRuleTokenStream(adaptor,"token TIME");
        RewriteRuleTokenStream stream_DATE=new RewriteRuleTokenStream(adaptor,"token DATE");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_DATETIME=new RewriteRuleTokenStream(adaptor,"token DATETIME");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");
        RewriteRuleSubtreeStream stream_intorvar=new RewriteRuleSubtreeStream(adaptor,"rule intorvar");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:357:9: ( DATE LEFT_PAR sval= STRING RIGHT_PAR -> ^( DATE $sval) | DATETIME LEFT_PAR sval= STRING RIGHT_PAR -> ^( DATETIME $sval) | TIME LEFT_PAR sval= STRING RIGHT_PAR -> ^( TIME $sval) | DATE LEFT_PAR year= intorvar COMMA month= intorvar COMMA day= intorvar RIGHT_PAR -> ^( DATE $year $month $day) | DATETIME LEFT_PAR year= intorvar COMMA month= intorvar COMMA day= intorvar COMMA hour= intorvar COMMA minute= intorvar COMMA second= intorvar RIGHT_PAR -> ^( DATETIME $year $month $day $hour $minute $second) | TIME LEFT_PAR hour= intorvar COMMA minute= intorvar COMMA second= intorvar RIGHT_PAR -> ^( TIME $hour $minute $second) )
            int alt46=6;
            switch ( input.LA(1) ) {
            case DATE:
                {
                int LA46_1 = input.LA(2);

                if ( (LA46_1==LEFT_PAR) ) {
                    int LA46_4 = input.LA(3);

                    if ( (LA46_4==STRING) ) {
                        alt46=1;
                    }
                    else if ( (LA46_4==INT||LA46_4==VARID) ) {
                        alt46=4;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 46, 4, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 46, 1, input);

                    throw nvae;

                }
                }
                break;
            case DATETIME:
                {
                int LA46_2 = input.LA(2);

                if ( (LA46_2==LEFT_PAR) ) {
                    int LA46_5 = input.LA(3);

                    if ( (LA46_5==STRING) ) {
                        alt46=2;
                    }
                    else if ( (LA46_5==INT||LA46_5==VARID) ) {
                        alt46=5;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 46, 5, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 46, 2, input);

                    throw nvae;

                }
                }
                break;
            case TIME:
                {
                int LA46_3 = input.LA(2);

                if ( (LA46_3==LEFT_PAR) ) {
                    int LA46_6 = input.LA(3);

                    if ( (LA46_6==STRING) ) {
                        alt46=3;
                    }
                    else if ( (LA46_6==INT||LA46_6==VARID) ) {
                        alt46=6;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 46, 6, input);

                        throw nvae;

                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 46, 3, input);

                    throw nvae;

                }
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 46, 0, input);

                throw nvae;

            }

            switch (alt46) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:358:5: DATE LEFT_PAR sval= STRING RIGHT_PAR
                    {
                    DATE198=(Token)match(input,DATE,FOLLOW_DATE_in_datetime1828);  
                    stream_DATE.add(DATE198);


                    LEFT_PAR199=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_datetime1830);  
                    stream_LEFT_PAR.add(LEFT_PAR199);


                    sval=(Token)match(input,STRING,FOLLOW_STRING_in_datetime1834);  
                    stream_STRING.add(sval);


                    RIGHT_PAR200=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_datetime1836);  
                    stream_RIGHT_PAR.add(RIGHT_PAR200);


                    // AST REWRITE
                    // elements: DATE, sval
                    // token labels: sval
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_sval=new RewriteRuleTokenStream(adaptor,"token sval",sval);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 358:41: -> ^( DATE $sval)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:358:44: ^( DATE $sval)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_DATE.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_sval.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:359:7: DATETIME LEFT_PAR sval= STRING RIGHT_PAR
                    {
                    DATETIME201=(Token)match(input,DATETIME,FOLLOW_DATETIME_in_datetime1853);  
                    stream_DATETIME.add(DATETIME201);


                    LEFT_PAR202=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_datetime1855);  
                    stream_LEFT_PAR.add(LEFT_PAR202);


                    sval=(Token)match(input,STRING,FOLLOW_STRING_in_datetime1859);  
                    stream_STRING.add(sval);


                    RIGHT_PAR203=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_datetime1861);  
                    stream_RIGHT_PAR.add(RIGHT_PAR203);


                    // AST REWRITE
                    // elements: DATETIME, sval
                    // token labels: sval
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_sval=new RewriteRuleTokenStream(adaptor,"token sval",sval);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 359:47: -> ^( DATETIME $sval)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:359:50: ^( DATETIME $sval)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_DATETIME.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_sval.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:360:7: TIME LEFT_PAR sval= STRING RIGHT_PAR
                    {
                    TIME204=(Token)match(input,TIME,FOLLOW_TIME_in_datetime1878);  
                    stream_TIME.add(TIME204);


                    LEFT_PAR205=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_datetime1880);  
                    stream_LEFT_PAR.add(LEFT_PAR205);


                    sval=(Token)match(input,STRING,FOLLOW_STRING_in_datetime1884);  
                    stream_STRING.add(sval);


                    RIGHT_PAR206=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_datetime1886);  
                    stream_RIGHT_PAR.add(RIGHT_PAR206);


                    // AST REWRITE
                    // elements: sval, TIME
                    // token labels: sval
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_sval=new RewriteRuleTokenStream(adaptor,"token sval",sval);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 360:43: -> ^( TIME $sval)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:360:46: ^( TIME $sval)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_TIME.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_sval.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:361:7: DATE LEFT_PAR year= intorvar COMMA month= intorvar COMMA day= intorvar RIGHT_PAR
                    {
                    DATE207=(Token)match(input,DATE,FOLLOW_DATE_in_datetime1903);  
                    stream_DATE.add(DATE207);


                    LEFT_PAR208=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_datetime1905);  
                    stream_LEFT_PAR.add(LEFT_PAR208);


                    pushFollow(FOLLOW_intorvar_in_datetime1909);
                    year=intorvar();

                    state._fsp--;

                    stream_intorvar.add(year.getTree());

                    COMMA209=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1911);  
                    stream_COMMA.add(COMMA209);


                    pushFollow(FOLLOW_intorvar_in_datetime1915);
                    month=intorvar();

                    state._fsp--;

                    stream_intorvar.add(month.getTree());

                    COMMA210=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1917);  
                    stream_COMMA.add(COMMA210);


                    pushFollow(FOLLOW_intorvar_in_datetime1921);
                    day=intorvar();

                    state._fsp--;

                    stream_intorvar.add(day.getTree());

                    RIGHT_PAR211=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_datetime1923);  
                    stream_RIGHT_PAR.add(RIGHT_PAR211);


                    // AST REWRITE
                    // elements: month, year, day, DATE
                    // token labels: 
                    // rule labels: retval, month, year, day
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_month=new RewriteRuleSubtreeStream(adaptor,"rule month",month!=null?month.tree:null);
                    RewriteRuleSubtreeStream stream_year=new RewriteRuleSubtreeStream(adaptor,"rule year",year!=null?year.tree:null);
                    RewriteRuleSubtreeStream stream_day=new RewriteRuleSubtreeStream(adaptor,"rule day",day!=null?day.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 362:9: -> ^( DATE $year $month $day)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:362:12: ^( DATE $year $month $day)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_DATE.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_year.nextTree());

                        adaptor.addChild(root_1, stream_month.nextTree());

                        adaptor.addChild(root_1, stream_day.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:363:7: DATETIME LEFT_PAR year= intorvar COMMA month= intorvar COMMA day= intorvar COMMA hour= intorvar COMMA minute= intorvar COMMA second= intorvar RIGHT_PAR
                    {
                    DATETIME212=(Token)match(input,DATETIME,FOLLOW_DATETIME_in_datetime1954);  
                    stream_DATETIME.add(DATETIME212);


                    LEFT_PAR213=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_datetime1956);  
                    stream_LEFT_PAR.add(LEFT_PAR213);


                    pushFollow(FOLLOW_intorvar_in_datetime1960);
                    year=intorvar();

                    state._fsp--;

                    stream_intorvar.add(year.getTree());

                    COMMA214=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1962);  
                    stream_COMMA.add(COMMA214);


                    pushFollow(FOLLOW_intorvar_in_datetime1966);
                    month=intorvar();

                    state._fsp--;

                    stream_intorvar.add(month.getTree());

                    COMMA215=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1968);  
                    stream_COMMA.add(COMMA215);


                    pushFollow(FOLLOW_intorvar_in_datetime1972);
                    day=intorvar();

                    state._fsp--;

                    stream_intorvar.add(day.getTree());

                    COMMA216=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1974);  
                    stream_COMMA.add(COMMA216);


                    pushFollow(FOLLOW_intorvar_in_datetime1978);
                    hour=intorvar();

                    state._fsp--;

                    stream_intorvar.add(hour.getTree());

                    COMMA217=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1980);  
                    stream_COMMA.add(COMMA217);


                    pushFollow(FOLLOW_intorvar_in_datetime1984);
                    minute=intorvar();

                    state._fsp--;

                    stream_intorvar.add(minute.getTree());

                    COMMA218=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime1986);  
                    stream_COMMA.add(COMMA218);


                    pushFollow(FOLLOW_intorvar_in_datetime1990);
                    second=intorvar();

                    state._fsp--;

                    stream_intorvar.add(second.getTree());

                    RIGHT_PAR219=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_datetime1992);  
                    stream_RIGHT_PAR.add(RIGHT_PAR219);


                    // AST REWRITE
                    // elements: day, month, hour, minute, DATETIME, second, year
                    // token labels: 
                    // rule labels: minute, retval, second, month, year, hour, day
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_minute=new RewriteRuleSubtreeStream(adaptor,"rule minute",minute!=null?minute.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_second=new RewriteRuleSubtreeStream(adaptor,"rule second",second!=null?second.tree:null);
                    RewriteRuleSubtreeStream stream_month=new RewriteRuleSubtreeStream(adaptor,"rule month",month!=null?month.tree:null);
                    RewriteRuleSubtreeStream stream_year=new RewriteRuleSubtreeStream(adaptor,"rule year",year!=null?year.tree:null);
                    RewriteRuleSubtreeStream stream_hour=new RewriteRuleSubtreeStream(adaptor,"rule hour",hour!=null?hour.tree:null);
                    RewriteRuleSubtreeStream stream_day=new RewriteRuleSubtreeStream(adaptor,"rule day",day!=null?day.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 364:9: -> ^( DATETIME $year $month $day $hour $minute $second)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:364:12: ^( DATETIME $year $month $day $hour $minute $second)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_DATETIME.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_year.nextTree());

                        adaptor.addChild(root_1, stream_month.nextTree());

                        adaptor.addChild(root_1, stream_day.nextTree());

                        adaptor.addChild(root_1, stream_hour.nextTree());

                        adaptor.addChild(root_1, stream_minute.nextTree());

                        adaptor.addChild(root_1, stream_second.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 6 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:365:7: TIME LEFT_PAR hour= intorvar COMMA minute= intorvar COMMA second= intorvar RIGHT_PAR
                    {
                    TIME220=(Token)match(input,TIME,FOLLOW_TIME_in_datetime2032);  
                    stream_TIME.add(TIME220);


                    LEFT_PAR221=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_datetime2034);  
                    stream_LEFT_PAR.add(LEFT_PAR221);


                    pushFollow(FOLLOW_intorvar_in_datetime2038);
                    hour=intorvar();

                    state._fsp--;

                    stream_intorvar.add(hour.getTree());

                    COMMA222=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime2040);  
                    stream_COMMA.add(COMMA222);


                    pushFollow(FOLLOW_intorvar_in_datetime2044);
                    minute=intorvar();

                    state._fsp--;

                    stream_intorvar.add(minute.getTree());

                    COMMA223=(Token)match(input,COMMA,FOLLOW_COMMA_in_datetime2046);  
                    stream_COMMA.add(COMMA223);


                    pushFollow(FOLLOW_intorvar_in_datetime2050);
                    second=intorvar();

                    state._fsp--;

                    stream_intorvar.add(second.getTree());

                    RIGHT_PAR224=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_datetime2052);  
                    stream_RIGHT_PAR.add(RIGHT_PAR224);


                    // AST REWRITE
                    // elements: minute, second, TIME, hour
                    // token labels: 
                    // rule labels: minute, retval, second, hour
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_minute=new RewriteRuleSubtreeStream(adaptor,"rule minute",minute!=null?minute.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_second=new RewriteRuleSubtreeStream(adaptor,"rule second",second!=null?second.tree:null);
                    RewriteRuleSubtreeStream stream_hour=new RewriteRuleSubtreeStream(adaptor,"rule hour",hour!=null?hour.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 366:9: -> ^( TIME $hour $minute $second)
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:366:12: ^( TIME $hour $minute $second)
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_TIME.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, stream_hour.nextTree());

                        adaptor.addChild(root_1, stream_minute.nextTree());

                        adaptor.addChild(root_1, stream_second.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "datetime"


    public static class geopt_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "geopt"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:369:1: geopt : GEOPT LEFT_PAR lat= floatorvar COMMA lon= floatorvar RIGHT_PAR -> ^( GEOPT $lat $lon) ;
    public final GqlExtParser.geopt_return geopt() throws RecognitionException {
        GqlExtParser.geopt_return retval = new GqlExtParser.geopt_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token GEOPT225=null;
        Token LEFT_PAR226=null;
        Token COMMA227=null;
        Token RIGHT_PAR228=null;
        GqlExtParser.floatorvar_return lat =null;

        GqlExtParser.floatorvar_return lon =null;


        Object GEOPT225_tree=null;
        Object LEFT_PAR226_tree=null;
        Object COMMA227_tree=null;
        Object RIGHT_PAR228_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_GEOPT=new RewriteRuleTokenStream(adaptor,"token GEOPT");
        RewriteRuleSubtreeStream stream_floatorvar=new RewriteRuleSubtreeStream(adaptor,"rule floatorvar");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:369:6: ( GEOPT LEFT_PAR lat= floatorvar COMMA lon= floatorvar RIGHT_PAR -> ^( GEOPT $lat $lon) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:370:5: GEOPT LEFT_PAR lat= floatorvar COMMA lon= floatorvar RIGHT_PAR
            {
            GEOPT225=(Token)match(input,GEOPT,FOLLOW_GEOPT_in_geopt2087);  
            stream_GEOPT.add(GEOPT225);


            LEFT_PAR226=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_geopt2089);  
            stream_LEFT_PAR.add(LEFT_PAR226);


            pushFollow(FOLLOW_floatorvar_in_geopt2093);
            lat=floatorvar();

            state._fsp--;

            stream_floatorvar.add(lat.getTree());

            COMMA227=(Token)match(input,COMMA,FOLLOW_COMMA_in_geopt2095);  
            stream_COMMA.add(COMMA227);


            pushFollow(FOLLOW_floatorvar_in_geopt2099);
            lon=floatorvar();

            state._fsp--;

            stream_floatorvar.add(lon.getTree());

            RIGHT_PAR228=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_geopt2101);  
            stream_RIGHT_PAR.add(RIGHT_PAR228);


            // AST REWRITE
            // elements: lon, GEOPT, lat
            // token labels: 
            // rule labels: retval, lon, lat
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_lon=new RewriteRuleSubtreeStream(adaptor,"rule lon",lon!=null?lon.tree:null);
            RewriteRuleSubtreeStream stream_lat=new RewriteRuleSubtreeStream(adaptor,"rule lat",lat!=null?lat.tree:null);

            root_0 = (Object)adaptor.nil();
            // 371:5: -> ^( GEOPT $lat $lon)
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:371:8: ^( GEOPT $lat $lon)
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_GEOPT.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_lat.nextTree());

                adaptor.addChild(root_1, stream_lon.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "geopt"


    public static class user_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "user"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:374:1: user : USER LEFT_PAR email= stringorvar RIGHT_PAR -> ^( USER $email) ;
    public final GqlExtParser.user_return user() throws RecognitionException {
        GqlExtParser.user_return retval = new GqlExtParser.user_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token USER229=null;
        Token LEFT_PAR230=null;
        Token RIGHT_PAR231=null;
        GqlExtParser.stringorvar_return email =null;


        Object USER229_tree=null;
        Object LEFT_PAR230_tree=null;
        Object RIGHT_PAR231_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_USER=new RewriteRuleTokenStream(adaptor,"token USER");
        RewriteRuleSubtreeStream stream_stringorvar=new RewriteRuleSubtreeStream(adaptor,"rule stringorvar");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:374:5: ( USER LEFT_PAR email= stringorvar RIGHT_PAR -> ^( USER $email) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:375:5: USER LEFT_PAR email= stringorvar RIGHT_PAR
            {
            USER229=(Token)match(input,USER,FOLLOW_USER_in_user2129);  
            stream_USER.add(USER229);


            LEFT_PAR230=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_user2131);  
            stream_LEFT_PAR.add(LEFT_PAR230);


            pushFollow(FOLLOW_stringorvar_in_user2135);
            email=stringorvar();

            state._fsp--;

            stream_stringorvar.add(email.getTree());

            RIGHT_PAR231=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_user2137);  
            stream_RIGHT_PAR.add(RIGHT_PAR231);


            // AST REWRITE
            // elements: email, USER
            // token labels: 
            // rule labels: retval, email
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_email=new RewriteRuleSubtreeStream(adaptor,"rule email",email!=null?email.tree:null);

            root_0 = (Object)adaptor.nil();
            // 376:5: -> ^( USER $email)
            {
                // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:376:8: ^( USER $email)
                {
                Object root_1 = (Object)adaptor.nil();
                root_1 = (Object)adaptor.becomeRoot(
                stream_USER.nextNode()
                , root_1);

                adaptor.addChild(root_1, stream_email.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }


            retval.tree = root_0;

            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "user"


    public static class intorvar_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "intorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:379:1: intorvar : ( INT | var );
    public final GqlExtParser.intorvar_return intorvar() throws RecognitionException {
        GqlExtParser.intorvar_return retval = new GqlExtParser.intorvar_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token INT232=null;
        GqlExtParser.var_return var233 =null;


        Object INT232_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:379:9: ( INT | var )
            int alt47=2;
            int LA47_0 = input.LA(1);

            if ( (LA47_0==INT) ) {
                alt47=1;
            }
            else if ( (LA47_0==VARID) ) {
                alt47=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 47, 0, input);

                throw nvae;

            }
            switch (alt47) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:379:11: INT
                    {
                    root_0 = (Object)adaptor.nil();


                    INT232=(Token)match(input,INT,FOLLOW_INT_in_intorvar2158); 
                    INT232_tree = 
                    (Object)adaptor.create(INT232)
                    ;
                    adaptor.addChild(root_0, INT232_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:379:17: var
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_var_in_intorvar2162);
                    var233=var();

                    state._fsp--;

                    adaptor.addChild(root_0, var233.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "intorvar"


    public static class floatorvar_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "floatorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:382:1: floatorvar : ( INT | FLOAT | var );
    public final GqlExtParser.floatorvar_return floatorvar() throws RecognitionException {
        GqlExtParser.floatorvar_return retval = new GqlExtParser.floatorvar_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token INT234=null;
        Token FLOAT235=null;
        GqlExtParser.var_return var236 =null;


        Object INT234_tree=null;
        Object FLOAT235_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:382:11: ( INT | FLOAT | var )
            int alt48=3;
            switch ( input.LA(1) ) {
            case INT:
                {
                alt48=1;
                }
                break;
            case FLOAT:
                {
                alt48=2;
                }
                break;
            case VARID:
                {
                alt48=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 48, 0, input);

                throw nvae;

            }

            switch (alt48) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:382:13: INT
                    {
                    root_0 = (Object)adaptor.nil();


                    INT234=(Token)match(input,INT,FOLLOW_INT_in_floatorvar2170); 
                    INT234_tree = 
                    (Object)adaptor.create(INT234)
                    ;
                    adaptor.addChild(root_0, INT234_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:382:19: FLOAT
                    {
                    root_0 = (Object)adaptor.nil();


                    FLOAT235=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_floatorvar2174); 
                    FLOAT235_tree = 
                    (Object)adaptor.create(FLOAT235)
                    ;
                    adaptor.addChild(root_0, FLOAT235_tree);


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:382:27: var
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_var_in_floatorvar2178);
                    var236=var();

                    state._fsp--;

                    adaptor.addChild(root_0, var236.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "floatorvar"


    public static class intstringorvar_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "intstringorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:385:1: intstringorvar : ( INT | STRING | var );
    public final GqlExtParser.intstringorvar_return intstringorvar() throws RecognitionException {
        GqlExtParser.intstringorvar_return retval = new GqlExtParser.intstringorvar_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token INT237=null;
        Token STRING238=null;
        GqlExtParser.var_return var239 =null;


        Object INT237_tree=null;
        Object STRING238_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:385:15: ( INT | STRING | var )
            int alt49=3;
            switch ( input.LA(1) ) {
            case INT:
                {
                alt49=1;
                }
                break;
            case STRING:
                {
                alt49=2;
                }
                break;
            case VARID:
                {
                alt49=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 49, 0, input);

                throw nvae;

            }

            switch (alt49) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:385:17: INT
                    {
                    root_0 = (Object)adaptor.nil();


                    INT237=(Token)match(input,INT,FOLLOW_INT_in_intstringorvar2186); 
                    INT237_tree = 
                    (Object)adaptor.create(INT237)
                    ;
                    adaptor.addChild(root_0, INT237_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:385:23: STRING
                    {
                    root_0 = (Object)adaptor.nil();


                    STRING238=(Token)match(input,STRING,FOLLOW_STRING_in_intstringorvar2190); 
                    STRING238_tree = 
                    (Object)adaptor.create(STRING238)
                    ;
                    adaptor.addChild(root_0, STRING238_tree);


                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:385:32: var
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_var_in_intstringorvar2194);
                    var239=var();

                    state._fsp--;

                    adaptor.addChild(root_0, var239.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "intstringorvar"


    public static class stringorvar_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "stringorvar"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:388:1: stringorvar : ( STRING | var );
    public final GqlExtParser.stringorvar_return stringorvar() throws RecognitionException {
        GqlExtParser.stringorvar_return retval = new GqlExtParser.stringorvar_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token STRING240=null;
        GqlExtParser.var_return var241 =null;


        Object STRING240_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:388:12: ( STRING | var )
            int alt50=2;
            int LA50_0 = input.LA(1);

            if ( (LA50_0==STRING) ) {
                alt50=1;
            }
            else if ( (LA50_0==VARID) ) {
                alt50=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 50, 0, input);

                throw nvae;

            }
            switch (alt50) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:388:14: STRING
                    {
                    root_0 = (Object)adaptor.nil();


                    STRING240=(Token)match(input,STRING,FOLLOW_STRING_in_stringorvar2202); 
                    STRING240_tree = 
                    (Object)adaptor.create(STRING240)
                    ;
                    adaptor.addChild(root_0, STRING240_tree);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:388:23: var
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_var_in_stringorvar2206);
                    var241=var();

                    state._fsp--;

                    adaptor.addChild(root_0, var241.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "stringorvar"


    public static class var_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "var"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:391:1: var : VARID ;
    public final GqlExtParser.var_return var() throws RecognitionException {
        GqlExtParser.var_return retval = new GqlExtParser.var_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token VARID242=null;

        Object VARID242_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:391:4: ( VARID )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:391:6: VARID
            {
            root_0 = (Object)adaptor.nil();


            VARID242=(Token)match(input,VARID,FOLLOW_VARID_in_var2214); 
            VARID242_tree = 
            (Object)adaptor.create(VARID242)
            ;
            adaptor.addChild(root_0, VARID242_tree);


            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "var"


    public static class prop_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "prop"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:394:1: prop : ( property | KEYPROP ) ;
    public final GqlExtParser.prop_return prop() throws RecognitionException {
        GqlExtParser.prop_return retval = new GqlExtParser.prop_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token KEYPROP244=null;
        GqlExtParser.property_return property243 =null;


        Object KEYPROP244_tree=null;

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:394:5: ( ( property | KEYPROP ) )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:394:7: ( property | KEYPROP )
            {
            root_0 = (Object)adaptor.nil();


            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:394:7: ( property | KEYPROP )
            int alt51=2;
            int LA51_0 = input.LA(1);

            if ( (LA51_0==ID||LA51_0==PROP) ) {
                alt51=1;
            }
            else if ( (LA51_0==KEYPROP) ) {
                alt51=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 51, 0, input);

                throw nvae;

            }
            switch (alt51) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:394:8: property
                    {
                    pushFollow(FOLLOW_property_in_prop2223);
                    property243=property();

                    state._fsp--;

                    adaptor.addChild(root_0, property243.getTree());

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:394:19: KEYPROP
                    {
                    KEYPROP244=(Token)match(input,KEYPROP,FOLLOW_KEYPROP_in_prop2227); 
                    KEYPROP244_tree = 
                    (Object)adaptor.create(KEYPROP244)
                    ;
                    adaptor.addChild(root_0, KEYPROP244_tree);


                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "prop"


    public static class property_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "property"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:397:1: property : (id+= ID ( DOT id+= ID )* -> ^( PROP ( $id)+ ) | PROP LEFT_PAR STRING RIGHT_PAR -> ^( PROP STRING ) );
    public final GqlExtParser.property_return property() throws RecognitionException {
        GqlExtParser.property_return retval = new GqlExtParser.property_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token DOT245=null;
        Token PROP246=null;
        Token LEFT_PAR247=null;
        Token STRING248=null;
        Token RIGHT_PAR249=null;
        Token id=null;
        List list_id=null;

        Object DOT245_tree=null;
        Object PROP246_tree=null;
        Object LEFT_PAR247_tree=null;
        Object STRING248_tree=null;
        Object RIGHT_PAR249_tree=null;
        Object id_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_DOT=new RewriteRuleTokenStream(adaptor,"token DOT");
        RewriteRuleTokenStream stream_PROP=new RewriteRuleTokenStream(adaptor,"token PROP");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:397:9: (id+= ID ( DOT id+= ID )* -> ^( PROP ( $id)+ ) | PROP LEFT_PAR STRING RIGHT_PAR -> ^( PROP STRING ) )
            int alt53=2;
            int LA53_0 = input.LA(1);

            if ( (LA53_0==ID) ) {
                alt53=1;
            }
            else if ( (LA53_0==PROP) ) {
                alt53=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 53, 0, input);

                throw nvae;

            }
            switch (alt53) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:398:5: id+= ID ( DOT id+= ID )*
                    {
                    id=(Token)match(input,ID,FOLLOW_ID_in_property2242);  
                    stream_ID.add(id);

                    if (list_id==null) list_id=new ArrayList();
                    list_id.add(id);


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:398:12: ( DOT id+= ID )*
                    loop52:
                    do {
                        int alt52=2;
                        int LA52_0 = input.LA(1);

                        if ( (LA52_0==DOT) ) {
                            alt52=1;
                        }


                        switch (alt52) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:398:13: DOT id+= ID
                    	    {
                    	    DOT245=(Token)match(input,DOT,FOLLOW_DOT_in_property2245);  
                    	    stream_DOT.add(DOT245);


                    	    id=(Token)match(input,ID,FOLLOW_ID_in_property2249);  
                    	    stream_ID.add(id);

                    	    if (list_id==null) list_id=new ArrayList();
                    	    list_id.add(id);


                    	    }
                    	    break;

                    	default :
                    	    break loop52;
                        }
                    } while (true);


                    // AST REWRITE
                    // elements: id
                    // token labels: 
                    // rule labels: retval
                    // token list labels: id
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_id=new RewriteRuleTokenStream(adaptor,"token id", list_id);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 398:26: -> ^( PROP ( $id)+ )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:398:29: ^( PROP ( $id)+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(PROP, "PROP")
                        , root_1);

                        if ( !(stream_id.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_id.hasNext() ) {
                            adaptor.addChild(root_1, stream_id.nextNode());

                        }
                        stream_id.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:399:7: PROP LEFT_PAR STRING RIGHT_PAR
                    {
                    PROP246=(Token)match(input,PROP,FOLLOW_PROP_in_property2269);  
                    stream_PROP.add(PROP246);


                    LEFT_PAR247=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_property2271);  
                    stream_LEFT_PAR.add(LEFT_PAR247);


                    STRING248=(Token)match(input,STRING,FOLLOW_STRING_in_property2273);  
                    stream_STRING.add(STRING248);


                    RIGHT_PAR249=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_property2275);  
                    stream_RIGHT_PAR.add(RIGHT_PAR249);


                    // AST REWRITE
                    // elements: STRING, PROP
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 399:38: -> ^( PROP STRING )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:399:41: ^( PROP STRING )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_PROP.nextNode()
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_STRING.nextNode()
                        );

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "property"


    public static class kind_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "kind"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:402:1: kind : (id+= ID ( DOT id+= ID )* -> ^( KIND ( $id)+ ) | KIND LEFT_PAR ( STRING )? RIGHT_PAR -> ^( KIND ( STRING )? ) );
    public final GqlExtParser.kind_return kind() throws RecognitionException {
        GqlExtParser.kind_return retval = new GqlExtParser.kind_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token DOT250=null;
        Token KIND251=null;
        Token LEFT_PAR252=null;
        Token STRING253=null;
        Token RIGHT_PAR254=null;
        Token id=null;
        List list_id=null;

        Object DOT250_tree=null;
        Object KIND251_tree=null;
        Object LEFT_PAR252_tree=null;
        Object STRING253_tree=null;
        Object RIGHT_PAR254_tree=null;
        Object id_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_DOT=new RewriteRuleTokenStream(adaptor,"token DOT");
        RewriteRuleTokenStream stream_KIND=new RewriteRuleTokenStream(adaptor,"token KIND");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleTokenStream stream_STRING=new RewriteRuleTokenStream(adaptor,"token STRING");

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:402:5: (id+= ID ( DOT id+= ID )* -> ^( KIND ( $id)+ ) | KIND LEFT_PAR ( STRING )? RIGHT_PAR -> ^( KIND ( STRING )? ) )
            int alt56=2;
            int LA56_0 = input.LA(1);

            if ( (LA56_0==ID) ) {
                alt56=1;
            }
            else if ( (LA56_0==KIND) ) {
                alt56=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 56, 0, input);

                throw nvae;

            }
            switch (alt56) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:403:5: id+= ID ( DOT id+= ID )*
                    {
                    id=(Token)match(input,ID,FOLLOW_ID_in_kind2297);  
                    stream_ID.add(id);

                    if (list_id==null) list_id=new ArrayList();
                    list_id.add(id);


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:403:12: ( DOT id+= ID )*
                    loop54:
                    do {
                        int alt54=2;
                        int LA54_0 = input.LA(1);

                        if ( (LA54_0==DOT) ) {
                            alt54=1;
                        }


                        switch (alt54) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:403:13: DOT id+= ID
                    	    {
                    	    DOT250=(Token)match(input,DOT,FOLLOW_DOT_in_kind2300);  
                    	    stream_DOT.add(DOT250);


                    	    id=(Token)match(input,ID,FOLLOW_ID_in_kind2304);  
                    	    stream_ID.add(id);

                    	    if (list_id==null) list_id=new ArrayList();
                    	    list_id.add(id);


                    	    }
                    	    break;

                    	default :
                    	    break loop54;
                        }
                    } while (true);


                    // AST REWRITE
                    // elements: id
                    // token labels: 
                    // rule labels: retval
                    // token list labels: id
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleTokenStream stream_id=new RewriteRuleTokenStream(adaptor,"token id", list_id);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 403:26: -> ^( KIND ( $id)+ )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:403:29: ^( KIND ( $id)+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(KIND, "KIND")
                        , root_1);

                        if ( !(stream_id.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_id.hasNext() ) {
                            adaptor.addChild(root_1, stream_id.nextNode());

                        }
                        stream_id.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:404:7: KIND LEFT_PAR ( STRING )? RIGHT_PAR
                    {
                    KIND251=(Token)match(input,KIND,FOLLOW_KIND_in_kind2324);  
                    stream_KIND.add(KIND251);


                    LEFT_PAR252=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_kind2326);  
                    stream_LEFT_PAR.add(LEFT_PAR252);


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:404:21: ( STRING )?
                    int alt55=2;
                    int LA55_0 = input.LA(1);

                    if ( (LA55_0==STRING) ) {
                        alt55=1;
                    }
                    switch (alt55) {
                        case 1 :
                            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:404:21: STRING
                            {
                            STRING253=(Token)match(input,STRING,FOLLOW_STRING_in_kind2328);  
                            stream_STRING.add(STRING253);


                            }
                            break;

                    }


                    RIGHT_PAR254=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_kind2331);  
                    stream_RIGHT_PAR.add(RIGHT_PAR254);


                    // AST REWRITE
                    // elements: STRING, KIND
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 404:39: -> ^( KIND ( STRING )? )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:404:42: ^( KIND ( STRING )? )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        stream_KIND.nextNode()
                        , root_1);

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:404:49: ( STRING )?
                        if ( stream_STRING.hasNext() ) {
                            adaptor.addChild(root_1, 
                            stream_STRING.nextNode()
                            );

                        }
                        stream_STRING.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "kind"


    public static class expr_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "expr"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:407:1: expr : ( mul ( ( PLUS | MINUS ) ^ mul )* | MINUS mul -> ^( UMINUS mul ) | PLUS mul -> mul );
    public final GqlExtParser.expr_return expr() throws RecognitionException {
        GqlExtParser.expr_return retval = new GqlExtParser.expr_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token set256=null;
        Token MINUS258=null;
        Token PLUS260=null;
        GqlExtParser.mul_return mul255 =null;

        GqlExtParser.mul_return mul257 =null;

        GqlExtParser.mul_return mul259 =null;

        GqlExtParser.mul_return mul261 =null;


        Object set256_tree=null;
        Object MINUS258_tree=null;
        Object PLUS260_tree=null;
        RewriteRuleTokenStream stream_PLUS=new RewriteRuleTokenStream(adaptor,"token PLUS");
        RewriteRuleTokenStream stream_MINUS=new RewriteRuleTokenStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_mul=new RewriteRuleSubtreeStream(adaptor,"rule mul");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:407:5: ( mul ( ( PLUS | MINUS ) ^ mul )* | MINUS mul -> ^( UMINUS mul ) | PLUS mul -> mul )
            int alt58=3;
            switch ( input.LA(1) ) {
            case DATE:
            case DATETIME:
            case FALSE:
            case FLOAT:
            case GEOPT:
            case ID:
            case INT:
            case KEY:
            case KEYPROP:
            case LEFT_PAR:
            case NULL:
            case PROP:
            case STRING:
            case TIME:
            case TRUE:
            case USER:
            case VARID:
                {
                alt58=1;
                }
                break;
            case MINUS:
                {
                alt58=2;
                }
                break;
            case PLUS:
                {
                alt58=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 58, 0, input);

                throw nvae;

            }

            switch (alt58) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:408:5: mul ( ( PLUS | MINUS ) ^ mul )*
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_mul_in_expr2352);
                    mul255=mul();

                    state._fsp--;

                    adaptor.addChild(root_0, mul255.getTree());

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:408:9: ( ( PLUS | MINUS ) ^ mul )*
                    loop57:
                    do {
                        int alt57=2;
                        int LA57_0 = input.LA(1);

                        if ( (LA57_0==MINUS||LA57_0==PLUS) ) {
                            alt57=1;
                        }


                        switch (alt57) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:408:10: ( PLUS | MINUS ) ^ mul
                    	    {
                    	    set256=(Token)input.LT(1);

                    	    set256=(Token)input.LT(1);

                    	    if ( input.LA(1)==MINUS||input.LA(1)==PLUS ) {
                    	        input.consume();
                    	        root_0 = (Object)adaptor.becomeRoot(
                    	        (Object)adaptor.create(set256)
                    	        , root_0);
                    	        state.errorRecovery=false;
                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        throw mse;
                    	    }


                    	    pushFollow(FOLLOW_mul_in_expr2364);
                    	    mul257=mul();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, mul257.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop57;
                        }
                    } while (true);


                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:409:7: MINUS mul
                    {
                    MINUS258=(Token)match(input,MINUS,FOLLOW_MINUS_in_expr2374);  
                    stream_MINUS.add(MINUS258);


                    pushFollow(FOLLOW_mul_in_expr2376);
                    mul259=mul();

                    state._fsp--;

                    stream_mul.add(mul259.getTree());

                    // AST REWRITE
                    // elements: mul
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 409:17: -> ^( UMINUS mul )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:409:20: ^( UMINUS mul )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(UMINUS, "UMINUS")
                        , root_1);

                        adaptor.addChild(root_1, stream_mul.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:410:7: PLUS mul
                    {
                    PLUS260=(Token)match(input,PLUS,FOLLOW_PLUS_in_expr2392);  
                    stream_PLUS.add(PLUS260);


                    pushFollow(FOLLOW_mul_in_expr2394);
                    mul261=mul();

                    state._fsp--;

                    stream_mul.add(mul261.getTree());

                    // AST REWRITE
                    // elements: mul
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 410:16: -> mul
                    {
                        adaptor.addChild(root_0, stream_mul.nextTree());

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "expr"


    public static class mul_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "mul"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:413:1: mul : atom ( muloper ^ atom )* ;
    public final GqlExtParser.mul_return mul() throws RecognitionException {
        GqlExtParser.mul_return retval = new GqlExtParser.mul_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        GqlExtParser.atom_return atom262 =null;

        GqlExtParser.muloper_return muloper263 =null;

        GqlExtParser.atom_return atom264 =null;



        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:413:4: ( atom ( muloper ^ atom )* )
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:414:5: atom ( muloper ^ atom )*
            {
            root_0 = (Object)adaptor.nil();


            pushFollow(FOLLOW_atom_in_mul2410);
            atom262=atom();

            state._fsp--;

            adaptor.addChild(root_0, atom262.getTree());

            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:414:10: ( muloper ^ atom )*
            loop59:
            do {
                int alt59=2;
                int LA59_0 = input.LA(1);

                if ( (LA59_0==ASTERISK||LA59_0==SLASH) ) {
                    alt59=1;
                }


                switch (alt59) {
            	case 1 :
            	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:414:11: muloper ^ atom
            	    {
            	    pushFollow(FOLLOW_muloper_in_mul2413);
            	    muloper263=muloper();

            	    state._fsp--;

            	    root_0 = (Object)adaptor.becomeRoot(muloper263.getTree(), root_0);

            	    pushFollow(FOLLOW_atom_in_mul2416);
            	    atom264=atom();

            	    state._fsp--;

            	    adaptor.addChild(root_0, atom264.getTree());

            	    }
            	    break;

            	default :
            	    break loop59;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "mul"


    public static class muloper_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "muloper"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:417:1: muloper : ( ASTERISK -> MUL | SLASH -> DIV );
    public final GqlExtParser.muloper_return muloper() throws RecognitionException {
        GqlExtParser.muloper_return retval = new GqlExtParser.muloper_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token ASTERISK265=null;
        Token SLASH266=null;

        Object ASTERISK265_tree=null;
        Object SLASH266_tree=null;
        RewriteRuleTokenStream stream_SLASH=new RewriteRuleTokenStream(adaptor,"token SLASH");
        RewriteRuleTokenStream stream_ASTERISK=new RewriteRuleTokenStream(adaptor,"token ASTERISK");

        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:417:8: ( ASTERISK -> MUL | SLASH -> DIV )
            int alt60=2;
            int LA60_0 = input.LA(1);

            if ( (LA60_0==ASTERISK) ) {
                alt60=1;
            }
            else if ( (LA60_0==SLASH) ) {
                alt60=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 60, 0, input);

                throw nvae;

            }
            switch (alt60) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:418:5: ASTERISK
                    {
                    ASTERISK265=(Token)match(input,ASTERISK,FOLLOW_ASTERISK_in_muloper2430);  
                    stream_ASTERISK.add(ASTERISK265);


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 418:14: -> MUL
                    {
                        adaptor.addChild(root_0, 
                        (Object)adaptor.create(MUL, "MUL")
                        );

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:419:7: SLASH
                    {
                    SLASH266=(Token)match(input,SLASH,FOLLOW_SLASH_in_muloper2442);  
                    stream_SLASH.add(SLASH266);


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 419:13: -> DIV
                    {
                        adaptor.addChild(root_0, 
                        (Object)adaptor.create(DIV, "DIV")
                        );

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "muloper"


    public static class atom_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "atom"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:422:1: atom : ( valorvarobj | prop | LEFT_PAR exprlist RIGHT_PAR -> exprlist | ID LEFT_PAR RIGHT_PAR -> ^( FUNC ID ) | ID LEFT_PAR e+= expr ( COMMA e+= expr )* RIGHT_PAR -> ^( FUNC ID ( expr )+ ) );
    public final GqlExtParser.atom_return atom() throws RecognitionException {
        GqlExtParser.atom_return retval = new GqlExtParser.atom_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token LEFT_PAR269=null;
        Token RIGHT_PAR271=null;
        Token ID272=null;
        Token LEFT_PAR273=null;
        Token RIGHT_PAR274=null;
        Token ID275=null;
        Token LEFT_PAR276=null;
        Token COMMA277=null;
        Token RIGHT_PAR278=null;
        List list_e=null;
        GqlExtParser.valorvarobj_return valorvarobj267 =null;

        GqlExtParser.prop_return prop268 =null;

        GqlExtParser.exprlist_return exprlist270 =null;

        RuleReturnScope e = null;
        Object LEFT_PAR269_tree=null;
        Object RIGHT_PAR271_tree=null;
        Object ID272_tree=null;
        Object LEFT_PAR273_tree=null;
        Object RIGHT_PAR274_tree=null;
        Object ID275_tree=null;
        Object LEFT_PAR276_tree=null;
        Object COMMA277_tree=null;
        Object RIGHT_PAR278_tree=null;
        RewriteRuleTokenStream stream_LEFT_PAR=new RewriteRuleTokenStream(adaptor,"token LEFT_PAR");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_RIGHT_PAR=new RewriteRuleTokenStream(adaptor,"token RIGHT_PAR");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        RewriteRuleSubtreeStream stream_exprlist=new RewriteRuleSubtreeStream(adaptor,"rule exprlist");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:422:5: ( valorvarobj | prop | LEFT_PAR exprlist RIGHT_PAR -> exprlist | ID LEFT_PAR RIGHT_PAR -> ^( FUNC ID ) | ID LEFT_PAR e+= expr ( COMMA e+= expr )* RIGHT_PAR -> ^( FUNC ID ( expr )+ ) )
            int alt62=5;
            switch ( input.LA(1) ) {
            case DATE:
            case DATETIME:
            case FALSE:
            case FLOAT:
            case GEOPT:
            case INT:
            case KEY:
            case NULL:
            case STRING:
            case TIME:
            case TRUE:
            case USER:
            case VARID:
                {
                alt62=1;
                }
                break;
            case ID:
                {
                int LA62_2 = input.LA(2);

                if ( (LA62_2==LEFT_PAR) ) {
                    int LA62_5 = input.LA(3);

                    if ( (LA62_5==RIGHT_PAR) ) {
                        alt62=4;
                    }
                    else if ( ((LA62_5 >= DATE && LA62_5 <= DATETIME)||(LA62_5 >= FALSE && LA62_5 <= FLOAT)||LA62_5==GEOPT||LA62_5==ID||LA62_5==INT||(LA62_5 >= KEY && LA62_5 <= KEYPROP)||LA62_5==LEFT_PAR||LA62_5==MINUS||LA62_5==NULL||(LA62_5 >= PLUS && LA62_5 <= PROP)||LA62_5==STRING||(LA62_5 >= TIME && LA62_5 <= TRUE)||LA62_5==USER||LA62_5==VARID) ) {
                        alt62=5;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 62, 5, input);

                        throw nvae;

                    }
                }
                else if ( (LA62_2==EOF||(LA62_2 >= AND && LA62_2 <= AS)||LA62_2==ASTERISK||LA62_2==COMMA||LA62_2==DOT||(LA62_2 >= EMPTY && LA62_2 <= EQ)||(LA62_2 >= ID && LA62_2 <= IN)||LA62_2==KEYPROP||LA62_2==LIMIT||LA62_2==MINUS||(LA62_2 >= OFFSET && LA62_2 <= ORDER)||(LA62_2 >= PLUS && LA62_2 <= PROP)||LA62_2==RIGHT_PAR||LA62_2==SLASH||LA62_2==STRING||LA62_2==UNINDEXED||LA62_2==WHERE) ) {
                    alt62=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 62, 2, input);

                    throw nvae;

                }
                }
                break;
            case KEYPROP:
            case PROP:
                {
                alt62=2;
                }
                break;
            case LEFT_PAR:
                {
                alt62=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 62, 0, input);

                throw nvae;

            }

            switch (alt62) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:423:5: valorvarobj
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_valorvarobj_in_atom2458);
                    valorvarobj267=valorvarobj();

                    state._fsp--;

                    adaptor.addChild(root_0, valorvarobj267.getTree());

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:424:7: prop
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_prop_in_atom2466);
                    prop268=prop();

                    state._fsp--;

                    adaptor.addChild(root_0, prop268.getTree());


                            if (!((Expr_scope)Expr_stack.peek()).hasEntity) throw new RuntimeException("Inproper use of property/key names");
                        

                    }
                    break;
                case 3 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:427:7: LEFT_PAR exprlist RIGHT_PAR
                    {
                    LEFT_PAR269=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_atom2476);  
                    stream_LEFT_PAR.add(LEFT_PAR269);


                    pushFollow(FOLLOW_exprlist_in_atom2478);
                    exprlist270=exprlist();

                    state._fsp--;

                    stream_exprlist.add(exprlist270.getTree());

                    RIGHT_PAR271=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_atom2480);  
                    stream_RIGHT_PAR.add(RIGHT_PAR271);


                    // AST REWRITE
                    // elements: exprlist
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 427:35: -> exprlist
                    {
                        adaptor.addChild(root_0, stream_exprlist.nextTree());

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 4 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:428:7: ID LEFT_PAR RIGHT_PAR
                    {
                    ID272=(Token)match(input,ID,FOLLOW_ID_in_atom2492);  
                    stream_ID.add(ID272);


                    LEFT_PAR273=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_atom2494);  
                    stream_LEFT_PAR.add(LEFT_PAR273);


                    RIGHT_PAR274=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_atom2496);  
                    stream_RIGHT_PAR.add(RIGHT_PAR274);


                    // AST REWRITE
                    // elements: ID
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 428:29: -> ^( FUNC ID )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:428:32: ^( FUNC ID )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(FUNC, "FUNC")
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_ID.nextNode()
                        );

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 5 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:429:7: ID LEFT_PAR e+= expr ( COMMA e+= expr )* RIGHT_PAR
                    {
                    ID275=(Token)match(input,ID,FOLLOW_ID_in_atom2512);  
                    stream_ID.add(ID275);


                    LEFT_PAR276=(Token)match(input,LEFT_PAR,FOLLOW_LEFT_PAR_in_atom2514);  
                    stream_LEFT_PAR.add(LEFT_PAR276);


                    pushFollow(FOLLOW_expr_in_atom2518);
                    e=expr();

                    state._fsp--;

                    stream_expr.add(e.getTree());
                    if (list_e==null) list_e=new ArrayList();
                    list_e.add(e.getTree());


                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:429:27: ( COMMA e+= expr )*
                    loop61:
                    do {
                        int alt61=2;
                        int LA61_0 = input.LA(1);

                        if ( (LA61_0==COMMA) ) {
                            alt61=1;
                        }


                        switch (alt61) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:429:28: COMMA e+= expr
                    	    {
                    	    COMMA277=(Token)match(input,COMMA,FOLLOW_COMMA_in_atom2521);  
                    	    stream_COMMA.add(COMMA277);


                    	    pushFollow(FOLLOW_expr_in_atom2525);
                    	    e=expr();

                    	    state._fsp--;

                    	    stream_expr.add(e.getTree());
                    	    if (list_e==null) list_e=new ArrayList();
                    	    list_e.add(e.getTree());


                    	    }
                    	    break;

                    	default :
                    	    break loop61;
                        }
                    } while (true);


                    RIGHT_PAR278=(Token)match(input,RIGHT_PAR,FOLLOW_RIGHT_PAR_in_atom2529);  
                    stream_RIGHT_PAR.add(RIGHT_PAR278);


                    // AST REWRITE
                    // elements: expr, ID
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 429:54: -> ^( FUNC ID ( expr )+ )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:429:57: ^( FUNC ID ( expr )+ )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(FUNC, "FUNC")
                        , root_1);

                        adaptor.addChild(root_1, 
                        stream_ID.nextNode()
                        );

                        if ( !(stream_expr.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_expr.hasNext() ) {
                            adaptor.addChild(root_1, stream_expr.nextTree());

                        }
                        stream_expr.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "atom"


    public static class exprlist_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };


    // $ANTLR start "exprlist"
    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:432:1: exprlist : ( expr ( COMMA expr )* -> ^( LIST ( expr )* ) | gql_select );
    public final GqlExtParser.exprlist_return exprlist() throws RecognitionException {
        GqlExtParser.exprlist_return retval = new GqlExtParser.exprlist_return();
        retval.start = input.LT(1);


        Object root_0 = null;

        Token COMMA280=null;
        GqlExtParser.expr_return expr279 =null;

        GqlExtParser.expr_return expr281 =null;

        GqlExtParser.gql_select_return gql_select282 =null;


        Object COMMA280_tree=null;
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:432:9: ( expr ( COMMA expr )* -> ^( LIST ( expr )* ) | gql_select )
            int alt64=2;
            int LA64_0 = input.LA(1);

            if ( ((LA64_0 >= DATE && LA64_0 <= DATETIME)||(LA64_0 >= FALSE && LA64_0 <= FLOAT)||LA64_0==GEOPT||LA64_0==ID||LA64_0==INT||(LA64_0 >= KEY && LA64_0 <= KEYPROP)||LA64_0==LEFT_PAR||LA64_0==MINUS||LA64_0==NULL||(LA64_0 >= PLUS && LA64_0 <= PROP)||LA64_0==STRING||(LA64_0 >= TIME && LA64_0 <= TRUE)||LA64_0==USER||LA64_0==VARID) ) {
                alt64=1;
            }
            else if ( (LA64_0==SELECT) ) {
                alt64=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 64, 0, input);

                throw nvae;

            }
            switch (alt64) {
                case 1 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:433:5: expr ( COMMA expr )*
                    {
                    pushFollow(FOLLOW_expr_in_exprlist2552);
                    expr279=expr();

                    state._fsp--;

                    stream_expr.add(expr279.getTree());

                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:433:10: ( COMMA expr )*
                    loop63:
                    do {
                        int alt63=2;
                        int LA63_0 = input.LA(1);

                        if ( (LA63_0==COMMA) ) {
                            alt63=1;
                        }


                        switch (alt63) {
                    	case 1 :
                    	    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:433:11: COMMA expr
                    	    {
                    	    COMMA280=(Token)match(input,COMMA,FOLLOW_COMMA_in_exprlist2555);  
                    	    stream_COMMA.add(COMMA280);


                    	    pushFollow(FOLLOW_expr_in_exprlist2557);
                    	    expr281=expr();

                    	    state._fsp--;

                    	    stream_expr.add(expr281.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop63;
                        }
                    } while (true);


                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (Object)adaptor.nil();
                    // 433:24: -> ^( LIST ( expr )* )
                    {
                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:433:27: ^( LIST ( expr )* )
                        {
                        Object root_1 = (Object)adaptor.nil();
                        root_1 = (Object)adaptor.becomeRoot(
                        (Object)adaptor.create(LIST, "LIST")
                        , root_1);

                        // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:433:34: ( expr )*
                        while ( stream_expr.hasNext() ) {
                            adaptor.addChild(root_1, stream_expr.nextTree());

                        }
                        stream_expr.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }


                    retval.tree = root_0;

                    }
                    break;
                case 2 :
                    // /Users/vaclav/work/gaudao/modules/parser/src/grammar/GqlExtParser.g:434:7: gql_select
                    {
                    root_0 = (Object)adaptor.nil();


                    pushFollow(FOLLOW_gql_select_in_exprlist2576);
                    gql_select282=gql_select();

                    state._fsp--;

                    adaptor.addChild(root_0, gql_select282.getTree());


                            if (!((Expr_scope)Expr_stack.peek()).isNestedQueryAllowed) throw new RuntimeException("Nested query is not allowed here");
                        

                    }
                    break;

            }
            retval.stop = input.LT(-1);


            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }

        finally {
        	// do for sure before leaving
        }
        return retval;
    }
    // $ANTLR end "exprlist"

    // Delegated rules


    protected DFA17 dfa17 = new DFA17(this);
    protected DFA28 dfa28 = new DFA28(this);
    protected DFA30 dfa30 = new DFA30(this);
    protected DFA43 dfa43 = new DFA43(this);
    static final String DFA17_eotS =
        "\14\uffff";
    static final String DFA17_eofS =
        "\14\uffff";
    static final String DFA17_minS =
        "\1\11\1\uffff\1\7\1\56\1\7\1\uffff\1\42\1\uffff\1\105\1\7\1\77\1"+
        "\7";
    static final String DFA17_maxS =
        "\1\120\1\uffff\1\113\1\56\1\113\1\uffff\1\42\1\uffff\1\105\1\113"+
        "\1\77\1\113";
    static final String DFA17_acceptS =
        "\1\uffff\1\1\3\uffff\1\3\1\uffff\1\2\4\uffff";
    static final String DFA17_specialS =
        "\14\uffff}>";
    static final String[] DFA17_transitionS = {
            "\1\1\5\uffff\2\5\11\uffff\2\5\2\uffff\1\5\3\uffff\1\2\2\uffff"+
            "\1\5\4\uffff\1\5\1\4\2\uffff\1\5\2\uffff\1\5\2\uffff\1\5\6\uffff"+
            "\1\5\1\3\10\uffff\1\5\1\uffff\2\5\4\uffff\1\5\2\uffff\1\5",
            "",
            "\1\5\1\uffff\1\5\3\uffff\1\7\5\uffff\1\6\2\uffff\1\5\5\uffff"+
            "\1\7\5\uffff\1\5\10\uffff\1\5\2\uffff\1\5\2\uffff\1\5\11\uffff"+
            "\2\5\6\uffff\1\5\1\uffff\1\5\5\uffff\1\5",
            "\1\10",
            "\1\5\1\uffff\1\5\3\uffff\1\7\10\uffff\1\5\5\uffff\1\7\5\uffff"+
            "\1\5\10\uffff\1\5\5\uffff\1\5\11\uffff\2\5\6\uffff\1\5\1\uffff"+
            "\1\5\5\uffff\1\5",
            "",
            "\1\11",
            "",
            "\1\12",
            "\1\5\1\uffff\1\5\3\uffff\1\7\5\uffff\1\6\2\uffff\1\5\5\uffff"+
            "\1\7\5\uffff\1\5\10\uffff\1\5\5\uffff\1\5\11\uffff\2\5\6\uffff"+
            "\1\5\1\uffff\1\5\5\uffff\1\5",
            "\1\13",
            "\1\5\1\uffff\1\5\3\uffff\1\7\10\uffff\1\5\5\uffff\1\7\5\uffff"+
            "\1\5\10\uffff\1\5\5\uffff\1\5\11\uffff\2\5\6\uffff\1\5\1\uffff"+
            "\1\5\5\uffff\1\5"
    };

    static final short[] DFA17_eot = DFA.unpackEncodedString(DFA17_eotS);
    static final short[] DFA17_eof = DFA.unpackEncodedString(DFA17_eofS);
    static final char[] DFA17_min = DFA.unpackEncodedStringToUnsignedChars(DFA17_minS);
    static final char[] DFA17_max = DFA.unpackEncodedStringToUnsignedChars(DFA17_maxS);
    static final short[] DFA17_accept = DFA.unpackEncodedString(DFA17_acceptS);
    static final short[] DFA17_special = DFA.unpackEncodedString(DFA17_specialS);
    static final short[][] DFA17_transition;

    static {
        int numStates = DFA17_transitionS.length;
        DFA17_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA17_transition[i] = DFA.unpackEncodedString(DFA17_transitionS[i]);
        }
    }

    class DFA17 extends DFA {

        public DFA17(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 17;
            this.eot = DFA17_eot;
            this.eof = DFA17_eof;
            this.min = DFA17_min;
            this.max = DFA17_max;
            this.accept = DFA17_accept;
            this.special = DFA17_special;
            this.transition = DFA17_transition;
        }
        public String getDescription() {
            return "177:1: get_property : ( ASTERISK | prop | get_property_expr );";
        }
    }
    static final String DFA28_eotS =
        "\16\uffff";
    static final String DFA28_eofS =
        "\16\uffff";
    static final String DFA28_minS =
        "\1\5\1\23\1\56\1\27\1\uffff\1\42\2\uffff\1\105\2\uffff\1\23\1\77"+
        "\1\27";
    static final String DFA28_maxS =
        "\1\74\1\67\1\56\1\67\1\uffff\1\42\2\uffff\1\105\2\uffff\1\67\1\77"+
        "\1\67";
    static final String DFA28_acceptS =
        "\4\uffff\1\3\1\uffff\1\1\1\4\1\uffff\1\5\1\2\3\uffff";
    static final String DFA28_specialS =
        "\16\uffff}>";
    static final String[] DFA28_transitionS = {
            "\1\4\34\uffff\1\1\10\uffff\1\3\20\uffff\1\2",
            "\1\5\3\uffff\1\6\13\uffff\1\7\23\uffff\1\6",
            "\1\10",
            "\1\12\13\uffff\1\11\23\uffff\1\12",
            "",
            "\1\13",
            "",
            "",
            "\1\14",
            "",
            "",
            "\1\5\3\uffff\1\6\13\uffff\1\7\23\uffff\1\6",
            "\1\15",
            "\1\6\13\uffff\1\7\23\uffff\1\6"
    };

    static final short[] DFA28_eot = DFA.unpackEncodedString(DFA28_eotS);
    static final short[] DFA28_eof = DFA.unpackEncodedString(DFA28_eofS);
    static final char[] DFA28_min = DFA.unpackEncodedStringToUnsignedChars(DFA28_minS);
    static final char[] DFA28_max = DFA.unpackEncodedStringToUnsignedChars(DFA28_maxS);
    static final short[] DFA28_accept = DFA.unpackEncodedString(DFA28_acceptS);
    static final short[] DFA28_special = DFA.unpackEncodedString(DFA28_specialS);
    static final short[][] DFA28_transition;

    static {
        int numStates = DFA28_transitionS.length;
        DFA28_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA28_transition[i] = DFA.unpackEncodedString(DFA28_transitionS[i]);
        }
    }

    class DFA28 extends DFA {

        public DFA28(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 28;
            this.eot = DFA28_eot;
            this.eof = DFA28_eof;
            this.min = DFA28_min;
            this.max = DFA28_max;
            this.accept = DFA28_accept;
            this.special = DFA28_special;
            this.transition = DFA28_transition;
        }
        public String getDescription() {
            return "248:1: condition : ( cond | condkey | condancestor | condin | condkeyin );";
        }
    }
    static final String DFA30_eotS =
        "\15\uffff";
    static final String DFA30_eofS =
        "\15\uffff";
    static final String DFA30_minS =
        "\1\42\1\23\1\56\1\42\1\56\1\105\1\23\1\17\1\uffff\1\77\2\uffff\1"+
        "\43";
    static final String DFA30_maxS =
        "\1\74\1\43\1\56\1\42\1\120\1\105\1\43\1\120\1\uffff\1\77\2\uffff"+
        "\1\43";
    static final String DFA30_acceptS =
        "\10\uffff\1\2\1\uffff\1\1\1\3\1\uffff";
    static final String DFA30_specialS =
        "\15\uffff}>";
    static final String[] DFA30_transitionS = {
            "\1\1\31\uffff\1\2",
            "\1\3\17\uffff\1\4",
            "\1\5",
            "\1\6",
            "\1\7\41\uffff\1\10",
            "\1\11",
            "\1\3\17\uffff\1\4",
            "\2\12\11\uffff\2\12\2\uffff\1\12\6\uffff\1\12\4\uffff\1\12"+
            "\11\uffff\1\12\14\uffff\1\13\3\uffff\1\12\1\uffff\2\12\4\uffff"+
            "\1\12\2\uffff\1\12",
            "",
            "\1\14",
            "",
            "",
            "\1\4"
    };

    static final short[] DFA30_eot = DFA.unpackEncodedString(DFA30_eotS);
    static final short[] DFA30_eof = DFA.unpackEncodedString(DFA30_eofS);
    static final char[] DFA30_min = DFA.unpackEncodedStringToUnsignedChars(DFA30_minS);
    static final char[] DFA30_max = DFA.unpackEncodedStringToUnsignedChars(DFA30_maxS);
    static final short[] DFA30_accept = DFA.unpackEncodedString(DFA30_acceptS);
    static final short[] DFA30_special = DFA.unpackEncodedString(DFA30_specialS);
    static final short[][] DFA30_transition;

    static {
        int numStates = DFA30_transitionS.length;
        DFA30_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA30_transition[i] = DFA.unpackEncodedString(DFA30_transitionS[i]);
        }
    }

    class DFA30 extends DFA {

        public DFA30(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 30;
            this.eot = DFA30_eot;
            this.eof = DFA30_eof;
            this.min = DFA30_min;
            this.max = DFA30_max;
            this.accept = DFA30_accept;
            this.special = DFA30_special;
            this.transition = DFA30_transition;
        }
        public String getDescription() {
            return "266:1: condin : ( property IN LEFT_PAR listitem ( COMMA listitem )* RIGHT_PAR -> ^( IN property ^( LIST ( listitem )+ ) ) | property IN var -> ^( IN property var ) | property IN LEFT_PAR gql_select RIGHT_PAR -> ^( IN property gql_select ) );";
        }
    }
    static final String DFA43_eotS =
        "\14\uffff";
    static final String DFA43_eofS =
        "\1\uffff\1\5\1\uffff\1\5\5\uffff\1\5\1\uffff\1\5";
    static final String DFA43_minS =
        "\1\42\1\10\1\56\1\10\1\42\3\uffff\1\105\1\10\1\77\1\10";
    static final String DFA43_maxS =
        "\1\74\1\104\1\56\1\104\1\42\3\uffff\1\105\1\104\1\77\1\104";
    static final String DFA43_acceptS =
        "\5\uffff\1\1\1\2\1\3\4\uffff";
    static final String DFA43_specialS =
        "\14\uffff}>";
    static final String[] DFA43_transitionS = {
            "\1\1\10\uffff\1\3\20\uffff\1\2",
            "\1\6\4\uffff\1\5\4\uffff\1\7\1\4\33\uffff\1\5\6\uffff\1\5\10"+
            "\uffff\1\5\4\uffff\1\5",
            "\1\10",
            "\1\6\4\uffff\1\5\4\uffff\1\7\34\uffff\1\5\6\uffff\1\5\10\uffff"+
            "\1\5\4\uffff\1\5",
            "\1\11",
            "",
            "",
            "",
            "\1\12",
            "\1\6\4\uffff\1\5\4\uffff\1\7\1\4\33\uffff\1\5\6\uffff\1\5\10"+
            "\uffff\1\5\4\uffff\1\5",
            "\1\13",
            "\1\6\4\uffff\1\5\4\uffff\1\7\34\uffff\1\5\6\uffff\1\5\10\uffff"+
            "\1\5\4\uffff\1\5"
    };

    static final short[] DFA43_eot = DFA.unpackEncodedString(DFA43_eotS);
    static final short[] DFA43_eof = DFA.unpackEncodedString(DFA43_eofS);
    static final char[] DFA43_min = DFA.unpackEncodedStringToUnsignedChars(DFA43_minS);
    static final char[] DFA43_max = DFA.unpackEncodedStringToUnsignedChars(DFA43_maxS);
    static final short[] DFA43_accept = DFA.unpackEncodedString(DFA43_acceptS);
    static final short[] DFA43_special = DFA.unpackEncodedString(DFA43_specialS);
    static final short[][] DFA43_transition;

    static {
        int numStates = DFA43_transitionS.length;
        DFA43_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA43_transition[i] = DFA.unpackEncodedString(DFA43_transitionS[i]);
        }
    }

    class DFA43 extends DFA {

        public DFA43(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 43;
            this.eot = DFA43_eot;
            this.eof = DFA43_eof;
            this.min = DFA43_min;
            this.max = DFA43_max;
            this.accept = DFA43_accept;
            this.special = DFA43_special;
            this.transition = DFA43_transition;
        }
        public String getDescription() {
            return "326:1: orderbyitem : ( prop -> ^( ASC prop ) | prop ASC -> ^( ASC prop ) | prop DESC -> ^( DESC prop ) );";
        }
    }
 

    public static final BitSet FOLLOW_gql_select_in_gqlext135 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_insert_in_gqlext139 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_update_in_gqlext143 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_gql_delete_in_gqlext147 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SELECT_in_gql_select173 = new BitSet(new long[]{0x18124C244C018200L,0x00000000000121A0L});
    public static final BitSet FOLLOW_get_properties_in_gql_select175 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_FROM_in_gql_select177 = new BitSet(new long[]{0x0000500400100000L});
    public static final BitSet FOLLOW_kindorquery_in_gql_select179 = new BitSet(new long[]{0x0240800000000002L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_select181 = new BitSet(new long[]{0x0240800000000002L});
    public static final BitSet FOLLOW_orderby_in_gql_select184 = new BitSet(new long[]{0x0040800000000002L});
    public static final BitSet FOLLOW_limit_in_gql_select187 = new BitSet(new long[]{0x0040000000000002L});
    public static final BitSet FOLLOW_offset_in_gql_select190 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INSERT_in_gql_insert245 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_INTO_in_gql_insert247 = new BitSet(new long[]{0x0000100400000000L});
    public static final BitSet FOLLOW_kind_in_gql_insert249 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_columns_in_gql_insert251 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L});
    public static final BitSet FOLLOW_values_in_gql_insert253 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UPDATE_in_gql_update283 = new BitSet(new long[]{0x0000100400000000L});
    public static final BitSet FOLLOW_kind_in_gql_update285 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_set_properties_in_gql_update287 = new BitSet(new long[]{0x0240800000000002L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_update289 = new BitSet(new long[]{0x0240800000000002L});
    public static final BitSet FOLLOW_orderby_in_gql_update292 = new BitSet(new long[]{0x0040800000000002L});
    public static final BitSet FOLLOW_limit_in_gql_update295 = new BitSet(new long[]{0x0040000000000002L});
    public static final BitSet FOLLOW_offset_in_gql_update298 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DELETE_in_gql_delete339 = new BitSet(new long[]{0x0000100410000000L});
    public static final BitSet FOLLOW_FROM_in_gql_delete341 = new BitSet(new long[]{0x0000100400000000L});
    public static final BitSet FOLLOW_kind_in_gql_delete344 = new BitSet(new long[]{0x0240800000000002L,0x0000000000080000L});
    public static final BitSet FOLLOW_where_in_gql_delete346 = new BitSet(new long[]{0x0240800000000002L});
    public static final BitSet FOLLOW_orderby_in_gql_delete349 = new BitSet(new long[]{0x0040800000000002L});
    public static final BitSet FOLLOW_limit_in_gql_delete352 = new BitSet(new long[]{0x0040000000000002L});
    public static final BitSet FOLLOW_offset_in_gql_delete355 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_kind_in_kindorquery394 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DUAL_in_kindorquery406 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAR_in_kindorquery418 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_gql_select_in_kindorquery420 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_kindorquery422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_get_property_in_get_properties463 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_COMMA_in_get_properties466 = new BitSet(new long[]{0x18124C244C018200L,0x00000000000121A0L});
    public static final BitSet FOLLOW_get_property_in_get_properties468 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_ASTERISK_in_get_property491 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prop_in_get_property495 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_get_property_expr_in_get_property499 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_get_property_expr510 = new BitSet(new long[]{0x1000080400400080L,0x0000000000000820L});
    public static final BitSet FOLLOW_AS_in_get_property_expr512 = new BitSet(new long[]{0x1000080400400000L,0x0000000000000820L});
    public static final BitSet FOLLOW_alias_in_get_property_expr515 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_alias533 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_aliasnokey_in_alias537 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_aliasnokey548 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_aliasnokey557 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNINDEXED_in_aliasnokey566 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_aliasnokey568 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_aliasnokey570 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_aliasnokey572 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EMPTY_in_aliasnokey590 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_aliasnokey592 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_aliasnokey594 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_aliasnokey596 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAR_in_columns617 = new BitSet(new long[]{0x1000080400400000L,0x0000000000000820L});
    public static final BitSet FOLLOW_column_in_columns619 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_columns622 = new BitSet(new long[]{0x1000080400400000L,0x0000000000000820L});
    public static final BitSet FOLLOW_column_in_columns624 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_columns628 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_alias_in_column653 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VALUES_in_values690 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_values692 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_value_in_values694 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_values697 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_value_in_values699 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_values703 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_value728 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SET_in_set_properties765 = new BitSet(new long[]{0x1000000400400000L,0x0000000000000820L});
    public static final BitSet FOLLOW_set_property_in_set_properties767 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_COMMA_in_set_properties770 = new BitSet(new long[]{0x1000000400400000L,0x0000000000000820L});
    public static final BitSet FOLLOW_set_property_in_set_properties772 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_aliasnokey_in_set_property799 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_EQ_in_set_property801 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_expr_in_set_property803 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHERE_in_where829 = new BitSet(new long[]{0x1000080400000020L});
    public static final BitSet FOLLOW_condition_in_where831 = new BitSet(new long[]{0x0000000000000042L,0x0000000000000010L});
    public static final BitSet FOLLOW_AND_in_where834 = new BitSet(new long[]{0x1000080400000020L});
    public static final BitSet FOLLOW_condition_in_where836 = new BitSet(new long[]{0x0000000000000042L,0x0000000000000010L});
    public static final BitSet FOLLOW_softwhere_in_where840 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHERE_in_where861 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_softwhere_in_where863 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SOFT_in_softwhere906 = new BitSet(new long[]{0x181A4C244C018020L,0x00000000000121A0L});
    public static final BitSet FOLLOW_softcondmul_in_softwhere908 = new BitSet(new long[]{0x0100000000000002L});
    public static final BitSet FOLLOW_OR_in_softwhere911 = new BitSet(new long[]{0x181A4C244C018020L,0x00000000000121A0L});
    public static final BitSet FOLLOW_softcondmul_in_softwhere914 = new BitSet(new long[]{0x0100000000000002L});
    public static final BitSet FOLLOW_cond_in_condition924 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condkey_in_condition928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condancestor_in_condition932 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condin_in_condition936 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condkeyin_in_condition940 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_cond952 = new BitSet(new long[]{0x0080000000800000L});
    public static final BitSet FOLLOW_oper_in_cond954 = new BitSet(new long[]{0x001004204C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_valorvarobj_in_cond956 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_condkey982 = new BitSet(new long[]{0x0080000000800000L});
    public static final BitSet FOLLOW_oper_in_condkey984 = new BitSet(new long[]{0x0000040000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_key_in_condkey986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTOR_in_condancestor1012 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_IS_in_condancestor1014 = new BitSet(new long[]{0x0000040000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_key_in_condancestor1016 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_condin1040 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_IN_in_condin1042 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_condin1044 = new BitSet(new long[]{0x001004204C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_listitem_in_condin1046 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_condin1049 = new BitSet(new long[]{0x001004204C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_listitem_in_condin1051 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_condin1055 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_condin1078 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_IN_in_condin1080 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_var_in_condin1082 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_condin1100 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_IN_in_condin1102 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_condin1104 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_gql_select_in_condin1106 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_condin1108 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_condkeyin1130 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_IN_in_condkeyin1132 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_condkeyin1134 = new BitSet(new long[]{0x0000040000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_key_in_condkeyin1136 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_condkeyin1139 = new BitSet(new long[]{0x0000040000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_key_in_condkeyin1141 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_condkeyin1145 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_condkeyin1168 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_IN_in_condkeyin1170 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_var_in_condkeyin1172 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_condkeyin1190 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_IN_in_condkeyin1192 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_condkeyin1194 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_gql_select_in_condkeyin1196 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_condkeyin1198 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_softcondat_in_softcondmul1220 = new BitSet(new long[]{0x0000000000000042L});
    public static final BitSet FOLLOW_AND_in_softcondmul1223 = new BitSet(new long[]{0x181A4C244C018020L,0x00000000000121A0L});
    public static final BitSet FOLLOW_softcondat_in_softcondmul1226 = new BitSet(new long[]{0x0000000000000042L});
    public static final BitSet FOLLOW_NOT_in_softcondat1263 = new BitSet(new long[]{0x181A4C244C018020L,0x00000000000121A0L});
    public static final BitSet FOLLOW_softcondat_in_softcondat1265 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTOR_in_softcondat1281 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_IS_in_softcondat1283 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_expr_in_softcondat1285 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_softcondat1301 = new BitSet(new long[]{0x0080000800800000L});
    public static final BitSet FOLLOW_operin_in_softcondat1303 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_expr_in_softcondat1305 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPER_in_operin1333 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EQ_in_operin1337 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IN_in_operin1341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_valorvarobj_in_listitem1351 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_key1360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_key1378 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_keyfunc_in_key1395 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEY_in_keyfunc1407 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_keyfunc1409 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_stringorvar_in_keyfunc1411 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_keyfunc1413 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEY_in_keyfunc1429 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_keyfunc1431 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_keypath_in_keyfunc1433 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_keyfunc1435 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_keypath1457 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_keypath1459 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_intstringorvar_in_keypath1461 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_COMMA_in_keypath1464 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_keypath_in_keypath1466 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDER_in_orderby1498 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_BY_in_orderby1500 = new BitSet(new long[]{0x1000080400000000L});
    public static final BitSet FOLLOW_orderbyitem_in_orderby1502 = new BitSet(new long[]{0x0000000000002002L,0x0000000000000010L});
    public static final BitSet FOLLOW_COMMA_in_orderby1505 = new BitSet(new long[]{0x1000080400000000L});
    public static final BitSet FOLLOW_orderbyitem_in_orderby1507 = new BitSet(new long[]{0x0000000000002002L,0x0000000000000010L});
    public static final BitSet FOLLOW_softorderby_in_orderby1511 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDER_in_orderby1532 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_BY_in_orderby1534 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_softorderby_in_orderby1536 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SOFT_in_softorderby1556 = new BitSet(new long[]{0x1000080400000000L});
    public static final BitSet FOLLOW_orderbyitem_in_softorderby1558 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_COMMA_in_softorderby1561 = new BitSet(new long[]{0x1000080400000000L});
    public static final BitSet FOLLOW_orderbyitem_in_softorderby1563 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_prop_in_orderbyitem1590 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prop_in_orderbyitem1606 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_ASC_in_orderbyitem1608 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prop_in_orderbyitem1624 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_DESC_in_orderbyitem1626 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LIMIT_in_limit1646 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_limit1650 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_limit1652 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_limit1656 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LIMIT_in_limit1680 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_limit1684 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OFFSET_in_offset1705 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_INT_in_offset1707 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_valorvarobj1731 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_valorvarobj1739 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_valorvarobj1747 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_valorvarobj1755 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_valorvarobj1763 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NULL_in_valorvarobj1771 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_valorvarobj1779 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_datetime_in_valorvarobj1787 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_keyfunc_in_valorvarobj1795 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_geopt_in_valorvarobj1803 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_user_in_valorvarobj1811 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATE_in_datetime1828 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_datetime1830 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_datetime1834 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_datetime1836 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATETIME_in_datetime1853 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_datetime1855 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_datetime1859 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_datetime1861 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TIME_in_datetime1878 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_datetime1880 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_datetime1884 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_datetime1886 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATE_in_datetime1903 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_datetime1905 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1909 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1911 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1915 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1917 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1921 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_datetime1923 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATETIME_in_datetime1954 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_datetime1956 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1960 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1962 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1966 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1968 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1972 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1974 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1978 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1980 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1984 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime1986 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime1990 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_datetime1992 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TIME_in_datetime2032 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_datetime2034 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime2038 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime2040 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime2044 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_datetime2046 = new BitSet(new long[]{0x0000002000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_intorvar_in_datetime2050 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_datetime2052 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_GEOPT_in_geopt2087 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_geopt2089 = new BitSet(new long[]{0x0000002008000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_floatorvar_in_geopt2093 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_geopt2095 = new BitSet(new long[]{0x0000002008000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_floatorvar_in_geopt2099 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_geopt2101 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_USER_in_user2129 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_user2131 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010020L});
    public static final BitSet FOLLOW_stringorvar_in_user2135 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_user2137 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_intorvar2158 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_intorvar2162 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_floatorvar2170 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_floatorvar2174 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_floatorvar2178 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_intstringorvar2186 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_intstringorvar2190 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_intstringorvar2194 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_stringorvar2202 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_var_in_stringorvar2206 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VARID_in_var2214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_property_in_prop2223 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_KEYPROP_in_prop2227 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_property2242 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_DOT_in_property2245 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_ID_in_property2249 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_PROP_in_property2269 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_property2271 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_property2273 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_property2275 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_kind2297 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_DOT_in_kind2300 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_ID_in_kind2304 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_KIND_in_kind2324 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_kind2326 = new BitSet(new long[]{0x8000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_STRING_in_kind2328 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_kind2331 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_mul_in_expr2352 = new BitSet(new long[]{0x0802000000000002L});
    public static final BitSet FOLLOW_set_in_expr2355 = new BitSet(new long[]{0x10104C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_mul_in_expr2364 = new BitSet(new long[]{0x0802000000000002L});
    public static final BitSet FOLLOW_MINUS_in_expr2374 = new BitSet(new long[]{0x10104C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_mul_in_expr2376 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_expr2392 = new BitSet(new long[]{0x10104C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_mul_in_expr2394 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atom_in_mul2410 = new BitSet(new long[]{0x0000000000000202L,0x0000000000000008L});
    public static final BitSet FOLLOW_muloper_in_mul2413 = new BitSet(new long[]{0x10104C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_atom_in_mul2416 = new BitSet(new long[]{0x0000000000000202L,0x0000000000000008L});
    public static final BitSet FOLLOW_ASTERISK_in_muloper2430 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SLASH_in_muloper2442 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_valorvarobj_in_atom2458 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prop_in_atom2466 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAR_in_atom2476 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A2L});
    public static final BitSet FOLLOW_exprlist_in_atom2478 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_atom2480 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_atom2492 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_atom2494 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_atom2496 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_atom2512 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_LEFT_PAR_in_atom2514 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_expr_in_atom2518 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_COMMA_in_atom2521 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_expr_in_atom2525 = new BitSet(new long[]{0x8000000000002000L});
    public static final BitSet FOLLOW_RIGHT_PAR_in_atom2529 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_exprlist2552 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_COMMA_in_exprlist2555 = new BitSet(new long[]{0x18124C244C018000L,0x00000000000121A0L});
    public static final BitSet FOLLOW_expr_in_exprlist2557 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_gql_select_in_exprlist2576 = new BitSet(new long[]{0x0000000000000002L});

}